var VortexEase = (function(VortexEase) {
    var Ease = {
        stageWidth: 1280,
        stageHeight: 720,
        FADE_IN_SPEED: 0.05,
        FADE_OUT_SPEED: 0.1,
    };
    Ease['wh'] = function(obj) {
        Ease['stageWidth'] = obj.width;
        Ease['stageHeight'] = obj.height;
    }
    /*音频的淡入*/
    Ease["audioFadeIn"] = function(obj, tw, duration) {
        obj.volume = 0;
        tw.call(function() {
            if (obj.isStopped) {
                if (typeof cb == 'function') {
                    cb();
                };
                egret.Tween.removeTweens(obj); //清除定时器
                return;
            };
            if (obj.volume > (1 - Ease.FADE_IN_SPEED)) {
                obj.volume = 1;
                egret.Tween.removeTweens(obj); //清除定时器
            } else {
                obj.volume += Ease.FADE_IN_SPEED;
            }
        });
        tw.wait(duration * Ease.FADE_IN_SPEED);
    };
    /*音频的淡出*/
    Ease["audioFadeOut"] = function(obj, tw, duration, cb) {
        tw.call(function() {
            if (obj.isStopped) {
                if (typeof cb == 'function') {
                    cb();
                };
                egret.Tween.removeTweens(obj); //清除定时器
                return;
            };
            if (obj.volume <= Ease.FADE_OUT_SPEED) {
                obj.volume = 0;
                if (typeof cb == 'function') {
                    cb();
                };
                egret.Tween.removeTweens(obj); //清除定时器
            } else {
                obj.volume -= Ease.FADE_OUT_SPEED;
            }
        });
        tw.wait(duration * Ease.FADE_OUT_SPEED);
    };
    //可进入下页的角标
    Ease["nextIcon"] = function(obj, tw, duration) {
        var d = duration * 0.5;
        tw.to({
            y: obj.y - 10,
        }, d);
        tw.to({
            y: obj.y,
        }, d);
    };
    Ease["typewriter"] = function(obj, tw, duration) {
        if (!obj.textFlow) return;
        var data = obj.textFlow;
        var out = [];
        var m = isVertical ? 3 : 1;
        var tl = new egret.TextField();
        for (var i in data) {
            var line = data[i];
            for (var j in line.text) {
                tl.fontFamily = obj.fontFamily;
                tl.size = obj.size;
                tl.text = line.text[j];
                out.push({
                    text: line.text[j],
                    style: line.style,
                    bytesW: tl.textWidth
                });
            }
        }
        delete(tl);
        obj.textFlow = [];
        // var gap = duration / out.length;
        // gap < 1 ? gap = 1 : 0;
        // gap > 20 ? gap = 20 : 0;
        var gap = duration > 1000 ? duration * 0.05 : duration * 0.03;
        tw.wait(gap);
        if (obj.direction != "Vertical") {
            var textW = 0; //当前文本宽度
            var cl = 0; //当前行数
            //开启单行模式
            var lineNum = isVertical ? 4 : 2;
            for (var i in out) {
                if (obj.name === "messageText") { //对话框分段执行打字机
                    textW += out[i].bytesW;
                    if (textW >= obj.width || out[i].text == "\n") {
                        cl++;
                        textW = out[i].bytesW;
                    };
                    if (cl === lineNum) {
                        tw.wait(1500);
                        cl = 0;
                        lineNum = 1;
                    }
                };
                tw.call(function(params) {
                    obj.appendElement(params);
                    obj.scrollV = obj.maxScrollV - m ? obj.maxScrollV - m : 1;
                }, obj, [out[i]]);
                tw.wait(gap, true);
            }
        } else {
            //文本框纵向打字机效果
            var line = 1;
            var h = 0;
            var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
            var rg = /\s/;
            var re = /\n/;
            var o = [];
            var x = 0;
            var line2 = 1;
            for (var i in out) {
                if (i == 0) {
                    var s = new egret.Sprite();
                    obj.addChild(s);
                }
                var t = new egret.TextField();
                t.fontFamily = obj.fontFamily;
                t.appendElement(out[i]);
                if (!reg.test(out[i].text)) {
                    if (rg.test(out[i].text)) {
                        t.height = 8;
                    }
                }
                if (re.test(out[i].text)) {
                    line = line + 1;
                    x = x + s.width;
                    h = 0;
                    out[i].style = {
                        'size': s.width
                    };
                    t.height = 0;
                }
                t.visible = false;
                if ((h + t.height) > obj.height) {
                    line++;
                    x = x + s.width;
                    h = t.height;
                } else {
                    h = h + t.height;
                }
                if (line2 < line) {
                    var s = new egret.Sprite();
                    obj.addChild(s);
                    line2 = line;
                }
                t.y = h ? (h - t.height) : h;
                var a = [t, s];
                o.push(a);
                s.addChild(t);
                if (out[i].style) {
                    s.width = out[i].style.size > s.width ? out[i].style.size : s.width;
                }
                if (line == 1) {
                    s.x = obj.width - s.width;
                } else {
                    s.x = obj.width - s.width - x - (line - 1) * obj.lineSpacing * 2;
                }
                tw.call(function(params) {
                    o[params][0].x = (o[params][1].width - o[params][0].width) / 2;
                    o[params][0].visible = true;
                    if (obj.textAlign == 'center') {
                        o[params][1].y = (obj.height - o[params][1].height) / 2;
                    } else if (obj.textAlign == 'right') {
                        o[params][1].y = obj.height - o[params][1].height;
                    }
                }, obj, [i]);
                tw.wait(gap);
            }
        }
    };
    Ease["wait"] = function(obj, tw, duration, passive) {
        tw.wait(duration, passive);
        var alpha = obj.ps ? obj.ps[11] : 1;
        tw.to({
            alpha: alpha,
        });
    };
    Ease["to"] = function(obj, tw, props, duration, ease) {
        tw.to(props, duration, ease);
    };
    //控制图片显示隐藏的动画
    Ease["visible"] = function(obj, tw, duration, alpha) {
        tw.to({
            alpha: alpha,
            visible: false
        });
        tw.wait(duration);
        var a = obj.ps ? obj.ps[11] : 1;
        tw.to({
            alpha: a,
            visible: true
        });
    };
    //无动画
    Ease["noAnimate"] = function(obj, tw, duration) {
        // var alpha = obj.alpha;
        // obj.alpha = 0;
        // tw.to({
        //  alpha: alpha
        // }, duration);
        // obj.alpha = alpha;
        // tw.wait(duration);
    };
    Ease["fadeInLeft"] = function(obj, tw, duration) {
        var x = obj.x;
        obj.x = x - (obj.width * 0.5);
        tw.to({
            x: x
        }, duration);
    };
    Ease["fadeInRight"] = function(obj, tw, duration) {
        var x = obj.x;
        obj.x = x + (obj.width * 0.5);
        tw.to({
            x: x
        }, duration);
    };
    /**
     * 进入动画
     */
    //从左飞入
    Ease["fadeInLeftBig"] = function(obj, tw, duration) {
        tw.to({
            x: -obj.width
        });
        tw.to({
            x: obj.x
        }, duration);
    };
    //从右飞入
    Ease["fadeInRightBig"] = function(obj, tw, duration) {
        tw.to({
            x: Ease.stageWidth + obj.width,
        });
        tw.to({
            x: obj.x,
        }, duration);
    };
    //从上飞入
    Ease["fadeInDownBig"] = function(obj, tw, duration) {
        tw.to({
            y: -obj.height,
        });
        tw.to({
            y: obj.y,
        }, duration);
    };
    //从下飞入
    Ease["fadeInUpBig"] = function(obj, tw, duration) {
        tw.to({
            y: Ease.stageHeight + obj.height,
        });
        tw.to({
            y: obj.y
        }, duration);
    };
    //淡入
    Ease["fadeIn"] = function(obj, tw, duration) {
        tw.to({
            alpha: 0,
            // visible : false
        });
        var alpha = obj.ps ? obj.ps[11] : 1;
        tw.to({
            alpha: alpha,
            // visible : true
        }, duration);
    };
    //从小到大
    Ease["closer"] = function(obj, tw, duration) {
        var centrex = obj.x + (obj.width * 0.5);
        var centrey = obj.y + (obj.height * 0.5);
        var w = obj.width * 0.5;
        var h = obj.height * 0.5;
        tw.to({
            x: centrex - (w * 0.5),
            y: centrey - (h * 0.5),
            width: w,
            height: h
        });
        tw.to({
            x: obj.x,
            y: obj.y,
            width: obj.width,
            height: obj.height
        }, duration);
    };
    //从大到小
    Ease["pull"] = function(obj, tw, duration) {
        var centrex = obj.x + obj.width * 0.5;
        var centrey = obj.y + obj.height * 0.5;
        var w = obj.width * 1.5;
        var h = obj.height * 1.5;
        tw.to({
            x: centrex - (w * 0.5),
            y: centrey - (h * 0.5),
            width: w,
            height: h
        });
        tw.to({
            x: obj.x,
            y: obj.y,
            width: obj.width,
            height: obj.height
        }, duration);
    };
    //从上弹入
    Ease["bounceInDown"] = function(obj, tw, duration) {
        tw.to({
            y: -obj.height,
        });
        var d = duration * 0.8;
        tw.to({
            y: obj.y
        }, d);
        var y = obj.y;
        var dt = duration - d;
        var count = 2;
        for (var i = count; i > 0; i--) {
            y = y - (i * 20);
            tw.to({
                y: y
            }, dt / 2);
            y = obj.y;
            tw.to({
                y: y
            }, dt / 2);
        };
    };
    //从下弹入
    Ease["bounceInUp"] = function(obj, tw, duration) {
        tw.to({
            y: Ease.stageHeight + obj.height,
        });
        var d = duration * 0.8;
        tw.to({
            y: obj.y
        }, d);
        var y = obj.y;
        var dt = duration - d;
        var count = 2;
        for (var i = count; i > 0; i--) {
            y = y - (i * 20);
            tw.to({
                y: y
            }, dt / 2);
            y = obj.y;
            tw.to({
                y: y
            }, dt / 2);
        };
    };
    //从左弹入
    Ease["bounceInLeft"] = function(obj, tw, duration) {
        tw.to({
            x: -obj.width,
        });
        var d = duration * 0.8;
        tw.to({
            x: obj.x
        }, d);
        var x = obj.x;
        var dt = duration - d;
        var count = 2;
        for (var i = count; i > 0; i--) {
            x = x - (i * 20);
            tw.to({
                x: x
            }, dt / 2);
            x = obj.x;
            tw.to({
                x: x
            }, dt / 2);
        };
    };
    //从右弹入
    Ease["bounceInRight"] = function(obj, tw, duration) {
        tw.to({
            x: Ease.stageWidth + obj.width,
        });
        var d = duration * 0.8;
        tw.to({
            x: obj.x
        }, d);
        var x = obj.x;
        var dt = duration - d;
        var count = 2;
        for (var i = count; i > 0; i--) {
            x = x - (i * 20);
            tw.to({
                x: x
            }, dt / 2);
            x = obj.x;
            tw.to({
                x: x
            }, dt / 2);
        };
    };
    //弹性放大
    Ease["bounceIn"] = function(obj, tw, duration) {
        var w = obj.width;
        var h = obj.height;
        var x = obj.x;
        var y = obj.y;
        var centrex = obj.x + obj.width / 2;
        var centrey = obj.y + obj.height / 2;
        var count = 5;
        var d = duration / count;
        for (var i = 1; i <= count; i++) {
            if (i === count) {
                tw.to({
                    x: obj.x,
                    y: obj.y,
                    width: obj.width,
                    height: obj.height
                }, d);
            } else if (i % 2 == 0) {
                w = w * 0.8;
                h = h * 0.8;
                x = centrex - (w / 2);
                y = centrey - (h / 2);
                tw.to({
                    x: x,
                    y: y,
                    width: w,
                    height: h
                }, d);
            } else {
                w = w * 1.2;
                h = h * 1.2;
                x = centrex - (w / 2);
                y = centrey - (h / 2);
                tw.to({
                    x: x,
                    y: y,
                    width: w,
                    height: h
                }, d);
            };
        };
    };
    /**
     * 强调动画
     */
    //跳跃
    Ease["bounce"] = function(obj, tw, duration) {
        var y = obj.y;
        var count = 3;
        var d = duration / count;
        for (var i = count; i > 0; i--) {
            y = y - (i * 20);
            tw.to({
                y: y
            }, d - (d / 3));
            y = obj.y;
            tw.to({
                y: y
            }, d / 3);
        };
    };
    //闪烁
    Ease["flash"] = function(obj, tw, duration) {
        var alpha = obj.ps ? obj.ps[11] : 1;
        var count = 2;
        for (var i = 0; i < count; i++) {
            tw.to({
                alpha: 0
            }, duration / count / 2);
            tw.to({
                alpha: alpha
            }, duration / count / 2);
        };
    };
    //抖动
    Ease["shake"] = function(obj, tw, duration) {
        var x = obj.x;
        var count = 5;
        var d = duration / count;
        for (var i = 0; i < count; i++) {
            if (i === count - 1) {
                x = obj.x;
                tw.to({
                    x: x
                }, d);
            } else if (i % 2 == 1) {
                x = obj.x + 20;
                tw.to({
                    x: x
                }, d);
            } else {
                x = obj.x - 20;
                tw.to({
                    x: x
                }, d);
            };
        };
    };
    //震动
    Ease["tada"] = function(obj, tw, duration) {
        var d = duration / 6; //放大缩小动画时间
        var r = obj.rotation - 4;
        for (var i = 0; i < 5; i++) {
            if (i % 2 == 0) {
                r = obj.rotation - 4;
                tw.to({
                    rotation: r
                }, d);
            } else {
                r = obj.rotation + 4;
                tw.to({
                    rotation: r
                }, d);
            };
        };
        tw.to({
            rotation: obj.rotation
        }, d);
    };
    /**
     * 退出动画
     */
    //从左飞出
    Ease["fadeOutLeftBig"] = function(obj, tw, duration) {
        tw.to({
            x: -obj.width
        }, duration);
        tw.to({
            alpha: 0,
            visible: false
        });
    };
    //从右飞出
    Ease["fadeOutRightBig"] = function(obj, tw, duration) {
        tw.to({
            x: Ease.stageWidth + obj.width
        }, duration);
        tw.to({
            alpha: 0,
            visible: false
        });
    };
    //从上飞出
    Ease["fadeOutUpBig"] = function(obj, tw, duration) {
        tw.to({
            y: -obj.height
        }, duration);
        tw.to({
            alpha: 0,
            visible: false
        });
    };
    //从下飞出
    Ease["fadeOutDownBig"] = function(obj, tw, duration) {
        tw.to({
            y: Ease.stageHeight + obj.height
        }, duration);
        tw.to({
            alpha: 0,
            visible: false
        });
    };
    //淡出
    Ease["fadeOut"] = function(obj, tw, duration) {
        tw.to({
            alpha: 0,
            visible: false
        }, duration);
    };
    //弹性缩小
    Ease["bounceOut"] = function(obj, tw, duration) {
        var d = duration / 3;
        var centrex = obj.x + obj.width / 2;
        var centrey = obj.y + obj.height / 2;
        var w = obj.width * 0.9;
        var h = obj.height * 0.9;
        var x = centrex - (w * 0.5);
        var y = centrey - (h * 0.5);
        tw.to({
            x: x,
            y: y,
            width: w,
            height: h
        }, d);
        w = obj.width * 1.1;
        h = obj.height * 1.1;
        x = centrex - (w * 0.5);
        y = centrey - (h * 0.5);
        tw.to({
            x: x,
            y: y,
            width: w,
            height: h
        }, d);
        w = 0;
        h = 0;
        x = centrex;
        y = centrey;
        tw.to({
            x: x,
            y: y,
            width: w,
            height: h
        }, d);
        tw.to({
            alpha: 0,
            visible: false
        }, duration);
    };
    return Ease;
})(VortexEase);
////