var Effect = (function(_super) {
    __extends(Effect, _super);

    function Effect() {
        _super.call(this);
        this.type = null;
    }
    var d = __define,
        c = Effect,
        p = c.prototype;
    p.play = function(type, resid, params) {
        var texture = RES.getRes(resid);
        var config = RES.getRes(type + "_json");
        if (type == 'snow') {
            params = this.fixSonwParams(params);
        } else if (type == 'rain') {
            params = this.fixRainParams(params);
        } else if (type == 'flower') {
            params = this.fixFlowerParams(params);
        }
        if (!this.type || this.type != type || !this.system ) {
             __extends(config, params);
            this.type = type;
            this.stop();
            this.system = new particle.GravityParticleSystem(texture, config);
            this.addChild(this.system);
            this.system.start();
        } else {
            if (type == 'snow') {
                this.system.speed = params.speed;
            } else if (type == 'rain') {
                this.system.gravityY = params.gravityY;
            } else if (type == 'flower') {
                this.system.speed = params.gravityY;
            }
        }
    };
    p.stop = function() {
        if (this.system) {
            this.system.stop();
            this.removeChild(this.system);
            this.system = null;
        }
    };
    //修正params
    p.fixSonwParams = function(params) {
        switch (params.speed) {
            case '0':
                params.speed = 30;
                break;
            case '1':
                params.speed = 100;
                break;
            default:
                params.speed = 250;
                break;
        }
        return params;
    };
    //修正params
    p.fixRainParams = function(params) {
        switch (params.speed) {
            case '0':
                params.gravityY = 100;
                break;
            case '1':
                params.gravityY = 300;
                break;
            default:
                params.gravityY = 500;
                break;
        }
        return params;
    };
    //修正params
    p.fixFlowerParams = function(params) {
        switch (params.speed) {
            case '0':
                params.gravityY = 30;
                break;
            case '1':
                params.gravityY = 100;
                break;
            default:
                params.gravityY = 170;
                break;
        }
        return params;
    };
    return Effect;
}(egret.Sprite));
egret.registerClass(Effect, 'Effect');
////