var VortexGame;
(function(VortexGame) {
    var GameManager = (function(_super) {
        __extends(GameManager, _super);

        function GameManager() {
            _super.call(this);
            this.game = null;
            this.gameid = null;
            this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        }
        GameManager.LIBRARY = {}
        GameManager.regLibrary = function(gameid, src) {
            GameManager.LIBRARY[gameid] = src;
        }
        GameManager.GAME = {};
        GameManager.regGame = function(gameid, creater) {
            GameManager.GAME[gameid] = creater;
        }
        var d = __define,
            c = GameManager,
            p = c.prototype;
        p.onAddToStage = function(event) {
            this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
            this.addEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            this.graphics.beginFill(0x555555, 0);
            this.graphics.drawRect(0, 0, this.width, this.height);
            this.graphics.endFill();
            this.visible = false;
            var lib = RES.getRes("gamelib");
            for (var x in lib) {
                GameManager.regLibrary(x, lib[x]);
            }
        }
        p.onRemoveFromStage = function() {
            this.removeEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            this.removeChildren();
        }
        p.handleTap = function(event) {
            event.stopPropagation();
        }
        p.playGame = function(gameid, params) {
            var self = this;
            this.touchEnabled = true;
            this.gameid = gameid;
            this.visible = params.visible ? false : true;
            this.addEventListener("gameShow", this.gameShow, this);
            var createGame = function() {
                self.game = new GameManager.GAME[gameid](params);
                self.game.width = self.width, self.game.height = self.height;
                self.addChild(self.game);
            }
            if (GameManager.GAME[gameid]) {
                createGame();
                return;
            }
            if (GameManager.LIBRARY[gameid]) {
                if (_typeBox == 'box') 
                {
                    return;
                }
                $LAB.script(GameManager.LIBRARY[gameid]).wait(function() {
                    if (GameManager.GAME[gameid]) {
                        createGame();
                        return;
                    }
                    self.dispatchEventWith("game_over", true, null, false);
                });
                return;
            }
            this.dispatchEventWith("game_over", true, null, false);
        }
        p.gameShow = function(event) {
            this.visible = true;
        }
        p.clearGame = function() {
            this.visible = false;
            this.touchEnabled = false;
            if (this.game) {
                this.removeChild(this.game);
                this.game = null;
            }
        }
        return GameManager;
    }(egret.Sprite));
    VortexGame.GameManager = GameManager;
    egret.registerClass(VortexGame.GameManager, 'VortexGame.GameManager');
    ////
    var GameBase = (function(_super) {
        __extends(GameBase, _super);

        function GameBase() {
            _super.call(this);
            this.gameid = "";
            this.baseurl = "";
            this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        }
        var d = __define,
            c = GameBase,
            p = c.prototype;
        p.onAddToStage = function(event) {
            this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
            this.addEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.loadingView = new LoadingUI(this);
            this.loadingView.visible = false;
            this.stage.addChild(this.loadingView);
            RES.addEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
            RES.loadConfig(this.baseurl + "resource/default.res.json", this.baseurl + "resource/");
        };
        p.onRemoveFromStage = function() {
            this.removeEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.destroy();
        }
        p.onConfigComplete = function(event) {
            RES.removeEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
            RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
            RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, this.onResourceLoadError, this);
            RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
            RES.addEventListener(RES.ResourceEvent.ITEM_LOAD_ERROR, this.onItemLoadError, this);
            RES.loadGroup(this.resID("preload"));
            var loadedFlag = RES.isGroupLoaded(this.resID("preload"));
            //这个地方是为了解决loadingView快速的显示和隐藏导致的闪烁问题
            if (!loadedFlag) {
                RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
            } else {
                this.loadingView.visible = true;
            }
        };
        p.onResourceLoadComplete = function(event) {
            if (event.groupName == this.resID("preload")) {
                RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
                RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, this.onResourceLoadError, this);
                RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
                RES.removeEventListener(RES.ResourceEvent.ITEM_LOAD_ERROR, this.onItemLoadError, this);
                if (this.resourceId) {
                    var bu = Config.editor + "Api/Play/getEditAvatarById?id=" + this.resourceId;
                    var self = this;
                    var resa = [{
                        name: this.resourceId,
                        type: 'json',
                        url: bu
                    }];
                    this.gameResource(this.resourceId + "_json", resa, function() {
                        self.parseAvatarJson(self.resourceId);
                    }, this);
                } else {
                    this.stage.removeChild(this.loadingView);
                    this.create();
                }
            }
        };
        p.parseAvatarJson = function(resourceid) {
            var data = RES.getRes(resourceid);
            if (!(data && data["res"] == "true")) {
                return;
            }
            data = data["msg"];
            var resa = [];
            for (var key in data) {
                var d = data[key];
                for (var k in d) {
                    var rid = d[k];
                    resa.push({
                        name: rid,
                        type: "image",
                        url: rid
                    });
                }
            }
            var self = this;
            this.gameResource(this.resourceId + "_detail", resa, function() {
                self.stage.removeChild(self.loadingView);
                self.create();
            }, this);
        }
        p.gameResource = function(frmid, resa, callback, thisobj) {
            if (RES.isGroupLoaded(frmid)) {
                this.hideLoading();
                if (callback) callback.call(thisobj, frmid);
                return;
            }
            var self = this;
            var findGroup = function(name) {
                for (var i in self.resGroups) {
                    var g = self.resGroups[i];
                    if (frmid === g.name) return g;
                }
            }
            var g = findGroup(frmid);
            if (!g) {
                var cfg = {
                    name: frmid,
                    resources: resa,
                    groups: [{
                        name: frmid,
                        keys: ""
                    }]
                };
                var ks = [];
                for (var i in resa) {
                    var r = resa[i];
                    ks.push(r.name);
                    if (!r.type || !r.url || r.url.indexOf("http", 0, 4) === 0) {
                        continue;
                    }
                    switch (r.type) {
                        case "image":
                            r.url = "resource.jpeg?resid=" + r.url;
                            break;
                        case "sound":
                            r.url = "resource.mp3?resid=" + r.url;
                            break;
                        default:
                            continue;
                            break;
                    }
                }
                cfg.groups[0].keys = ks.join(",");
                RES.parseConfig(cfg, this.resurl);
            }
            if (callback) {
                this.showLoading(resa.length);
                var onComp = function(e) {
                    if (e.groupName === frmid) {
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                        if (callback) callback.call(e, thisobj, frmid);
                        //这个地方是为了解决资源二次加载的时候loadingView闪烁的问题
                        if (e.groupName.indexOf("_detail")>-1) {this.hideLoading();} 
                    }
                }
                var onError = function(e) {
                    if (e.groupName === frmid) {
                        console.log("error", e);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                        if (callback) callback.call(e, thisobj, frmid);
                        this.hideLoading();
                    }
                }
                RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
                RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
            }
            RES.loadGroup(frmid);
        };
        p.onItemLoadError = function(event) {
            console.warn("Url:" + event.resItem.url + " has failed to load");
        };
        p.onResourceLoadError = function(event) {
            console.warn("Group:" + event.groupName + " has failed to load");
            this.onResourceLoadComplete(event);
        };
        p.onResourceProgress = function(event) {
            if (!this.loadingView.visible) {
                this.showLoading();
            };
            if (event.groupName == this.resID("preload")) {
                this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
            } else if (this.resourceId) {
                this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
            }
        };
        p.hideLoading = function() {
            this.loadingView.hide();
        };
        p.showLoading = function(l) {
            this.loadingView.show(l);
        };
        p.resID = function(key) {
            return this.gameid + "_" + key;
        }
        p.getRes = function(key) {
            return RES.getRes(this.resID(key));
        }
        p.create = function() {};
        p.destroy = function() {
            while (this.numChildren) {
                var dobj = this.removeChildAt(0);
                if (dobj.destroy) {
                    dobj.destroy();
                }
            }
        };
        return GameBase;
    }(egret.Sprite));
    VortexGame.GameBase = GameBase;
    egret.registerClass(VortexGame.GameBase, 'VortexGame.GameBase');
    ////
    var GameKid = (function(_super) {
        __extends(GameKid, _super);

        function GameKid() {
            _super.call(this);
            this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        }
        var d = __define,
            c = GameKid,
            p = c.prototype;
        p.onAddToStage = function(event) {
            this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
            this.addEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.create();
        }
        p.onRemoveFromStage = function() {
            this.removeEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            this.destroy();
        }
        p.create = function() {};
        p.destroy = function() {
            while (this.numChildren) {
                var dobj = this.removeChildAt(0);
                if (dobj.destroy) {
                    dobj.destroy();
                }
            }
        };
        return GameKid;
    }(egret.Sprite));
    VortexGame.GameKid = GameKid;
    egret.registerClass(VortexGame.GameKid, 'VortexGame.GameKid');
})(VortexGame || (VortexGame = {}));
////