(function() {
	const GAMEID = "avatar";
	var Main = (function(_super) {
		__extends(Main, _super);

		function Main(data) {
			_super.call(this);

			this.super = data.content;
			this.eaName = data.id;

			this.baseurl = "bin/game/" + GAMEID + "/";
			this.gameid = GAMEID;
			this.resurl = Config.material;
			// this.net = new Net(this);
			this.editAvatar = this.super.act.getChildByName(this.eaName);
			this.resourceId = data.resid;
			// this.originalData = data["originalData"];

			//每个选项的当前页面
			/*
			* eg:
			* this.pageArray["hair"] = "4"
			*/
			this.pageNumsArray = new Array();
			
		}
		var d = __define,
			c = Main,
			p = c.prototype;
		p.destroy = function() {
			 // this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			_super.prototype.destroy.call(this);
		};
		p.create = function()
		{
			this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);

			this.graphics.beginFill(0x000000, 0.9);
        	this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        	this.graphics.endFill();

			this.avatarScale = this.editAvatar.avatarScale;
			this.bodyScale = this.editAvatar.gameBodyScale;

			this.bodyContainer = new egret.Sprite();
			this.bodyContainer.width = this.editAvatar.width*this.bodyScale;
			this.bodyContainer.height = this.editAvatar.height*this.bodyScale;
			this.bodyContainer.x = 0;
			this.bodyContainer.y = (this.stage.stageHeight-this.bodyContainer.height)/2.0;
			this.bodyContainer.y = 50;
			this.bodyContainer.touchEnabled = false;
			this.addChild(this.bodyContainer);

			this.bodyItemArray = new Array(); 

			 for (var i = 0; i < this.editAvatar.numChildren; i++) 
			 {
			 	var editingItem = this.editAvatar.getChildAt(i);

			 	var name = editingItem.name;
				var item = this.addBitmapItem(name);
				item.touchEnabled = false;
				item.texture = editingItem.texture;
				item.x = editingItem.x*this.bodyScale;
				item.y = editingItem.y*this.bodyScale;
				item.width = editingItem.width*this.bodyScale;
				item.height = editingItem.height*this.bodyScale;
				item.resid = editingItem.resid;
				this.bodyContainer.addChild(item);
				this.bodyItemArray.push(item);

			 }

			// this.bodyArray = nameArray;
			this.optionArray = ["head","hair","coat","trousers","eyebrow","eye","nose","mouth"];
			this.curOptionName = this.optionArray[0];

			this.buildUI();

			var	data = RES.getRes(this.resourceId);
			data = data["msg"];
			this.avatarTotalData = data;
			this.testData();
			this.optionChange();
		};

		p.buildUI = function()
		{
			this.editContainer = new egret.Sprite();
			this.editContainer.x = this.getMaxX(this.bodyContainer);
			this.editContainer.y = 65;
			this.addChild(this.editContainer);

			//4*4
			this.content = new egret.Sprite();
			this.content.x = 0;
			this.content.y = 0;
			this.editContainer.addChild(this.content);
			this.buildContentUI();

			//1*8
			this.option = new egret.Sprite();
			this.option.x = this.content.x+ this.content.width;
			this.option.y = this.content.y;
			this.option.width = 200;
			this.option.height = this.content.height;
			this.editContainer.addChild(this.option);
			this.buildOptionUI(this.option.width,this.option.height);

			//完成按钮
			this.doneBtn = this.addBitmapItem("doneBtn");
			this.doneBtn.texture = RES.getRes("avatar_done");
			this.doneBtn.x = this.getMiddleX(this.content);
			this.doneBtn.y = this.getMaxY(this.content)+10;
			this.editContainer.addChild(this.doneBtn);


			//关闭按钮
			this.closeBtn = this.addBitmapItem("close");
			this.closeBtn.texture = RES.getRes("avatar_close");
			this.closeBtn.x = this.getMaxX(this.option)+5;
			this.closeBtn.y = 0;
			this.editContainer.addChild(this.closeBtn);
		}

		p.buildOptionUI = function(tw,th)
		{
			var optionBg = this.addBitmapItem("option_bg");	
			optionBg.touchEnabled = false;
			optionBg.texture = RES.getRes("avatar_option_bg");	
			// optionBg.width = tw;
			// optionBg.height = th;
			optionBg.x = tw - optionBg.width;
			optionBg.y = (th - optionBg.height)/2.0;

			this.option.addChild(optionBg);

			var startX = 25;
			var startY = 10+optionBg.y;
			var marginY = 5;
			var itemW = 142;
			var itemH = 53;

			var itemArray = this.optionArray;

			for (var i = 0; i < itemArray.length; i++) 
			{
				var name = itemArray[i];
				var x = startX;
				var y = (marginY+itemH)*i + startY;
				var item = this.addBitmapItem(name);
				item.x = x;
				item.y = y;
				item.mark = "option";
				var textureName = name+"_off";
				if (name == this.curOptionName)
				{
					textureName = name+"_on";
				}
		
				item.texture = RES.getRes(textureName);
				this.option.addChild(item);
			}
		}

		p.buildContentUI = function()
		{
			this.cellBgName = "cellBg";
			this.cellContentName = "contentItem";

			this.cellOn = RES.getRes("avatar_cell_on");
			this.cellOff = RES.getRes("avatar_cell_off");

			var contentBg = this.addBitmapItem("contentBg");
			contentBg.touchEnabled = false;
			contentBg.texture = RES.getRes("avatar_content_bg");	
			this.content.addChild(contentBg);

			var cellW = 104;
			this.cellWidth = cellW;
			var cellH = cellW;
			var cellOriginX = 65;
			var cellOriginY = 27;
			var cellMargin = 10;
			var total = 16;
			var row = 4;
			
			for (var i = 0; i < total; i++) 
			{
				var x = (parseInt(i%row)) * (cellW + cellMargin) + cellOriginX;
            	var y = (parseInt(i/row)) * (cellH + cellMargin) + cellOriginY;

            	var name = "content_"+i;
            	var cell = this.addCell(name,x,y,cellW,cellH);
            	cell.mark = "selectedCell"
            	this.content.addChild(cell);
			}		

			//左右翻页
			this.left = this.addBitmapItem("avatar_left");
			this.left.texture = RES.getRes("left_none");
			this.setAnchor(this.left,this.left.width/2.0,this.left.height/2.0);
			this.left.x = cellOriginX/2.0;
			this.left.y = contentBg.height/2.0;
			this.content.addChild(this.left);

			this.right = this.addBitmapItem("avatar_right");
			this.right.texture = RES.getRes("right_none");
			this.setAnchor(this.right,this.right.width/2.0,this.right.height/2.0);
			this.right.x = contentBg.width - cellOriginX/2.0;
			this.right.y = contentBg.height/2.0;
			this.content.addChild(this.right);
		}


		p.parsePartData = function(name,tid,dR)
		{
			this.resetContent();
			var d = dR?dR:this.avatarTotalData[name];
			var count = d.length>16?16:d.length;
		    for (var i = 0; i < count; i++) 
		    {
                // var arr = d[i];
                // var resid = arr[0];
                var resid = d[i];
                var name = "content_"+i;
                var cItem = this.content.getChildByName(name);
                cItem.touchEnabled = true;
                cItem.resid = resid;
                var vItem = cItem.getChildByName(this.cellContentName);
                var bgItem = cItem.getChildByName(this.cellBgName);
                vItem.texture = RES.getRes(resid);
                this.cellImgPosition(vItem,RES.getRes(resid));
                if (tid&&resid == tid) 
                {
                	bgItem.texture = this.cellOn;
                	this.preCitem = cItem;
                }
            }
		}

		p.cellImgPosition = function(item,texture)
		{
			var imgW = texture.textureWidth;
			var imgH = texture.textureHeight;
			var scale = imgW/imgH;
			var cw = this.cellWidth-20;
			var ch = cw;

			var nw = cw;
			var nh = nw/scale;
			var nx = 0;
			var ny = 0;

			if (imgW<=cw && imgH <= ch) 
			{
				nw = imgW;
				nh = imgH;
		
			}else if (nh > ch)
			{
				nh = ch;
				nw = nh*scale;
			}

			nx = (this.cellWidth - nw)/2.0;
			ny = (this.cellWidth - nh)/2.0;
			item.x = nx;
			item.y = ny;
			item.width = nw;
			item.height = nh;


		}

		p.resetContent = function()
		{
			for (var i = 0; i < 16; i++) {
				var name = "content_"+i;
                var cItem = this.content.getChildByName(name);
                cItem.touchEnabled = false;
                cItem.resid = null;
                var vItem = cItem.getChildByName(this.cellContentName);
                var bgItem = cItem.getChildByName(this.cellBgName);
                vItem.texture = null;
                vItem.touchEnabled = false;
                bgItem.touchEnabled = false;
                bgItem.texture = this.cellOff;
			}
		}

		p.loadPartSource = function(name,dataArray)
		{
			for (var i = 0; i < dataArray.length; i++) {
				var cData = dataArray[i];
				var resid = cData[0];
				if (this.readTextureData(resid))
				{
					return;
				}
			}
		}

		p.readItemDataByName = function(name,resid)
		{	
			var arr = this.getXY(resid);
			return arr?arr:null;
		}

		p.addTextureData = function(key,value)
		{
			if (!this.textureDict) 
			{	
				this.textureDict = new Array();
			}
			this.textureDict[key] = value; 
		}

		p.readTextureData = function(key)
		{
			if (!this.textureDict) 
			{	
				this.textureDict = new Array();
			}

			return this.textureDict[key];
		}

		p.clearOptionButItem = function(tItem)
		{
			var optionArr = this.optionArray;

			for (var i = 0; i < optionArr.length; i++) 
			{
				var name = optionArr[i];
				var item = this.option.getChildByName(name);
				var textureName = name+"_off";
				item.texture = RES.getRes(textureName);
				this.option.addChild(item);
			}

			var textureName = tItem.name+"_on";
			tItem.texture = RES.getRes(textureName);
			this.curOptionName = tItem.name;
		}

    	p.addBitmapItem = function(name) {
        	var item = new egret.Bitmap();
        	item.touchEnabled = true;
        	item.name = name;
        	return item;
    	};

    	p.addCell = function(name,x,y,w,h)
    	{
    		var cell = new egret.Sprite();
    		cell.name = name;
    		cell.x = x;
    		cell.y = y;
    		cell.width = w;
    		cell.height = h;

    		var bgItem = this.addBitmapItem(this.cellBgName);
    		bgItem.x = 0;
    		bgItem.y = 0;
    		bgItem.width = w;
    		bgItem.height = h;
    		bgItem.touchEnabled = false;
    		bgItem.texture = this.cellOff;

    		//contentItem
    		var cItem = this.addBitmapItem(this.cellContentName);
    		cItem.x = 10;
    		cItem.y = 10;
    		cItem.width = w-20;
    		cItem.height = h-20;
    		cItem.touchEnabled = false;
    		// cItem.fillMode = egret.BitmapFillMode.CLIP;
    		cell.addChild(bgItem);
    		cell.addChild(cItem);
    		return cell;
    	};

    	p.setAnchor = function (item,ax,ay)
    	{
    		 item.anchorOffsetX = ax;
    		 item.anchorOffsetY = ay;
    	}

    	p.getMaxY = function(item)
    	{
    		return item.y+item.height;
    	}

    	p.getMaxX = function(item)
    	{

    		return item.x+item.width;
    	};

    	p.getMiddleX = function(item)
    	{
    		return item.x+item.width/2.0;
    	}

    	p.getMiddleY = function(item)
    	{
    		return item.y+item.height/2.0;
    	} 

    	p.handleTap = function(event)
		{
			var name = event.target.name;
			if (name == this.closeBtn.name) 
			{
				this.dispatchEventWith("game_over", true, null, false);

			}else if (name == this.doneBtn.name)
			{
				this.dispatchEventWith("game_over", true, {
					cmds: [
                            ['avatarEdit',
                            this.editAvatar,//立绘中被编辑的Avatar对象
                            this.bodyContainer //编辑完成的精灵图对象
                            ]
                        ]   
                }, false);
			}else if (event.target.mark)
			{
				var mark = event.target.mark;
				if (mark == "option") 
				{
					this.clearOptionButItem(event.target);
					this.optionChange();
				
				}else if (mark == "selectedCell")
				{
					if (this.preCitem) 
					{
						var preBgItem = this.preCitem.getChildByName(this.cellBgName);
                		preBgItem.texture = this.cellOff;
					}

					var cItem = event.target;
                	var bgItem = cItem.getChildByName(this.cellBgName);
                	bgItem.texture = this.cellOn;

					var resid = cItem.resid;
					var oName = this.curOptionName;
					var arr = this.readItemDataByName(oName,resid);
					if (!arr) 
					{
						return;
					}
					var item = this.bodyContainer.getChildByName(oName);
					item.texture = RES.getRes(resid);
					this.setItemRect(item,arr);
					item.resid = resid;
					this.preCitem = cItem;

				}
			}else if (name == this.left.name)
			{
				this.toLeft();

			}else if (name == this.right.name)
			{
				this.toRight();
			}
		};

		p.setItemRect = function(item,arr)
		{	
			var tw = item.texture.textureWidth;
			var th = item.texture.textureHeight;
			var scale = this.avatarScale*this.bodyScale;

			item.x = arr[1]*scale;
			item.y = arr[2]*scale;
			item.width = tw*scale;
			item.height = th*scale;
		}

    	p.optionChange = function()
    	{
    		var name = this.curOptionName;
    		var cPage = this.pageNumsArray[name]?this.pageNumsArray[name]:0;
    		this.currentPage = cPage;
    		this.pageChange();
    	}

		p.toLeft = function()
		{
			this.currentPage--;
			this.pageChange();
		}

		p.toRight = function()
		{
			this.currentPage++;
			this.pageChange();
		}

		p.pageChange = function()
		{
			this.pageNumsArray[this.curOptionName] = this.currentPage;
			this.resetContent();
			var name = this.curOptionName;
			var cData = this.avatarTotalData[name];
			var start = this.currentPage*16;
			if (!cData) 
			{
				return;
			}

			var pData = cData.slice(start);

			var item = this.bodyContainer.getChildByName(name);
	
			this.parsePartData(name,item?item.resid:null,pData);

			var ltName = this.currentPage<1?"left_none":"left_more";
    		this.leftTextureChagedByName(ltName);

    		var maxPage = Math.ceil(cData.length/16);
    		var rtName = "right_more";
    		if(this.currentPage == maxPage-1 || maxPage < 2)
    		{
    			rtName = "right_none";
    		}

    		this.rightTextureChagedByName(rtName);
		}

		p.leftTextureChagedByName = function(name)
		{	
			this.left.texture = RES.getRes(name);
			this.left.touchEnabled = name.indexOf('more')>=0?true:false;
		} 
		p.rightTextureChagedByName = function(name)
		{	
			this.right.texture = RES.getRes(name);
			this.right.touchEnabled = name.indexOf('more')>=0?true:false;
		} 

		p.getXY = function(id)
        {
            // var man = RES.getRes("mod_2")["msg"];
            // var woman = RES.getRes("mod_3")["msg"];
            var man = (RES.getRes("mod_2")&&RES.getRes("mod_2")["res"] == "true")?RES.getRes("mod_2")["msg"]:null;
            var woman = (RES.getRes("mod_3")&&RES.getRes("mod_3")["res"] == "true")?RES.getRes("mod_3")["msg"]:null;
            var pArr = this.getPsotion(id,man);
            if (!pArr) 
            {
                pArr = this.getPsotion(id,woman);
            }

            return pArr?pArr:["","0","0"];
        }

        p.getPsotion = function(id,data)
        {
            for(var key in data)
            {
                var d = data[key];
                if (key == "mod") 
                {
                    if (d[0] == id) 
                    {
                        return [key,d[2],d[3]];
                    }
                }

                for (var i = 0; i < d.length; i++) {
                   var arr = d[i];
                   if (arr[0] == id) 
                    {
                        return [key,arr[2],arr[3]];
                    }
                }
            } 
            return null;
        }

		p.testData = function()
		{
			// var count = 6;

			// for (var i = 0; i < this.optionArray.length; i++) {
			// 	var name = this.optionArray[i];
			// 	var arr = this.avatarTotalData[name];
				
			// 	if (arr.length) 
			// 	{
			// 		var nArr = new Array();
			// 		for (var index = 0; index < count; index++) 
			// 		{
			// 			nArr = nArr.concat(arr);
			// 		}
			// 		this.avatarTotalData[name] = nArr;
			// 	}
				
			// }

		}

		return Main;
	}(VortexGame.GameBase));
	VortexGame.GameManager.regGame(GAMEID, Main);
})();

////