(function() {
	const GAMEID = "des";
	var Main = (function(_super) {
		__extends(Main, _super);

		function Main() {
			_super.call(this);
			this.baseurl = "bin/game/" + GAMEID + "/";
			this.gameid = GAMEID;
			this.exp = new vortex.exp();
		}
		var d = __define,
			c = Main,
			p = c.prototype;
		p.processProp = Vortex.processProp;
		p.destroy = function() {
			_super.prototype.destroy.call(this);
		};
		p.create = function() {
			this._res_ui = this.getRes("ui_json");
			this.panelGame = new PanelGame();
			this.addChild(this.panelGame);
			this.processProp(this._res_ui.data ? this._res_ui.data : {});
			if (this.width > this.height) {
				this.processProp(this._res_ui.dataheng ? this._res_ui.dataheng : {});
			} else {
				this.processProp(this._res_ui.datashu ? this._res_ui.datashu : {});
			}
			this.panelGame.init();
			this.panelGame.start();
		}
		return Main;
	}(VortexGame.GameBase));
	VortexGame.GameManager.regGame(GAMEID, Main);
	var PanelGame = (function(_super) {
		__extends(PanelGame, _super);

		function PanelGame() {
			_super.call(this);
			this.data = {
				types: [0xFF0000, 0x00FF00, 0x0000FF, 0xFFFF00] //, 0xFF00FF, 0x00FFFF, 0xFFFFFF, 0x000000]
			};
			this.game = {};
			this.num_row = 10;
			this.num_col = 15;
			this.rows = [];
			for (var i = 0; i < this.num_row; i++) {
				this.rows.push([]);
			}
			this.game.data = [];
			for (var i = 0; i < this.num_row; i++) {
				this.game.data.push([]);
				for (var j = 0; j < this.num_col; j++) {
					this.game.data[i][j] = this.data.types[Math.floor(this.data.types.length * Math.random())];
				}
			}
			this.game.dropDir = "bottom;left";
			this.game.blockSize = 2;
		}
		var d = __define,
			c = PanelGame,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
		}
		p.init = function() {
			this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			this.mask = new egret.Rectangle(0, 0, this.width, this.height);
			this.touchEnabled = true;
			this.graphics.beginFill(0x333333);
			this.graphics.drawRect(0, 0, this.width, this.height);
			this.graphics.endFill();
			this.block_width = this.width / this.num_col;
			this.line_height = this.height / this.num_row;
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var block = new egret.TextField();
					block.background = true;
					block.textColor = 0x0;
					block.width = this.block_width, block.height = this.line_height;
					this.rows[i][j] = {
						block: block,
						type: this.game.data[i][j],
						elim: 0,
					};
					this.addChild(block);
				}
			}
		}
		p.handleTap = function(evt) {
			var cx = Math.floor(evt.localX / this.block_width);
			var cy = Math.floor(evt.localY / this.line_height);
			var cell = this.getCell(cy, cx);
			if (cell && cell.block.visible) {
				this.eliminate(cx, cy);
			}
		}
		p.start = function() {
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					egret.Tween.removeTweens(data.block);
					data.type = this.game.data[i][j];
					data.elim = 0;
					data.x = j;
					data.y = i;
					var block = data.block;
					block.alpha = 1.0;
					block.x = j * this.block_width;
					block.y = i * this.line_height;
					this.showCell(data);
				}
			}
			this.canMove = false;
		}
		p.showCell = function(data) {
			data.block.alpha = 1.0;
			data.block.backgroundColor = data.type;
		}
		p.getCell = function(i, j) {
			if (i < 0 || i >= this.num_row) {
				return null;
			}
			if (j < 0 || j >= this.num_col) {
				return null;
			}
			return this.rows[i][j];
		}
		p.checkDead = function() {
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var c = this.getCell(i, j);
					if (c && c.block.visible) {
						var ovr = [];
						this.checkOne(j, i, ovr);
						if (ovr.length >= this.game.blockSize) {
							console.log("这里还能消",j, i);
							return false;
						}
					}
				}
			}
			console.log("dead");
			return true;
		}
		p.checkOne = function(cx, cy, ovr) {
			var self = this;
			var nxt = [];
			var check = function(cx, cy) {
				var cell = self.getCell(cy, cx);
				ovr.push(cell);
				var c;
				c = self.getCell(cy - 1, cx);
				if (c && c.block.visible && c.type == cell.type) {
					nxt.push(c);
				}
				c = self.getCell(cy + 1, cx);
				if (c && c.block.visible && c.type == cell.type) {
					nxt.push(c);
				}
				c = self.getCell(cy, cx + 1);
				if (c && c.block.visible && c.type == cell.type) {
					nxt.push(c);
				}
				c = self.getCell(cy, cx - 1);
				if (c && c.block.visible && c.type == cell.type) {
					nxt.push(c);
				}
			}
			nxt.push(self.getCell(cy, cx));
			while (nxt.length > 0) {
				var c = nxt.pop();
				if (ovr.indexOf(c) < 0) {
					check(c.x, c.y);
				}
			}
		}
		p.eliminate = function(cx, cy) {
			var self = this;
			var ovr = [];
			this.checkOne(cx, cy, ovr);
			if (ovr.length >= this.game.blockSize) {
				for (var x in ovr) {
					ovr[x].elim = 100;
				}
			} else {
				this.canMove = true;
				return false;
			}
			var tw;
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					var block = data.block;
					if (data.elim >= 3) {
						tw = egret.Tween.get(block);
						tw.to({
							alpha: 0.0
						}, 300);
						tw.set({
							visible: false
						});
					}
				}
			}
			if (tw) {
				tw.wait(20);
				tw.call(this.drop, this);
				return true;
			} else {
				this.canMove = true;
			}
			return false;
		}
		p.dropOnce = function(from, to, gap, another, xxx) {
			//目前没支持向中间塌陷的算法.
			for (var i = from; i != to; i = i + gap) {
				for (var j = 0; j < another; j++) {
					var data = xxx ? this.getCell(i, j) : this.getCell(j, i);
					if (data.elim >= 3) {
						var next = null;
						for (var y = i + gap; y != to; y = y + gap) {
							var n = xxx ? this.getCell(y, j) : this.getCell(j, y);
							if (!n) break;
							if (n.elim >= 3) continue;
							next = n;
							break;
						}
						if (next) {
							data.x = next.x, data.y = next.y;
							this.rows[next.y][next.x] = data;
							next.x = xxx ? j : i, next.y = xxx ? i : j;
							this.rows[next.y][next.x] = next;
						}
					}
				}
			}
		}
		p.dropLineOnce = function(from, to, gap, another, xxx) {
			//目前没支持向中间塌陷的算法.
			for (var i = from; i != to; i = i + gap) {
				var drop = true;
				for (var j = 0; j < another; j++) {
					var data = xxx ? this.getCell(i, j) : this.getCell(j, i);
					if (data.elim < 3) {
						drop = false;
						break;
					}
				}
				if (drop) {
					//console.log("empty line",i);
					var movesome = false;
					for (var x = i; x != to; x = x + gap) {
						for (var y = 0; y < another; y++) {
							var data = xxx ? this.getCell(x, y) : this.getCell(y, x);
							var next = xxx ? this.getCell(x + gap, y) : this.getCell(y, x + gap);
							if (data && next && (data.block.visible || next.block.visible)) {
								movesome = true;
								var xx = data.x,
									yy = data.y;
								data.x = next.x, data.y = next.y;
								this.rows[next.y][next.x] = data;
								next.x = xx, next.y = yy;
								this.rows[next.y][next.x] = next;
							}
						}
					}
					if (movesome) {
						i = i - gap;
					}
				}
			}
		}
		p.printData = function() {
			var out = [];
			for (var i = 0; i < this.num_col; i++) {
				out.push([]);
				for (var j = 0; j < this.num_row; j++) {
					out[i][j] = this.rows[j][i].elim;
				}
			}
			console.log(out);
		}
		p.drop = function() {
			var self = this;
			var dropdir = this.game.dropDir.split(";");
			var d = dropdir[0];
			if (d == "bottom") {
				this.dropOnce(this.num_row - 1, -1, -1, this.num_col, true);
			}
			if (d == "up") {
				this.dropOnce(0, this.num_row, 1, this.num_col, true);
			}
			if (d == "left") {
				this.dropOnce(0, this.num_col, 1, this.num_row, false);
			}
			if (d == "right") {
				this.dropOnce(this.num_col - 1, -1, -1, this.num_row, false);
			}
			d = dropdir[1];
			if (d == "bottom") {
				this.dropLineOnce(this.num_row - 1, -1, -1, this.num_col, true);
			}
			if (d == "up") {
				this.dropLineOnce(0, this.num_row, 1, this.num_col, true);
			}
			if (d == "left") {
				this.dropLineOnce(0, this.num_col, 1, this.num_row, false);
			}
			if (d == "right") {
				this.dropLineOnce(this.num_col - 1, -1, -1, this.num_row, false);
			}
			var tw;
			for (var i = this.num_row - 1; i >= 0; i--) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					var y = data.y * this.line_height;
					var x = data.x * this.block_width;
					if (data.block.y != y || data.block.x != x) {
						tw = egret.Tween.get(data.block);
						tw.to({
							x: x,
							y: y
						}, 300, egret.Ease.backInOut);
					}
				}
			}
			if (tw) {
				tw.wait(20);
				tw.call(function() {
					self.checkDead();
					self.canMove = true;
				});
			} else {
				this.checkDead();
				this.canMove = true;
			}
		}
		return PanelGame;
	})(egret.Sprite);
})();



////