(function() {
    const GAMEID = "face";
    var Main = (function(_super) {
        __extends(Main, _super);

        function Main() {
            _super.call(this);
            this.exp = new vortex.exp();
            this.baseurl = "bin/game/face/";
            this.gameid = GAMEID;
            this.data = {
                gridSize: [2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7, 8, 8, 8, 8, 8, 9],
                levelDesp: ["无药可救", "重度脸盲", "中度脸盲", "轻度脸盲", "顿足捶胸", "手疾眼快", "火眼金睛"],
                despNeed: [21, 31, 41, 51, 56, 60],
                types: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14],
                maxTime: 3,
            }
            this.gridSpace = 10;
            this.game = {};
        }
        var d = __define,
            c = Main,
            p = c.prototype;
        p.processProp = Vortex.processProp;
        p.destroy = function() {
            this.timer.removeEventListener(egret.TimerEvent.TIMER, this.onTick, this);
            this.timer.removeEventListener(egret.TimerEvent.TIMER_COMPLETE, this.onGameOver, this);
            this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.onTap, this);
            this.pool = null;
            _super.prototype.destroy.call(this);
        };
        p.create = function() {
            //this.fitSize(360,360);
            this._res = this.getRes("sprites_json");
            this._res_ui = this.getRes("ui_json");
            var bg = new egret.Bitmap(this._res.getTexture("bg"));
            bg.fillMode = egret.BitmapFillMode.REPEAT;
            bg.width = this.width, bg.height = this.height;
            this.addChild(bg);
            ////
            this._lvDesLable = new egret.TextField();
            this._scoreLaber = new egret.TextField();
            this._timeLabel = new egret.TextField();
            this._gridContainer = new egret.Sprite();
            this.processProp(this._res_ui.data ? this._res_ui.data : {});
            if (this.width > this.height) {
                this.processProp(this._res_ui.dataheng ? this._res_ui.dataheng : {});
            } else {
                this.processProp(this._res_ui.datashu ? this._res_ui.datashu : {});
            }
            this._gridContainer.graphics.beginFill(0xffffff);
            this._gridContainer.graphics.drawRect(0, 0, this._gridContainer.width, this._gridContainer.height);
            this._gridContainer.graphics.endFill();
            ////
            this.addChild(this._lvDesLable);
            this.addChild(this._scoreLaber);
            this.addChild(this._timeLabel);
            this.addChild(this._gridContainer);
            this.curlv = 0;
            this.curtime = -1;
            this.onTick();
            this.buildLevel(this.curlv);
            this.timer = new egret.Timer(1000, this.data.maxTime);
            this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTap, this);
            this.timer.addEventListener(egret.TimerEvent.TIMER, this.onTick, this);
            this.timer.addEventListener(egret.TimerEvent.TIMER_COMPLETE, this.onGameOver, this);
            this.timer.start();
        }
        p.onTick = function() {
            this.curtime++;
            this._timeLabel.text = "剩余时间 : " + (this.data.maxTime - this.curtime);
        }
        p.onGameOver = function() {
            this.dispatchEventWith("game_over", true, {
                evt: "end",
                argvs: {
                    result: this.curlv
                }
            }, false);
        }
        p.onTap = function(e) {
            if (e.target.name == this.game.pos) {
                this.curlv++;
                this.buildLevel(this.curlv);
            }
        }
        p.buildLevel = function(lv) {
            var self = this;
            var genData = function(gridsize, out) { ////随机游戏数据
                var typelg = self.data.types.length;
                out.type = Math.floor(Math.random() * typelg + 1);
                out.diftype = Math.floor(Math.random() * typelg + 1);
                if (out.type == out.diftype)
                    out.diftype = out.type == 1 ? 2 : out.type - 1;
                out.pos = Math.floor(Math.random() * gridsize * gridsize);
            }
            var getTitle = function(lv, data) {
                var idx = 0;
                var out = data.levelDesp[idx];
                for (var i in data.despNeed) {
                    if (lv >= data.despNeed) {
                        idx++;
                        out = data.levelDesp[idx];
                    }
                }
                return out;
            }
            while (this._gridContainer.numChildren) {
                this.pool.push(this._gridContainer.removeChildAt(0));
            }
            var gridsize = this.data.gridSize[lv] ? this.data.gridSize[lv] : 9;
            var cellsize = (this._gridContainer.width - (gridsize + 1) * this.gridSpace) / gridsize;
            genData(gridsize, this.game);
            for (var i = 0; i < gridsize; i++) {
                for (var j = 0; j < gridsize; j++) {
                    var idx = gridsize * i + j;
                    var type = idx == this.game.pos ? this.game.diftype : this.game.type;
                    var img = this.createItem();
                    img.texture = this._res.getTexture(type.toString());
                    img.name = idx;
                    img.width = img.height = cellsize;
                    img.x = j * (cellsize + this.gridSpace) + this.gridSpace;
                    img.y = i * (cellsize + this.gridSpace) + this.gridSpace;
                    this._gridContainer.addChild(img);
                }
            }
            this._scoreLaber.text = "当前关卡 : " + this.curlv;
            this._lvDesLable.text = "当前称号 : " + getTitle(this.curlv, this.data);
        }
        p.createItem = function() {
            this.pool = this.pool ? this.pool : [];
            if (this.pool.length > 0) {
                return this.pool.shift();
            } else {
                var img = new egret.Bitmap();
                img.touchEnabled = true;
                return img;
            }
        }
        return Main;
    }(VortexGame.GameBase));
    VortexGame.GameManager.regGame(GAMEID, Main);
})();



////