//本来源代码的样子..
/**
 * Created by sunzg on 14-7-31.
 */
var Main = (function(_super) {
    __extends(Main, _super);

    function Main() {
        _super.call(this);
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.addToStage, this);
        //window["EgretRuntimeBridgeInit"]();
        ShareUtils.onEnterGame();
    }
    var d = __define,
        c = Main,
        p = c.prototype;
    p.addToStage = function(evt) {
        this.loadingView = new LoadingUI();
        this.stage.addChild(this.loadingView);
        RES.addEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.loadConfig("resource/default.res.json", "resource/");
    };
    p.onConfigComplete = function(event) {
        RES.removeEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
        RES.loadGroup("preload");
    };
    p.onResourceLoadComplete = function(event) {
        if (event.groupName == "preload") {
            RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
            RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
            this.stage.removeChild(this.loadingView);
            this.createGameScene();
        }
    };
    p.onResourceProgress = function(event) {
        if (event.groupName == "preload") {
            this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
        }
    };
    p.createGameScene = function() {
        console.log(RES.getRes("sprites_json"));
        this._res = RES.getRes("sprites_json");
        var bitmap = new egret.Bitmap();
        bitmap.texture = this._res.getTexture("bg");
        this.addChild(bitmap);
        this.initGame();
    };
    p.initGame = function() {
        this._gameView = new GameView();
        this._gameView._res = this._res;
        this._gameView.width = this.stage.stageWidth;
        this._gameView.height = this.stage.stageHeight;
        this._gameView.createGame(this._res);
        this.addChild(this._gameView);
    };
    return Main;
}(egret.DisplayObjectContainer));
egret.registerClass(Main, 'Main');
/**
 * Created by sunzg on 14-7-31.
 */
var ImgBtn = (function(_super) {
    __extends(ImgBtn, _super);

    function ImgBtn() {
        _super.call(this);
    }
    var d = __define,
        c = ImgBtn,
        p = c.prototype;
    p.createBtn = function(upData, downData, dispatcher) {
        this._downImg = new egret.Bitmap();
        this._upImg = new egret.Bitmap();
        this._downImg.texture = downData;
        this._upImg.texture = upData;
        this.touchEnabled = true;
        this._dispatcher = dispatcher;
        this.addChild(this._downImg);
        this.addChild(this._upImg);
        this.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.downHandler, this);
        this.addEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.upHandler, this);
        this.addEventListener(egret.TouchEvent.TOUCH_END, this.upHandler, this);
        //this.addEventListener(egret.TouchEvent.TOUCH_TAP,this.touchTapHandler,this);
    };
    p.downHandler = function(evt) {
        this._downImg.visible = true;
        this._upImg.visible = false;
    };
    p.upHandler = function(evt) {
        this._downImg.visible = false;
        this._upImg.visible = true;
    };
    p.touchTapHandler = function(evt) {
        this._dispatcher.dispatchEventWith("startGame");
    };
    return ImgBtn;
}(egret.Sprite));
egret.registerClass(ImgBtn, 'ImgBtn');
/**
 * Created by sunzg on 14-7-31.
 */
var Grid = (function(_super) {
    __extends(Grid, _super);

    function Grid() {
        _super.call(this);
        this._index = 0;
        this._type = 0;
        this._imgIco = new egret.Bitmap();
        this.touchEnabled = true;
        //this.addEventListener(egret.TouchEvent.TOUCH_TAP,this.touchTapHandler,this);
        this.addChild(this._imgIco);
    }
    var d = __define,
        c = Grid,
        p = c.prototype;
    p.touchTapHandler = function(evt) {
        this._dispatcher.dispatchEventWith("GridTouchTap", true);
    };
    p.reset = function(index, type, data, scale) {
        this._imgIco.texture = data;
        this._imgIco.scaleX = scale;
        this._imgIco.scaleY = scale;
        this._index = index;
        this._type = type;
    };
    return Grid;
}(egret.DisplayObjectContainer));
egret.registerClass(Grid, 'Grid');
/**
 * Created by sunzg on 14-7-31.
 */
var GameView = (function(_super) {
    __extends(GameView, _super);

    function GameView() {
        _super.call(this);
        this._gridLvArr = [2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7, 8, 8, 8, 8, 8, 9];
        this._gridTypeArr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
        this._scoreLvDes = ["无药可救", "重度脸盲", "中度脸盲", "轻度脸盲", "顿足捶胸", "手疾眼快", "火眼金睛"];
        this._scoreLv = [21, 31, 41, 51, 56, 60];
        this._score = 0;
        this._totalTime = 30 * 1000;
        this._runTime = 0;
        this._currentLv = 0;
        this._zxh = new egret.Bitmap();
        this.__title = "测测你有脸盲症吗！";
        this.__desc = "你以为你躲起来就找不到你了吗，没有用的！";
        this.__iconLink = "http://egret-game.b0.upaiyun.com/icons/10000007.jpg";
        this._space = 13.5;
        this._row = 3;
        this._line = 3;
        this._shareView = new egret.Sprite();
        this._shareLabel = new egret.gui.Label();
        this._shareTip = new egret.Bitmap();
        this._shareTipLabel = new egret.gui.Label();
        //this.addEventListener("startGame",this.startGame,this);
        //this.addEventListener("restartGame",this.restartGame,this);
        //this.addEventListener("GridTouchTap",this.gridTouchTapHandler,this);
    }
    var d = __define,
        c = GameView,
        p = c.prototype;
    p.createGame = function(res) {
        var logo = new Logo("Powered by Egret FrameWork", 20, 0x000000);
        logo.x = 110;
        logo.y = 635;
        this.addChild(logo);
        var _self = this;
        RES.getResByUrl("resource/assets/fx1.png", function(data) {
            _self._shareImgtDown = data;
        }, this);
        RES.getResByUrl("resource/assets/fx2.png", function(data) {
            _self._shareImgtUp = data;
        }, this);
        RES.getResByUrl("resource/assets/shareTip.png", function(data) {
            this._shareTip.texture = data;
        }, this);
        ShareUtils.setShareInfo(this.__title, this.__desc, this.__iconLink);
        this._res = res;
        this._startBtn = new ImgBtn();
        this._startBtn.x = 85;
        this._startBtn.y = 385;
        this._startBtn.createBtn(this._res.getTexture("start1"), this._res.getTexture("start2"), this);
        this._startBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.firstStartGame, this);
        this._zxh.texture = this._res.getTexture("zxh");
        this._restartBtn = new ImgBtn();
        this._restartBtn.createBtn(this._res.getTexture("restart1"), this._res.getTexture("restart2"), this);
        this._restartBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.restartGame, this);
        this._restartBtn.x = 85;
        this._restartBtn.y = 385;
        this._moreBtn = new ImgBtn();
        this._moreBtn.createBtn(this._res.getTexture("more1"), this._res.getTexture("more2"), this);
        this._moreBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.more, this);
        this._moreBtn.x = 85;
        this._moreBtn.y = 500;
        this._gameDesLable1 = new egret.gui.Label();
        this._gameDesLable1.text = "茫茫人海中";
        this._gameDesLable1.x = 175;
        this._gameDesLable1.y = 70;
        this._gameDesLable2 = new egret.gui.Label();
        this._gameDesLable2.text = "你的小伙伴在哪里？";
        this._gameDesLable2.x = 126;
        this._gameDesLable2.y = 120;
        this._lvDesLable = new egret.gui.Label();
        this._lvDesLable.text = "";
        this._lvDesLable.size = 30;
        this._lvDesLable.x = 20;
        this._lvDesLable.y = 320;
        this._scoreLaber = new egret.gui.Label();
        this._scoreLaber.text = "得分：" + this._score.toString();
        this._scoreLaber.x = 30;
        this._scoreLaber.y = 35;
        this._timeLabel = new egret.gui.Label();
        this._timeLabel.x = 220;
        this._timeLabel.y = 35;
        this._timeLabel.text = "60";
        this._gridContainer = new egret.Sprite();
        this._gridContainer.y = 140;
        this._gridContainer.x = 0;
        this._gridContainer.width = 480;
        this._gridContainer.height = 480;
        this._gridContainer.graphics.beginFill(0xffffff);
        this._gridContainer.graphics.drawRect(0, 0, this._gridContainer.width, this._gridContainer.height);
        this._gridContainer.graphics.endFill();
        this.initGameStartView();
        this.initGridPool();
    };
    p.initGameStartView = function() {
        this.addChild(this._gameDesLable1);
        this.addChild(this._gameDesLable2);
        this.addChild(this._startBtn);
        this.addChild(this._moreBtn);
        this._zxh.x = 195;
        this._zxh.y = 200;
        this.addChild(this._zxh);
    };
    p.initGridPool = function() {
        this._gridPool = [];
        for (var i = 0; i < 81; i++) {
            var grid = new Grid();
            this._gridPool.push(grid);
        }
    };
    p.firstStartGame = function(evt) {
        this.removeChild(this._gameDesLable1);
        this.removeChild(this._gameDesLable2);
        this.removeChild(this._startBtn);
        this.removeChild(this._zxh);
        this.removeChild(this._moreBtn);
        this.startGame();
    };
    p.startGame = function() {
        this.addChild(this._scoreLaber);
        this.addChild(this._timeLabel);
        this.addChild(this._gridContainer);
        this.createGrids(this.getGridLv(this._currentLv));
        egret.Ticker.getInstance().register(this.loop, this);
    };
    p.getGridLv = function(lv) {
        if (lv > this._gridLvArr.length - 1) return 9;
        return this._gridLvArr[lv];
    };
    p.createGrids = function(gridLv) {
        this.destroyGrids();
        this._row = gridLv;
        this._line = gridLv;
        this._size = (this.width - (gridLv + 1) * this._space) / gridLv;
        var difArr = this.getDifTypeAndPos(gridLv);
        for (var i = 0; i < this._row; i++) {
            for (var j = 0; j < this._line; j++) {
                var index = this._row * i + j + 1;
                if (index == difArr[2]) {
                    var grid = this.getGrid(index, difArr[1], j, i, true);
                } else {
                    var grid = this.getGrid(index, difArr[0], j, i);
                }
                this._gridContainer.addChild(grid);
                grid.addEventListener(egret.TouchEvent.TOUCH_TAP, this.gridTouchTapHandler, this);
            }
        }
    };
    p.destroyGrids = function() {
        while (this._gridContainer.numChildren) {
            this._gridPool.push(this._gridContainer.removeChildAt(0));
        }
    };
    p.gridTouchTapHandler = function(evt) {
        console.log(evt.target);
        if (evt.target._index == this._difPos) {
            this._currentLv++;
            this._score++;
            this._scoreLaber.text = "得分：" + this._score.toString();
            this.nextGirdLv();
        }
    };
    p.nextGirdLv = function() {
        this.createGrids(this.getGridLv(this._currentLv));
    };
    p.getDifTypeAndPos = function(lv) {
        var typelg = this._gridTypeArr.length;
        var type = Math.floor(Math.random() * typelg + 1);
        var diftype = Math.floor(Math.random() * typelg + 1);
        if (type == diftype) diftype = type == 1 ? 2 : type - 1;
        var pos = Math.floor(Math.random() * lv * lv + 1);
        this._difPos = pos;
        return [type, diftype, pos];
    };
    p.getGrid = function(index, type, posX, posY, b) {
        var grid = this._gridPool.shift();
        var dataName = type.toString();
        var data = this._res.getTexture(dataName);
        grid.width = this._size;
        grid.height = this._size;
        var scale = this._size / 142;
        //        if(b)scale=scale*1.2;
        grid.x = (posX + 1) * this._space + posX * this._size;
        grid.y = (posY + 1) * this._space + posY * this._size;
        grid._dispatcher = this;
        grid.reset(index, type, data, scale);
        return grid;
    };
    p.loop = function(spaceTime) {
        this._runTime = this._runTime + spaceTime;
        if (this._runTime > this._totalTime) {
            egret.Ticker.getInstance().unregister(this.loop, this);
            this.gameOver();
        }
        var tipTime = Math.floor((this._totalTime - this._runTime) / 1000);
        this._timeLabel.text = tipTime.toString();
    };
    p.gameOver = function() {
        this.getLvDesByScore(this._score);
        this.initGameOverView();
    };
    p.getLvDesByScore = function(score) {
        //        for(var i:number=0;i<this._scoreLv.length;i++){
        //            if(score<this._scoreLv[i]){
        //                this._lvDesLable.text=this._scoreLvDes[i];
        //                return;
        //            }
        //        }
        //        this._lvDesLable.text=this._scoreLvDes[6];
        this.__num = Math.floor(Math.random() * 7);
        this._lvDesLable.text = "我闯过了" + score + "关，被认定为" + this._scoreLvDes[this.__num];
    };
    p.initGameOverView = function() {
        this._shareGameBtn = new ImgBtn();
        this._shareGameBtn.createBtn(this._shareImgtUp, this._shareImgtDown, this);
        this._shareGameBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.shareGame, this);
        this._shareGameBtn.x = 85;
        this._shareGameBtn.y = 500;
        this.removeChild(this._timeLabel);
        this.removeChild(this._scoreLaber);
        this.removeChild(this._gridContainer);
        this._zxh.x = 195;
        this._zxh.y = 120;
        this.addChild(this._zxh);
        this.addChild(this._lvDesLable);
        this.addChild(this._restartBtn);
        this.addChild(this._shareGameBtn);
        this.__title = "测测你有脸盲症吗！";
        this.__desc = "我闯过了" + this._score + "关，被认定为" + this._scoreLvDes[this.__num] + "，不服来试试！";
        ShareUtils.setShareInfo(this.__title, this.__desc, this.__iconLink);
    };
    p.restartGame = function(evt) {
        if (this._shareView.parent) this.removeChild(this._shareView);
        this._runTime = 0;
        this._score = 0;
        this._currentLv = 0;
        this._scoreLaber.text = "得分：" + "0";
        this._timeLabel.text = "60";
        this.removeChild(this._lvDesLable);
        this.removeChild(this._zxh);
        this.removeChild(this._restartBtn);
        this.removeChild(this._shareGameBtn);
        this.startGame();
    };
    p.showShareView = function() {
        this._shareView.width = this.stage.stageWidth;
        this._shareView.height = this.stage.stageHeight;
        this._shareView.graphics.clear();
        this._shareView.graphics.beginFill(0x555555, 0.5);
        this._shareView.graphics.drawRect(0, 0, this._shareView.width, this._shareView.height);
        this._shareView.graphics.endFill();
        this._shareView.touchEnabled = true;
        this._shareTip.x = this._shareView.width - 150;
        this._shareTip.y = 0;
        this._shareView.addChild(this._shareTip);
        this._shareTipLabel.text = "分享到朋友圈";
        this._shareTipLabel.y = 60;
        this._shareTipLabel.x = 200;
        this._shareTipLabel.size = 25;
        this._shareView.addChild(this._shareTipLabel);
        this._shareView.addChild(this._lvDesLable);
        this.addChild(this._shareView);
        this.__title = "测测你有脸盲症吗！";
        this.__desc = "我闯过了" + this._score + "关，被认定为" + this._scoreLvDes[this.__num] + "，不服来试试！";
        ShareUtils.shareToWeChat();
        this._shareView.addEventListener(egret.TouchEvent.TOUCH_TAP, this.removeShareView, this);
    };
    p.shareGame = function(evt) {
        if (ShareUtils.isInWeChat()) {
            this.showShareView();
        } else {
            ShareUtils.shareToU9();
        }
    };
    p.removeShareView = function(event) {
        if (this._shareView.parent) this.removeChild(this._shareView);
        this.addChild(this._lvDesLable);
    };
    p.more = function() {
        ShareUtils.moreGame();
    };
    return GameView;
}(egret.DisplayObjectContainer));
egret.registerClass(GameView, 'GameView');
/**
 * Created by sunzg on 14-8-1.
 */
var Logo = (function(_super) {
    __extends(Logo, _super);

    function Logo(txt, size, color) {
        _super.call(this);
        var logo = new egret.gui.Label();
        logo.text = txt;
        logo.size = size;
        logo.textColor = color;
        this.addChild(logo);
    }
    var d = __define,
        c = Logo,
        p = c.prototype;
    return Logo;
}(egret.Sprite));
egret.registerClass(Logo, 'Logo');
/**
 * Copyright (c) 2014,Egret-Labs.org
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Egret-Labs.org nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EGRET-LABS.ORG AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL EGRET-LABS.ORG AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
var LoadingUI = (function(_super) {
    __extends(LoadingUI, _super);

    function LoadingUI() {
        _super.call(this);
        this.logoUrl = "resource/assets/loading_logo.png";
        this.bgUrl = "resource/assets/loading_bg.jpg";
        this.createView();
    }
    var d = __define,
        c = LoadingUI,
        p = c.prototype;
    p.createView = function() {
        this.w = 480;
        //        this.h = document.documentElement.clientHeight;
        if (egret.MainContext.instance.stage.scaleMode == egret.StageScaleMode.NO_BORDER && IsPC()) {
            this.h = document.documentElement.clientHeight * (480 / document.documentElement.clientWidth);
        } else {
            this.h = 800;
        }
        this.textField = new egret.TextField();
        this.textField.y = 500;
        this.textField.textColor = 0x333333;
        this.textField.size = 23;
        this.textField.width = this.w;
        this.textField.height = 100;
        this.textField.fontFamily = "Black";
        this.textField.textAlign = "center";
        this.textField_power = new egret.TextField();
        this.textField_power.y = this.h * 0.9;
        this.textField_power.textColor = 0x333333;
        this.textField_power.width = this.w;
        this.textField_power.height = 100;
        this.textField_power.size = 20;
        this.textField_power.text = "Powered by Egret Engine";
        this.textField_power.fontFamily = "Black";
        this.textField_power.textAlign = "center";
        var urlLoader = new egret.URLLoader();
        urlLoader.addEventListener(egret.Event.COMPLETE, this.onComplete, this);
        urlLoader.dataFormat = egret.URLLoaderDataFormat.TEXTURE;
        urlLoader.load(new egret.URLRequest(this.logoUrl));
        var urlLoader = new egret.URLLoader();
        urlLoader.addEventListener(egret.Event.COMPLETE, this.onComplete, this);
        urlLoader.dataFormat = egret.URLLoaderDataFormat.TEXTURE;
        urlLoader.load(new egret.URLRequest(this.bgUrl));
        this.bg = new egret.Bitmap();
        this.logo = new egret.Bitmap();
        this.uiContainer = new egret.DisplayObjectContainer();
        this.addChild(this.uiContainer);
        this.addChild(this.logo);
        this.addChildAt(this.bg, 0);
        this.addChild(this.textField);
        this.addChild(this.textField_power);
    };
    p.onComplete = function(e) {
        var urlLoader = e.target;
        var texture = urlLoader.data;
        if (urlLoader._request.url == this.bgUrl) {
            this.bg.texture = texture;
            this.bg.scaleX = this.w / 640;
            this.bg.scaleY = this.h / 960;
        } else if (urlLoader._request.url == this.logoUrl) {
            this.logo.texture = texture;
            this.logo.anchorOffsetX = this.logo.width * 0.5;
            this.logo.anchorOffsetY = this.logo.height * 0.5;
            this.logo.x = this.w / 2;
            this.logo.y = this.h / 2 - 60;
            this.logo.scaleX = this.logo.scaleY = this.h / 960;
            this.textField.y = this.logo.y + 100;
        }
    };
    p.setProgress = function(current, total) {
        var num = Math.floor((current / total) * 100);
        this.textField.text = "游戏加载中�??" + num + "%";
    };
    p.onLoadComplete = function(callback, thisObj) {
        //        callback.call(thisObj);
    };
    return LoadingUI;
}(egret.Sprite));
egret.registerClass(LoadingUI, 'LoadingUI');
/**
 * Created by lcj on 14-8-5.
 */
var ShareUtils = (function() {
    function ShareUtils() {}
    var d = __define,
        c = ShareUtils,
        p = c.prototype;
    ShareUtils.moreGame = function() {
        // window.open("http://edn.egret.com/cn/list/example/id/13", "_self");
    };
    ShareUtils.shareToWeChat = function() {
        //if (window.hasOwnProperty("WeixinApi")) {
        //    WeixinApi.ready(function (api:WeixinApi) {
        //        var info:WeixinShareInfo = new WeixinShareInfo();
        //        info.title = ShareUtils.shareTitle;
        //        info.desc = ShareUtils.shareDesc;
        //        info.link = window.location.href;
        //        info.imgUrl = ShareUtils.shareImgUrl;//"http://egret-game.b0.upaiyun.com/icons/10000005.jpg";
        //        api.shareToFriend(info);
        //        api.shareToTimeline(info);
        //    })
        //}
    };
    ShareUtils.shareToU9 = function() {
        var url = location.href;
        if (location.search == "") {
            url += "?channel=weixin";
        } else {
            url += "&channel=weixin";
        }
        url = encodeURIComponent(url);
        var a = "123";
        var msg = encodeURIComponent(ShareUtils.shareDesc);
        var uid = ShareUtils.getUid();
        var link = "u9time://share?" + "uid=" + uid + "&game_url=" + url + "&a=" + a + "&msg=" + msg;
        if (!uid) {
            link = "u9time://share?" + "&game_url=" + url + "&a=" + a + "&msg=" + msg;
        }
        location.href = link;
    };
    ShareUtils.setShareInfo = function(title, desc, imgUrl) {
        ShareUtils.shareTitle = title;
        ShareUtils.shareDesc = desc;
        ShareUtils.shareImgUrl = imgUrl;
        ShareUtils.shareToWeChat();
    };
    ShareUtils.isInWeChat = function() {
        if (!IsPC()) 
        {
            return;
        }
        var ua = window.navigator.userAgent;
        return ua.indexOf("MicroMessenger") != -1;
    };
    ShareUtils.isInU9 = function() {
        if (!IsPC()) 
        {
            return;
        }
        var ua = window.navigator.userAgent;
        return ua.indexOf("EgretRuntime") != -1 && ua.indexOf("yoyo") != -1;
    };
    ShareUtils.findLocationProperty = function(key) {
        if (this.hasOwnProperty("location")) {
            var search = location.search;
            if (search == "") {
                return null;
            }
            search = search.slice(1);
            var searchArr = search.split("&");
            var length = searchArr.length;
            for (var i = 0; i < length; i++) {
                var str = searchArr[i];
                var arr = str.split("=");
                if (arr[0] == key) {
                    return arr[1];
                }
            }
        } else if (false) {}
        return null;
    };
    ShareUtils.getUid = function() {
        return ShareUtils.findLocationProperty("uid");
    };
    ShareUtils.onEnterGame = function() {
        var appId = ShareUtils.findLocationProperty("app_id");
        var gameId = ShareUtils.findLocationProperty("game_id");
        var deviceId = ShareUtils.findLocationProperty("device_id");
        if (appId && gameId) {
            if (!deviceId) {
                deviceId = egret.localStorage.getItem("device_id");
                if (!deviceId) {
                    deviceId = Math.random();
                }
            }
            try {
                egret.localStorage.setItem("device_id", deviceId);
            } catch (error) {}
            var url = "http://statistics.egret-labs.org/api.php?app_id=" + appId + "&game_id=" + gameId + "&device_id=" + deviceId;
            var channel = ShareUtils.findLocationProperty("channel");
            if (channel && ShareUtils.isInWeChat()) {
                url += "&channel=" + channel;
            }
            if (url) {
                var urlLoader = new egret.URLLoader();
                urlLoader.load(new egret.URLRequest(url));
            }
        }
    };
    return ShareUtils;
}());
egret.registerClass(ShareUtils, 'ShareUtils');