(function() {
	const GAMEID = "hitblock";
	var Main = (function(_super) {
		__extends(Main, _super);

		function Main() {
			_super.call(this);
			this.baseurl = "bin/game/" + GAMEID + "/";
			this.gameid = GAMEID;
		}
		var d = __define,
			c = Main,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			_super.prototype.destroy.call(this);
		};
		p.create = function() {
			this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			this.graphics.beginFill(0x333333);
			this.graphics.drawRect(0, 0, this.width, this.height);
			this.graphics.endFill();
			this._panelGame = new PanelGame(this.width, this.height);
			this._panelGame.width = this.width, this._panelGame.height = this.height;
			this.addChild(this._panelGame);
			this._panelGame.visible = false;
			this._panelStart = new PanelStart();
			this.addChild(this._panelStart);
		}
		p.handleTap = function(evt) {
			if (evt.target.name == "startbtn") {
				this._panelStart.visible = false;
				this._panelGame.visible = true;
				this._panelGame.start();
			}
		}
		return Main;
	}(VortexGame.GameBase));
	VortexGame.GameManager.regGame(GAMEID, Main);
	var PanelStart = (function(_super) {
		__extends(PanelStart, _super);

		function PanelStart() {
			_super.call(this);
			this.init();
		}
		var d = __define,
			c = PanelStart,
			p = c.prototype;
		p.destroy = function() {
			this.removeChild(this._startBtn);
		}
		p.init = function() {
			this._startBtn = new egret.TextField();
			this._startBtn.name = "startbtn";
			this._startBtn.text = "开始";
			this._startBtn.size = 50;
			this._startBtn.x = 180;
			this._startBtn.y = 200;
			this.addChild(this._startBtn);
			this._startBtn.touchEnabled = true;
		};
		return PanelStart;
	})(egret.Sprite);
	var PanelGame = (function(_super) {
		__extends(PanelGame, _super);

		function PanelGame(width, height) {
			_super.call(this);
			this.init(width, height);
		}
		var d = __define,
			c = PanelGame,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			this.stop();
			this.timer.removeEventListener(egret.TimerEvent.TIMER, this.handleTimer, this);
			this.timer = null;
			var n=this.numChildren;
			for(var i=0;i<n;i++){
				var line=this.getChildAt(i);
				line.removeChildren();
			}
			this.removeChildren();
		}
		p.init = function(width, height) {
			this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			this.timer = new egret.Timer(20, 0);
			this.timer.addEventListener(egret.TimerEvent.TIMER, this.handleTimer, this);
			this.num_col = 4;
			this.space = Math.ceil(width / this.num_col / 20);
			this.block_width = Math.floor((width - (this.num_col + 1) * this.space) / this.num_col);
			this.line_height = this.block_width * 1.5;
			this.num_row = Math.ceil(height / this.line_height) + 2;
			this.speed = height / 30;
			for (var i = 0; i < this.num_row; i++) {
				var line = new egret.Sprite();
				for (var j = 0; j < this.num_col; j++) {
					var block = new egret.Shape();
					block.touchEnabled = true;
					line.addChild(block);
				}
				this.addChild(line);
			}
		}
		p.handleTap = function(evt) {
			evt.stopPropagation();
			if (evt.target.name == "black") {
				var block = evt.target;
				block.name="gray";
				block.graphics.beginFill(0x888888);
				block.graphics.drawRect(0, 0, this.block_width, this.line_height);
				block.graphics.endFill();

			} else {
				this.dispatchEventWith("game_over", true, {
					evt: "end",
					argvs: {
						result: this.level
					}
				}, false);
			}
		}
		p.stop = function() {
			this.timer.stop();
		}
		p.handleTimer = function(evt) {
			for (var i = 0; i < this.num_row; i++) {
				var line = this.getChildAt(i);
				line.y += this.speed;
			}
			var line = this.getChildAt(this.numChildren - 1);
			if (line.y >= this.height) {
				var have_black = false;
				for (var j = 0; j < this.num_row; j++) {
					var block = line.getChildAt(j);
					if (block.name == "black") {
						have_black = true;
					}
				}
				if (have_black) {
					this.dispatchEventWith("game_over", true, {
						evt: "end",
						argvs: {
							result: this.level
						}
					}, false);
					return;
				}
				var first_line = this.getChildAt(0);
				line.y = first_line.y - (this.line_height + this.space);
				this.freshLine(line);
				this.removeChild(line);
				this.addChildAt(line, 0);
				this.level++;
				this.speed+=0.1;
			}
		}
		p.freshLine = function(line) {
			var sed = Math.floor(Math.random() * this.num_col);
			for (var j = 0; j < this.num_col; j++) {
				var block = line.getChildAt(j);
				if (sed == j) {
					block.name = "black";
					block.graphics.beginFill(0x0);
				} else {
					block.name = "white";
					block.graphics.beginFill(0xFFFFFF);
				}
				block.graphics.drawRect(0, 0, this.block_width, this.line_height);
				block.graphics.endFill();
			}
		}
		p.start = function() {
			this.level=0;
			this.graphics.beginFill(0x333333, 1);
			this.graphics.drawRect(0, 0, this.width, this.height);
			this.graphics.endFill();
			for (var i = 0; i < this.num_row; i++) {
				var line = this.getChildAt(i);
				for (var j = 0; j < this.num_col; j++) {
					var block = line.getChildAt(j);
					block.x = this.space + j * (this.block_width + this.space);
				}
				line.y = -((this.num_row - i) * (this.line_height + this.space));
				this.freshLine(line);
			}
			this.timer.start();
		}
		return PanelGame;
	})(egret.Sprite);
})();



////