var GameLock;
(function(GameLock) {
    const GAMEID = "lock";
    var GamePasswordLock = (function(_super) {
        __extends(GamePasswordLock, _super);

        function GamePasswordLock(params) {
            _super.call(this);
            this.params = params;
            this.content = params.content;
        }
        var d = __define,
            c = GamePasswordLock,
            p = c.prototype;
        p.create = function(event) {
            this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            this.touchEnabled = true;
            this.graphics.beginFill(0x000000, 0.9);
            this.graphics.drawRect(0, 0, this.width, this.height);
            this.graphics.endFill();
            this.length = this.params["length"];
            var size = this.params["size"].split(";");
            //容器
            this.lock = new egret.Sprite();
            this.lock.width = parseInt(size[0]);
            this.lock.height = parseInt(size[1]);
            this.lock.name = this.params["layerId"];
            this.lock.anchorOffsetX = this.lock.width / 2;
            this.lock.anchorOffsetY = this.lock.height / 2;
            this.lock.x = this.width / 2;
            this.lock.y = this.height / 2;
            this.addChild(this.lock);
            //底图
            this.bg = new egret.Bitmap();
            this.bg.name = "lockBg";
            this.bg.texture = RES.getRes(this.params["pic_res"][0]);
            this.lock.addChild(this.bg);
            //确定
            this.btn = new egret.Bitmap();
            this.btn.name = "lockBtn";
            this.btn.texture = RES.getRes(this.params["pic_res"][3]);
            this.btn.anchorOffsetX = this.btn.width / 2;
            this.btn.anchorOffsetY = this.btn.height / 2;
            this.btn.x = this.lock.width / 2;
            this.btn.y = 380;
            this.btn.touchEnabled = true;
            this.lock.addChild(this.btn);
            //关闭
            this.close = new egret.Bitmap();
            this.close.name = "lockClose";
            this.close.texture = RES.getRes(this.params["pic_res"][4]);
            this.close.x = this.lock.width - 70 - this.length * 5;
            this.close.y = 17;
            this.close.touchEnabled = true;
            this.lock.addChild(this.close);
            //中间显示区域
            for (var i = 0; i < this.length; i++) {
                var pic = new egret.Bitmap();
                var up = new egret.Bitmap();
                var down = new egret.Bitmap();
                pic.name = "pic" + i;
                pic.texture = RES.getRes(this.params["all_pwd_res"][i]);
                pic.tag = "tag" + i;
                
                up.name = "up" + i;
                up.texture = RES.getRes(this.params["pic_res"][2]);
                
                down.name = "down" + i;
                down.texture = RES.getRes(this.params["pic_res"][1]);
                pic.y = isVertical ? 137 : 135;
                up.y = isVertical ? 80 : 90;
                down.y = isVertical ? 285 : 290;
                if (i == 0) {
                    pic.x = 25;
                    up.x = pic.x + (pic.width - up.width) / 2;
                    down.x = up.x;
                } else {
                    var name = 'pic' + (i - 1);
                    if(isVertical){
                        console.log(11);
                        pic.x = pic.width + this.lock.getChildByName(name).x + 20;
                    }else{
                        console.log(22);
                        pic.x = pic.width + this.lock.getChildByName(name).x + 22;
                    }
                    up.x = pic.x + (pic.width - up.width) / 2;
                    down.x = up.x;
                }
                pic.touchEnabled = true;
                up.touchEnabled = true;
                down.touchEnabled = true;
                this.lock.addChild(pic);
                this.lock.addChild(up);
                this.lock.addChild(down);
            }
           
        }
        p.handleTap = function(event) {
            var n = event.target.name;
            var obj;
            var str;
            if (n == "lockClose") {
                this.dispatchEventWith("game_over", true, null, false);
            }
            if (n == "lockBtn") {
                str = [];
                for (var i = 0; i < this.length; i++) {
                    var s = this.lock.getChildByName("pic" + i).tag.replace("tag", "");
                    str.push(this.params["all_pwd_res"][parseInt(s)]);
                }
                if (this.isObjectValueEqual(str, this.params["correct_pwd_res"])) {
                    this.dispatchEventWith("game_over", true, {
                        result: "ok",
                        key: this.lock.name,
                        cmds: [
                            ['goto', this.params.j_sceneId]
                        ]
                    }, false);
                } else {
                    var msg = "密码错误";
                    var params = {
                        width : 180,
                        height : 60,
                        y : this.lock.height / 2 + this.lock.y + 10,
                    }
                    this.content.vortexMsg(msg, params);
                }
            }
            if (n.indexOf("up") > -1) {
                str = "pic" + n.replace("up", "");
                obj = this.lock.getChildByName(str);
                obj.texture = this.changPic(obj, "up");
            }
            if (n.indexOf("down") > -1) {
                str = "pic" + n.replace("down", "");
                obj = this.lock.getChildByName(str);
                obj.texture = this.changPic(obj, "down");
            }
        }
        p.changPic = function(o, tag) {
            var pics = this.params["all_pwd_res"];
            var j = 0;
            for (var i in pics) {
                if (i == o.tag.replace("tag", "")) {
                    if (tag == "up") {
                        j = (parseInt(i) + 1) > 9 ? 0 : (parseInt(i) + 1);
                        break;
                    }
                    if (tag == "down") {
                        j = (parseInt(i) - 1) < 0 ? 9 : (parseInt(i) - 1);
                        break;
                    }
                }
            }
            o.tag = "tag"+j;
            return RES.getRes(pics[j]);
        }
        p.destroy = function() {
            this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            _super.prototype.destroy.call(this);
        }
        p.isObjectValueEqual = function(a, b) {
            var aProps = Object.getOwnPropertyNames(a);
            var bProps = Object.getOwnPropertyNames(b);
            if (aProps.length != bProps.length) {
                return false;
            }
            for (var i = 0; i < aProps.length; i++) {
                var propName = aProps[i];
                if (a[propName] !== b[propName]) {
                    return false;
                }
            }
            return true;
        }
        return GamePasswordLock;
    }(VortexGame.GameKid));
    egret.registerClass(GamePasswordLock, 'GameLock.GamePasswordLock');
    VortexGame.GameManager.regGame(GAMEID, GamePasswordLock);
})(GameLock || (GameLock = {}));