var Main = (function(_super) {
    __extends(Main, _super);

    function Main() {
        _super.call(this);
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        main_index = this;
    }
    var d = __define,
        c = Main,
        p = c.prototype;
    p.onAddToStage = function(event) {
        this.loadingView = new LoadingUI(this);
        this.stage.addChild(this.loadingView);
        RES.addEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.loadConfig("resource/default.res.json", "resource/");
    };
    p.onConfigComplete = function(event) {
        RES.removeEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, this.onResourceLoadError, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
        RES.addEventListener(RES.ResourceEvent.ITEM_LOAD_ERROR, this.onItemLoadError, this);
        RES.loadGroup("preload");
    };
    p.onResourceLoadComplete = function(event) {
        if (event.groupName == "preload") {
            this.stage.removeChild(this.loadingView);
            RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
            RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, this.onResourceLoadError, this);
            RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
            RES.removeEventListener(RES.ResourceEvent.ITEM_LOAD_ERROR, this.onItemLoadError, this);
//            this.createGameScene();
            this.receiveDataFromNative();
        }
    };
    p.onItemLoadError = function(event) {
        console.warn("Url:" + event.resItem.url + " has failed to load");
    };
    p.onResourceLoadError = function(event) {
        console.warn("Group:" + event.groupName + " has failed to load");
        this.onResourceLoadComplete(event);
    };
    p.onResourceProgress = function(event) {
        if (event.groupName == "preload") {
            this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
        }
    };
    p.reCreate = function(isSkipContinue) {
        this.removeChild(this.game);
        this.game.destroy();
        this.game = null;
//            this.createGameScene(isSkipContinue);
        this.receiveDataFromNative(isSkipContinue);
    };
            
    p.receiveDataFromNative = function(isSkipContinue)
    {
            var self = this;
            
            // 这连个方法是为了隐藏闪屏
            egret.ExternalInterface.call("hideFlash", "");
            egret.ExternalInterface.addCallback("hideFlashDone", function (message)
            {
                egret.ExternalInterface.addCallback("responseGameArgs", function (message) {
                                                    egret.ExternalInterface.call("sendToNative", message);
                                                    var arr = message.split(';');
                                                    
                                                    var scriptid = arr[1];
                                                    var V = arr[2];
                                                    if(V == "V")
                                                    {
                                                    isVertical = true;
                                                    
                                                    }else
                                                    {
                                                    isVertical = false;
                                                    }
                                                    
                                                    userid = arr[3];
                                                    
                                                    self.createGameScene(scriptid,isSkipContinue)
                                                    });
                
                
                egret.ExternalInterface.call("gameParams", "");
            });
            
    }

    p.createGameScene = function(scriptid,isSkipContinue) {
            
        egret.ImageLoader.crossOrigin = "Anonymous";
//        var gameid = request("gameid");
//        var scriptid = request("id");
//        var gameid = "9070c402596532da6138c1b36058655f";
        

//        if (request("type") != 'preview' && IsPC()) {
//            document.getElementById('down').style.display = 'block';
//        };
        var gameid = null;
        var gameurl = "";
        if (gameid) {
            gameurl = Config.editor + "Api/Play/preview?gameId=" + gameid;
            // gameurl = "http://tools.vortexfun.com/Api/Play/preview?gameId=" + gameid;
            if (typeof gameid == 'string' && gameid.indexOf('test_') > -1) {
                gameurl = window.location.origin + '/' + gameid.replace('test_', '') + ".json";
            };
        } else if (scriptid) {
            gameurl = Config.material + "getPlay.json?id="+scriptid;
//            if (request('v') == 'last') {
//                gameurl += "&version=lastest";
//            };
        } else {
            gameurl = window.location.origin + "/nnn.json";
        }
        this.game = new Vortex.VortexView({
            gameurl: gameurl,
            resurl: Config.material,
            isSkipContinue: isSkipContinue
        });
        var self = this;
//        this.lastClientWidth = document.body.clientWidth;
//        var w = self.stage.stageWidth,
//            h = self.stage.stageHeight;
//        window.onresize = function() {
//            if (IsPC() || document.body.clientWidth == self.lastClientWidth) return;
//            if (document.body.clientWidth > self.lastClientWidth) {
//                //竖屏变横屏
//                self.stage.scaleMode = egret.StageScaleMode.FIXED_HEIGHT;
//            } else {
//                //横屏变竖屏
//                self.stage.scaleMode = egret.StageScaleMode.FIXED_WIDTH;
//            }
//            setTimeout(function() {
//                self.reCreate(1);
//            }, 500);
//        }
        this.game.width = this.stage.stageWidth;
        this.game.height = this.stage.stageHeight;
        VortexEase.stageWidth = this.game.width;
        VortexEase.stageHeight = this.game.height;
        this.addChild(this.game);
    };
            
    return Main;
}(egret.DisplayObjectContainer));
egret.registerClass(Main, 'Main');
////
var LoadingUI = (function(_super) {
    __extends(LoadingUI, _super);

    function LoadingUI(argvs) {
        _super.call(this);
        this.content = argvs;
        this.createView();
    }
    var d = __define,
        c = LoadingUI,
        p = c.prototype;
    p.createView = function() {
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            
        this.width = this.content.width;
        this.height = this.content.height;
        //设置遮罩
        this.graphics.beginFill(0x000000, 1);
        this.graphics.drawRect(0, 0, this.content.width, this.content.height);
        this.graphics.endFill();
        //序列帧动画
        var fac = new egret.MovieClipDataFactory(RES.getRes("progress.json"), RES.getRes("progress.img"));
        this.movieClip = new egret.MovieClip(fac.generateMovieClipData('butterfly'));
        this.movieClip.name = 'butterfly';
        this.movieClip.x = (this.width - this.movieClip.width) * 0.5;
        this.movieClip.y = (this.height - this.movieClip.height) * 0.4;
        this.addChild(this.movieClip);
        this.movieClip.play(-1);
        //progress 
        this.textField = new egret.TextField();
        this.textField.width = this.width;
        this.tips_arr = ["电脑上搜索“漩涡互娱”可以制作自己的作品哦~", "走错剧情不用愁，永久存储解你忧", "自己制作一分钟上手，活动奖励信手拈来", "献花催更更有效，不怕作者看不到", "再次游戏的时候可以直接继续玩"];
        this.textField.text = "正在加载资源，当前进度1/2";
        var offsetY = 20;
        this.textField.y = this.movieClip.y * 1 + this.movieClip.height + offsetY;
        this.textField.textAlign = "center";
        this.addChild(this.textField);
        //tips
        this.tipsField = new egret.TextField();
        this.tipsField.width = this.width;
        this.tipsField.text = this.tips_arr[Math.floor(Math.random() * this.tips_arr.length)];
        this.tipsField.size = 18;
        this.tipsField.y = this.textField.y + this.textField.height + offsetY;
        this.tipsField.textAlign = "center";
        this.addChild(this.tipsField);
                 
        if(_type == "box")
        {
             var item = new egret.Bitmap();
             item.touchEnabled = true;
             item.visible = true;
             item.texture = RES.getRes("loadBack");
             item.name = "backBtn";
             var margin = 47.5;
             item.x = margin;
             item.y = margin;
             this.backBtn = item;
             this.addChild(item);
        }
    };
    p.setProgress = function(current, total) {
        this.textField.text = "正在加载资源，当前进度" + current + "/" + total;
    };
    p.hide = function() {
        this.movieClip.stop();
        this.visible = false;
    }
    p.show = function(length) {
        this.movieClip.play(-1);
        this.tipsField.text = this.tips_arr[Math.floor(Math.random() * this.tips_arr.length)];
        this.visible = true;
         var t = "1";
         if (length)
         {
            t = length;
         }
        this.textField.text = "正在加载资源，当前进度" + "0" + "/" + t;
    }
                 
     p.handleTap = function(event) {
         event.stopPropagation();
         if (event.target.name == this.backBtn.name)
        {
            //退出游戏
            this.content.boxOffMusic();
            egret.ExternalInterface.call("ocExit", "");
        }
     };
         
    return LoadingUI;
}(egret.Sprite));
egret.registerClass(LoadingUI, 'LoadingUI');
////
