/**
 * 与服务器通信类
 * 
 */
var Net = (function(_super) {
    __extends(Net, _super);

    function Net(argvs) {
        _super.call(this);
        this.content = argvs;
    }
    var d = __define,
        c = Net,
        p = c.prototype;
    /*获取脚本接口*/
    p.getScript = function(callback) {
        RES.getResByUrl(this.content.gameurl, callback, this.content, RES.ResourceItem.TYPE_JSON);
    };
    /*fs方式获取图片*/
    p.getImgFs = function(imgid, callback) {
        RES.getResByUrl(this.content.resurl + "resource.jpeg?fs=" + imgid, function(o) {
            callback(o, imgid);
        }, this, RES.ResourceItem.TYPE_IMAGE);
    };
    /*resid方式获取图片*/
    p.getImg = function(imgid, callback) {
        RES.getResByUrl(this.content.resurl + "resource.jpeg?resid=" + imgid, function(o) {
            callback(o, imgid);
        }, this, RES.ResourceItem.TYPE_IMAGE);
    };
    /*
     *   imgid = 图片id
     *   type 是fs 还是resid 方式
     *   item 当前bitmap对象
     *   callback 回调. p1:当前对象  p2:加载完成后的纹理
     */
    p.getImgWithItem = function(imgid, type, item, callback) {
        if (type === "fs") {
            this.getImgFs(imgid, function(o) {
                callback(item, o, imgid);
            });
        } else {
            this.getImg(imgid, function(o) {
                callback(item, o, imgid);
            });
        }
    }
    /*获取存档接口*/
    p.readDocument = function(params, callback) {
        if (params.userid == null) {
            console.error('userid is ' + params.userid);
            return;
        };
        var url = Config.player + "Nochlogin/Doc/read";
        var variables = "";
        this.callback = callback;
        this.postData(url, params);
    };
    /*保存存档接口*/
    p.saveDocument = function(params, callback) {
        if (params.userid == null) {
            return;
        };
        var url = Config.player + "Nochlogin/Doc/save";
        this.callback = callback;
        this.postData(url, params);
    };
    p.onLoadComplete = function(event) {
        var loader = event.target;
        //获取加载到的纹理对象
        var data = loader.data;
        if (this.callback) {
            this.callback(JSON.parse(data));
        };
    }
    p.onLoadError = function() {
        egret.log("onLoadError");
        // this.callback();
    };
    p.json2variables = function(json) {
        var variables = "";
        for (var i in json) {
            if (i == 'data') {
                variables += (i + "=" + JSON.stringify(json[i]) + "&");
            } else {
                variables += (i + "=" + json[i] + "&");
            }
        }
        if (variables.length > 0) {
            variables = variables.substring(0, variables.length - 1);
        }
        return variables;
    };
    p.pay = function(string, callback) {
        var pay = string.split(';')[0];
        var earn = string.split(';')[1];
        if (pay) {
            var num = pay.split('&')[0] * 1;
            //-1表示重复付费,1表示只付费一次
            var type = pay.split('&')[1] * 1;
            if (this.content.g_token) {
                showPay();
            } else {
                showLogin();
            }
            //判断是否登录，消耗（不足充值）
            //showLogin();
            //不足的时候调充值界面
            // if(earn){
            //     //..此处增加货币,在消耗之后的回调下
            // }  
        }
        //这里写在增加货币的回调里
        // if(typeof callback == "function"){
        //     callback();
    }
    /*点击和分享日志接口*/
    p.log = function(params, callback) {
        var uniqueFlag = this.content.vt.cache.getLocalUniqueFlag();
        params.uniqueFlag = uniqueFlag;
        params.goods_id = this.content.vt.gameid;
        var url = Config.official + "Mobile/Goods/shareGoods";
        this.callback = callback;
        this.postData(url, params);
    }
    p.postData = function(url, params) {
        var variables = this.json2variables(params);
        var loader = new egret.URLLoader();
        loader.addEventListener(egret.Event.COMPLETE, this.onLoadComplete, this);
        //添加加载失败侦听
        loader.addEventListener(egret.IOErrorEvent.IO_ERROR, this.onLoadError, this);
        var request = new egret.URLRequest(url);
        request.method = egret.URLRequestMethod.POST;
        request.data = new egret.URLVariables(variables);
        loader.load(request);
    }
    p.getToken = function(url, params) {
        console.log(params);
        this.callback = function(data) {
            console.log(data);
            if (data.res == 'true') {
                this.content.g_token = data.msg.g_token;
                this.initUser({
                    "g_token": data.msg.g_token
                });
            }
        };
        this.postData(url, params);
    }
    p.postToPlayerServer = function(url, params, cb) {
        var d = params ? params : {};
        d['g_token'] = this.content.g_token;
        this.callback = cb;
        this.postData(url, params);
    }
    p.initUser = function(data) {
        var url = Config.player + "Home/Main/initUser";
        this.postToPlayerServer(url, data, function(data) {
            
        });
    }
    p.payInit = function(data, cb) {
        var url = Config.player + "Home/Main/payInit";
        this.postToPlayerServer(url, data, cb);
    }
    return Net;
}(egret.Sprite));
egret.registerClass(Net, 'Net');