var TalkDialog = (function(_super) {
    __extends(TalkDialog, _super);

    function TalkDialog(argvs) {
        _super.call(this);
        this.content = argvs;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = TalkDialog,
        p = c.prototype;
    p.onAddToStage = function(event) {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.flag = false; //标记打字机是否结束 是否可以往下点击
        this.textArr = new Array();
        this.arr = new Array();
        this.messageBack = new egret.Bitmap();
        this.messageBack.name = "messageBack";
        this.addChild(this.messageBack);
        this.messageBack.visible = false;
        this.message = new egret.TextField();
        this.message.size = 29;
        this.message.name = "messageText";
        this.addChild(this.message);
        this.message.visible = false;

        this.nameBack = new egret.Bitmap();
        this.nameBack.name = "nameBack";
        this.addChild(this.nameBack);
        this.nameBack.visible = false;
        this.nametf = new egret.TextField();
        this.nametf.name = "nameText";
        this.nametf.verticalAlign = egret.VerticalAlign.MIDDLE;
        this.nametf.textAlign = "center";
        this.addChild(this.nametf);
        this.nametf.visible = false;

    };
    p.distroy = function() {
        while (this.act.numChildren) {
            var dobj = this.act.removeChildAt(0);
            if (dobj.destroy) {
                dobj.destroy();
            }
        }
    }
    p.setContent = function(name, content, params) {
        this.flag = false;
        var speed = 1000;
        if(params){
            if (params.speed == "0") {
                speed = 0;
            } else if (params.speed == "20") {
                speed = 1000;
            } else {
                speed = 2000;
            }
        }
        if (name) {
            this.nametf.textFlow = new egret.HtmlTextParser().parser(name);
            this.content.addReviewText(this.nametf.text);
            this.nametf.visible = true;
            if (params['posX']) {
                this.nametf.x = params['posX'] * this.width;
                this.nameBack.x = params['posX'] * this.width - 5;
            } else if (params['position']) {
                switch (params['position']) {
                    case 'left':
                        this.nametf.x = this.res[this.nametf.name].x + OffsetX;
                        this.nameBack.x = this.res[this.nameBack.name].x + OffsetX;
                        break;
                    case 'center':
                        this.nametf.x = this.stage.stageWidth * 0.5 - this.nametf.width * 0.5 - 5 + OffsetX;
                        this.nameBack.x = this.stage.stageWidth * 0.5 - this.nameBack.width * 0.5 + OffsetX;
                        break;
                    case 'right':
                        this.nametf.x = this.stage.stageWidth - this.res[this.nametf.name].x - this.nametf.width - 5 + OffsetX;
                        this.nameBack.x = this.stage.stageWidth - this.res[this.nameBack.name].x - this.nameBack.width + OffsetX;
                        break;
                    default:
                        this.nametf.x = this.res[this.nametf.name].x;
                        this.nameBack.x = this.res[this.nameBack.name].x;
                        break;
                }
            }else {
                this.nametf.x = this.res[this.nametf.name].x + OffsetX;
                this.nameBack.x = this.res[this.nameBack.name].x + OffsetX;
            }
            this.nameBack.visible = true;
            this.fillTalkName(name,params);
        } else {
            this.nametf.text = "";
            this.nametf.visible = false;
            this.nameBack.visible = false;
        }
        if (content) {
            this.fillTalkContent(content, true, speed,params);
        } else {
            this.flag = true;
            this.message.text = "";
            this.message.visible = false;
            this.messageBack.visible = false;
        }
    };
    p.fillTalkContent = function(content, isTyping, speed,params) {

        var contentDelay = (params && params.contentDelay) ? params.contentDelay : 0;
        content = this.content.vt.showVariate(content);
        this.message.textFlow = new egret.HtmlTextParser().parser(content);
        this.content.addReviewText(this.message.text);
        this.message.visible = true;
        this.messageBack.visible = true;
        if (isTyping) {
            this.content.vortexAnim(this.message, [
                ["wait", contentDelay ? contentDelay : 0],
                ["ease", "typewriter", speed]
            ]);
            this.content.vortexAnim(this.messageBack, [
                ["ease", "visible", contentDelay ? contentDelay : 0]
            ]);
        }
    }
    p.fillTalkName = function(name,params) {
        var nameDelay = params.nameDelay ? params.nameDelay : 0;
        this.content.vortexAnim(this.nametf, [
            ["ease", "visible", nameDelay ? nameDelay : 0]
        ]);
        this.content.vortexAnim(this.nameBack, [
            ["ease", "visible", nameDelay ? nameDelay : 0]
        ]);
    }
    p.messageVisible = function(flag) {
        this.message.visible = flag;
        this.messageBack.visible = flag;
    }
    p.setSkin = function(skinname, res) {
        this.res = res;
        
        this.messageBack.texture = RES.getRes(skinname + "." + res[this.messageBack.name].background);
        this.messageBack.x = res[this.messageBack.name].x + OffsetX;
        this.messageBack.y = res[this.messageBack.name].y + OffsetY;
        this.message.width = res[this.message.name].w;
        this.message.height = res[this.message.name].h;
    
        this.message.size = res[this.message.name].size; 
        this.message.lineSpacing = this.message.size * 0.3;   
        //向左偏移一个字的大小
        this.message.x = res[this.message.name].x + OffsetX - this.message.size;
        this.message.y = res[this.message.name].y + OffsetY;

        this.nameBack.texture = RES.getRes(skinname + "." + res[this.nameBack.name].background);
        this.nameBack.x = res[this.nameBack.name].x + OffsetX;
        this.nameBack.y = res[this.nameBack.name].y + OffsetY;
        this.nametf.width = this.nameBack.width;
        this.nametf.height = this.nameBack.height;
        this.nametf.x = (this.nameBack.width - this.nametf.width) * 0.5 + this.nameBack.x;
        this.nametf.y = (this.nameBack.height - this.nametf.height) * 0.5 + this.nameBack.y; 

        this.nametf.fontFamily = this.message.fontFamily = res["mainui"].fontFamily;
        this.nametf.textColor = this.message.textColor = this.content.vt.script.global.color ? this.content.vt.script.global.color : res["mainui"].color;
    }
    return TalkDialog;
}(egret.Sprite));
egret.registerClass(TalkDialog, 'TalkDialog');
////