//这里是界面的总控
var UIMain = (function(_super) {
    __extends(UIMain, _super);

    function UIMain(argvs) {
        _super.call(this);
        this.content = argvs;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = UIMain,
        p = c.prototype;
    p.onAddToStage = function(event) {
        var argvs = {
            content: this.content,
            super: this
        }
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.uiBg = new egret.Sprite();
        this.uiBg.graphics.beginFill(0x000000, 0.0001);
        this.uiBg.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.uiBg.graphics.endFill();
        this.uiBg.touchEnabled = true;
        this.uiBg.visible = false;
        this.addChild(this.uiBg);
        //工具栏
        this.toolShow = true;
        this.toolBox = new ToolBox(argvs);
        this.toolBox.visible = true;
        this.addChild(this.toolBox);
        //小三角
        this.nextIcon = new egret.Bitmap();
        this.nextIcon.name = "nextIcon";
        this.nextIcon.visible = false;
        this.addChild(this.nextIcon);

        this.menuShow = true;
        this.menuButton = new egret.Bitmap();
        this.menuButton.name = "menu";
        this.menuButton.touchEnabled = true;
        this.addChild(this.menuButton);

        this.bagButton = new egret.Bitmap();
        this.bagButton.name = "bag";
        this.bagButton.touchEnabled = true;
        this.addChild(this.bagButton);
        //选择是否继续界面
        this.selectStart = new Continue(argvs);
        this.selectStart.visible = false;
        this.addChild(this.selectStart);
        this.menu = new Menu(argvs);
        this.menu.visible = false;
        this.addChild(this.menu);
        this.bagUI = new UIBag(argvs);
        this.addChild(this.bagUI);
        //最后一页
        this.end = new UIEnd(argvs);
        this.end.visible = false;
        this.addChild(this.end);
        //提示框
        this.tips = new egret.Shape();
        this.tips.x = this.width / 2;
        this.tips.y = this.height / 2;
        this.addChild(this.tips);
        this.msg = new egret.TextField();
        this.msg.x = this.width / 2;
        this.msg.y = this.height / 2;
        this.msg.textAlign = "center";
        this.msg.verticalAlign = egret.VerticalAlign.MIDDLE;
        this.addChild(this.msg);
        this.tips.visible = false;
        this.msg.visible = false;
        this.tag = true;
    }
    p.handleTap = function(event) {
        var name = event.target.name;
        if (name === this.bagButton.name) {
            this.setBagVisible();
            this.HideUIExceptMenu(this.bagUI.visible);
            this.content.autoPause = true;
        };
        if (name == this.menuButton.name) {
            this.menu.visible = true;
            this.HideUIExceptMenu(this.menu.visible);
            this.content.autoPause = true;
        }
        event.stopPropagation();
    }
    p.setBagVisible = function() {
        this.bagUI.setVisible(!this.bagUI.getVisible());
    }
    p.msgShow = function(msg, params) {
        this.tips.alpha = 0.65;
        this.tips.visible = true;
        this.msg.alpha = 1;
        this.msg.visible = true;
        this.tips.width = params.width;
        this.tips.height = params.height;
        this.tips.graphics.beginFill(0x000000, 0.65);
        this.tips.graphics.drawRoundRect(0, 0, params.width, params.height, 10, 10);
        this.tips.graphics.endFill();
        this.tips.anchorOffsetX = this.tips.width / 2;
        this.tips.anchorOffsetY = this.tips.height / 2;
        this.tips.y = params.y;
        this.msg.text = msg;
        this.msg.width = params.width;
        this.msg.height = params.height;
        this.msg.anchorOffsetX = this.msg.width / 2;
        this.msg.anchorOffsetY = this.msg.height / 2;
        this.msg.y = params.y;
        var tw1 = egret.Tween.get(this.tips);
        VortexEase['fadeOut'](this.tips, tw1, 1500);
        var tw2 = egret.Tween.get(this.msg);
        VortexEase['fadeOut'](this.msg, tw2, 1500);
    }
    p.setSkin = function(skinname, res) {
        this.menuButton.texture = RES.getRes(skinname + "." + res[this.menuButton.name].background);
        this.menuButton.x = res[this.menuButton.name].x;
        this.menuButton.y = res[this.menuButton.name].y;
        var menuBtnPs = ["## $sw - " + this.menuButton.x, this.menuButton.y, null, null, "## $w", 0];
        this.positonParameters(this.menuButton, menuBtnPs);
        // if (res[this.menuButton.name].hide) {
            this.menuButton.visible = true;
        // }
        this.bagButton.texture = RES.getRes(skinname + "." + res[this.bagButton.name].background);
        this.bagButton.x = res[this.bagButton.name].x;
        this.bagButton.y = res[this.bagButton.name].y;
        var bgBtnPs = ["## $sw - " + this.bagButton.x, this.bagButton.y, null, null, "## $w", 0];
        this.positonParameters(this.bagButton, bgBtnPs);
        this.bagButton.visible = false;
        this.bagUI.setSkin(skinname, res);
        this.menu.setSkin(skinname, res);
        this.toolBox.setSkin(skinname, res);
        this.nextIcon.texture = RES.getRes(this.nextIcon.name);
        this.nextIcon.x = res[this.nextIcon.name].x + OffsetX;
        this.nextIcon.y = res[this.nextIcon.name].y + OffsetY;
        var tw = egret.Tween.get(this.nextIcon, {
            loop: true
        });
        VortexEase["nextIcon"](this.nextIcon, tw, 750);
        this.end.setSkin(skinname, res);
        //设置鼠标光标为手形状
        // mouse.setButtonMode(this.menuButton, true);
        // mouse.setButtonMode(this.bagButton, true);
    
        (_typeBox != 'box')?mouse.setButtonMode(this.menuButton, true):1;
        (_typeBox != 'box')?mouse.setButtonMode(this.bagButton, true):1;
    }
    p.HideUIExceptMenu = function(flag) {
        this.uiBg.visible = flag;
        //true 表示隐藏
        if (this.bagUI.items) this.bagButton.visible = !flag;
        if(this.menuShow){
            this.menuButton.visible = !flag;
        }else{
            this.menuButton.visible = false;
        }
        this.content.HideUIExceptUI(false);
    }
    p.setMenuShow = function(type){
        this.menuShow = type;
        if(this.menuShow){
            this.menuButton.visible = true;
        }else{
            this.menuButton.visible = false;
        }
    }

    p.setToolShow = function(type){
        this.toolShow = type;
        if(this.toolShow){
            this.toolBox.visible = this.toolBox.getPropNum()>0;
        }else{
            this.toolBox.visible = false;
        }
    }
    p.positonParameters = function(target, tps) {
        var params = {
            ps: tps
        };
        this.content.processProp({
            data: params
        }, {
            data: target
        });
    }
    p.getContainerWidth = function() {
        var uiW = 1280;
        if (screenMod == "fixedWidth") {
            uiW = this.width;
        } else {
            uiW = isVertical ? 720 : 1280;
        }
        return uiW;
    }
    p.getContainerHeight = function() {
        var uiH = 720;
        if (screenMod == "fixedWidth") {
            uiH = isVertical ? 1280 : 720;
        } else {
            uiH = this.height;
        }
        return uiH;
    }
    p.getContainerX = function() {
        return (this.width - this.getContainerWidth()) / 2;
    }
    p.getContainerY = function() {
        return (this.height - this.getContainerHeight()) / 2;
    }
    p.getContainer = function(name) {
        var container = new egret.Sprite();
        container.name = name;
        container.x = this.getContainerX();
        container.y = this.getContainerY();
        container.width = this.getContainerWidth();
        container.height = this.getContainerHeight();
        container.visible = false;
        return container;
    }
    p.setBag = function(list) {
        if (list.length > 0) {
            this.bagButton.visible = true;
            this.bagUI.setBag(list)
        } else {
            this.bagButton.visible = false;
        }
    }
    p.boxShare = function() {
        if (_typeBox == 'box') {
            egret.ExternalInterface.call("ocShare", "");
            return true;
        }
        return false;
    }
    p.boxExit = function() {
        if (_typeBox == 'box') {
             //退出
            this.content.boxOffMusic();
            egret.ExternalInterface.call("ocExit", "");
            return true;
        }
        return false;
    }

    //menu bag  gongjulan
    p.gameShowMBG = function(flag)
    {
        if(this.menuShow)
        {
             this.menuButton.visible = flag;
        }
        if (this.bagUI.items) this.bagButton.visible = flag;

        if (this.toolShow&&this.toolBox.getPropNum()>0) 
        {
            this.toolBox.visible = flag;
        }
    };

    return UIMain;
}(egret.Sprite));
egret.registerClass(UIMain, 'UIMain');
////