//storyReview
//menu剧情回放
//ly
var StoryReview = (function(_super) {
    __extends(StoryReview, _super);

    function StoryReview(argvs) {
        _super.call(this);
        this.super = argvs.super;
        this.content = argvs.content
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.currentPoint;
    }
    var d = __define,
        c = StoryReview,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        
        this.touchEnabled = true;
        this.itemBgArray = new Array();

        this.container = this.super.super.getContainer("review_layout");
        this.container.visible = true;
        this.addChild(this.container);
        //背景
        this.contentBg = this.addBitmapItem("storyReview_contentBg");
        this.container.addChild(this.contentBg);
        this.itemBgArray.push(this.contentBg);
        //文本layout
        this.textLayout = new egret.Sprite();
        this.textLayout.name = "review_textlayout";
        this.container.addChild(this.textLayout);
        //文本显示
        this.textView = this.addLabelItem("review_text");
        this.textView.addEventListener(egret.TouchEvent.TOUCH_MOVE, this.scrollText, this);
        this.textView.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.begintext, this);
        this.textLayout.addChild(this.textView);
        //标题
        this.titlebg = this.addBitmapItem("storyReview_title");
        this.container.addChild(this.titlebg);
        this.itemBgArray.push(this.titlebg);
        //返回按钮
        this.backBtn = this.addBitmapItem("storyReview_back");
        this.addChild(this.backBtn);
        this.itemBgArray.push(this.backBtn);
    }

    p.setSkin = function(skinname, res) {
        var layoutName = this.textLayout.name;
        this.textLayout.x = res[layoutName].x;
        this.textLayout.y = res[layoutName].y;
        this.textLayout.width = res[layoutName].w;
        this.textLayout.height = res[layoutName].h;

        var textName = this.textView.name;
        this.textView.width = res[layoutName].w;
        this.textView.size = res[textName].fontSize;
        this.textView.lineSpacing = res[textName].lineSpacing;
        this.textView.textColor = res["mainui"].color;
        this.textView.fontFamily = res["mainui"].fontFamily;
        this.textView.scrollRect = new egret.Rectangle(0, 0, res[layoutName].w, res[layoutName].h); //滚动区域是layout的区域
        this.textView.cacheAsBitmap = true;
       
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.texture = RES.getRes(res[item.name].background);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
        }

        var backBtnPs = ["## $sw - "+this.backBtn.x,this.backBtn.y,null,null,"## $w",0];
        this.super.super.positonParameters(this.backBtn,backBtnPs);

        this.totalRes = res;
        // mouse.setButtonMode(this.backBtn,true);
         (_typeBox != 'box')?mouse.setButtonMode(this.backBtn,true):1;
        this.iconAddMouseOverEventWithTarget(this.backBtn);
        this.iconAddMouseOutEventWithTarget(this.backBtn);
    }

    //滑动文本区域
    p.scrollText = function(event) {
        event.stopPropagation();
        var rect = this.textView.scrollRect;
        var gap = this.currentPoint - event.localY;
        if (gap <= 0) {
            if (rect.y > 0) {
            rect.y += gap;
            this.textView.scrollRect = rect;
            };
        }else {
            if (rect.y < (this.textView.height - this.textLayout.height)) {
                rect.y += gap;
                this.textView.scrollRect = rect;
            }
        };
    }
    //按下事件操作
    p.begintext = function(event) {
        event.stopPropagation();
        this.currentPoint = event.localY;
    }
    //点击事件操作
    p.handleTap = function(event) {
        event.stopPropagation();
        var name = event.target.name;
        
        if (name == this.titlebg.name) {
            return;
        } else if (name == this.backBtn.name) {
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
        }
    }

    p.setReviewText = function(){
        this.textView.text = this.content.addReviewText();
        if (this.textView.height > this.textLayout.height) {
            var rect = this.textView.scrollRect;
            rect.y = this.textView.height - this.textLayout.height;
            this.textView.scrollRect = rect;
        };
    }

    p.addBitmapItem = function(name) {
            var item = new egret.Bitmap();
            item.touchEnabled = true;
            item.name = name;
            return item;
        }
        //临时存储的时间文本
    p.addLabelItem = function(name) {
        var txItem = new egret.TextField;
        txItem.name = name;
        txItem.textAlign = egret.HorizontalAlign.LEFT;
        txItem.verticalAlign = egret.HorizontalAlign.CENTER;
        txItem.type = egret.TextFieldType.DYNAMIC;
        txItem.textColor = 0xffffff;
        txItem.touchEnabled = true;
        return txItem;
    }

    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };

    return StoryReview;
}(egret.Sprite));
egret.registerClass(StoryReview, 'StoryReview');