//ToolBox 工具栏
var ToolBox = (function(_super) {
    __extends(ToolBox, _super);

    function ToolBox(argvs) {
        _super.call(this);
        this.super = argvs.super;
        this.content = argvs.content
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.grids = new Array();
        this.crruntTopProp = 0;
        this.propData = new Array(); //数据源
        this.open = false;
    }
    var d = __define,
        c = ToolBox,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        //上三角
        this.toolUp = new egret.Bitmap();
        this.toolUp.name = "tool_up";
        this.toolUp.touchEnabled = true;
        this.addChild(this.toolUp);
        //下三角
        this.toolDown = new egret.Bitmap();
        this.toolDown.name = "tool_down";
        this.toolDown.touchEnabled = true;
        this.addChild(this.toolDown);
        for (var i = 0; i < 5; i++) {
            //格子layout
            this.grids[i] = new egret.Sprite();
            this.grids[i].touchEnabled = true;
            this.addChild(this.grids[i]);
            //格子背景
            var gridBg = new egret.Bitmap();
            gridBg.name = "gridBg";
            this.grids[i].addChild(gridBg);
            //道具
            var prop = new egret.Bitmap();
            prop.name = "prop";
            prop.touchEnabled = true;
            this.grids[i].addChild(prop);
            var count = new egret.TextField();
            count.name = "count";
            count.touchEnabled = false;
            count.visible = false;
            this.grids[i].addChild(count);
        };
    }
    p.setSkin = function(skinname, res) {
            //this.visible = false;
            this.toolUp.texture = RES.getRes(this.toolUp.name);
            this.toolUp.x = this.toolUp.width * 0.5;
            this.toolUp.y = this.toolUp.width * 0.5;
            var toLeft = this.toolUp.width * 0.5 - 10; //工具栏距左
            var toTop = 10; //单元格之间高距
            var grid_h = this.toolUp.width + 20; //单元格宽高
            var grid_w = this.toolUp.width + 20;
            for (var i = 0; i < this.grids.length; i++) {
                this.grids[i].width = grid_w;
                this.grids[i].height = grid_h;
                this.grids[i].x = toLeft;
                if (i === 0) {
                    this.grids[i].y = this.toolUp.y + this.toolUp.height + toTop;
                    this.grids[i].visible = true;
                } else {
                    this.grids[i].y = this.grids[i - 1].y + grid_h + toTop;
                    this.grids[i].visible = this.open;
                };
                var gridBg = this.grids[i].getChildByName("gridBg");
                gridBg.width = grid_w;
                gridBg.height = grid_h;
                var prop = this.grids[i].getChildByName("prop");
                prop.width = grid_w - 20;
                prop.height = grid_h - 20;
                prop.x = gridBg.x + 10;
                prop.y = gridBg.y + 10;
                var count = this.grids[i].getChildByName("count");
                count.width = grid_w - 20;
                count.height = grid_h - 20;
                count.x = gridBg.x + 10;
                count.y = gridBg.y + 10;
                count.size = count.width / 10;
                count.verticalAlign = "bottom";
                count.textAlign = "right";
            };
            this.toolDown.texture = RES.getRes(this.toolDown.name);
            this.toolDown.x = this.toolUp.x;
            this.toolDown.y = this.grids[this.grids.length - 1].y + grid_h + toTop;
            // this.setGridData();
        }
        //点击事件操作
    p.handleTap = function(event) {
            event.stopPropagation();
            var name = event.target.name;
            if (name === this.toolUp.name) {
                this.lastProp();
            } else if (name === this.toolDown.name) {
                this.nextProp();
            } else if (name === "prop") {
                this.clickProp(event.target);
            };
        }
        //下个道具
    p.nextProp = function() {
            if (!this.propData) return;
            this.crruntTopProp++;
            this.toolUp.visible = true;
            this.bindProp(this.propData.slice(this.crruntTopProp, this.crruntTopProp + this.grids.length));
            if (this.crruntTopProp + this.grids.length >= this.propData.length) {
                this.toolDown.visible = false;
            };
        }
        //上个道具
    p.lastProp = function() {
            if (!this.propData) return;
            this.crruntTopProp--;
            this.toolDown.visible = true;
            this.bindProp(this.propData.slice(this.crruntTopProp, this.crruntTopProp + this.grids.length));
            if (this.crruntTopProp <= 0) {
                this.toolUp.visible = false;
            };
        }
        //隐藏工具栏
    p.hideToolBox = function(){
        //this.visible = false;
    }
        //显示工具栏
    p.showToolBox = function(tools){
        this.setGridData(tools, null);
        //this.visible = true;
    }
    p.freshToolBox = function(tools){
        if(!this.visible) return;
        this.setGridData(tools, null);
        //this.visible = true;
    }
        //清空道具栏
    p.cleanProp = function() {
            this.propData = new Array();
            this.toolUp.visible = false;
            this.toolDown.visible = false;
            //this.visible = false;
            this.crruntTopProp = 0;
        }
        //绑定道具
    p.bindProp = function(data) {
            for(var i = 0; i < this.grids.length; i++){
                var prop = this.grids[i].getChildByName("prop");
                var count = this.grids[i].getChildByName("count");
                if (data[i]) {
                    prop.texture = RES.getRes(data[i].resid);
                    prop.tag = data[i];
                    prop.visible = true;
                    if(data[i].num && data[i].num > 1){
                        count.visible = true;
                        count.text = data[i].num;
                    } else {
                        count.visible = false;
                    }
                } else {
                    if(prop) prop.visible = false;
                    if(count) count.visible = false;
                }
            }
        }
        //点击道具
    p.clickProp = function(prop) {
            if (!prop.tag) return;
            if (prop.tag.id !== this.propData[0].id) {
                for (var i = 0; i < this.propData.length; i++) {
                    if (this.propData[i].id === "hand" && prop.tag.id !== "hand") {//让手保持第二位
                        this.propData.unshift(this.propData[i]);
                        this.propData.splice(i + 1, 1);
                    }
                    if (prop.tag.id === this.propData[i].id) {
                        this.propData.splice(i, 1);
                    }
                }
                this.propData.unshift(prop.tag);
                if (prop.tag.cmds) {
                    this.content.tiggerToolEvt(prop.tag.cmds);
                }
                this.bindProp(this.propData.slice(0, this.grids.length));
                this.crruntTopProp = 0;
            }
            this.openToolBox();
        }
        //展开收缩
    p.openToolBox = function() {
            this.open = !this.open;
            for (var i = 0; i < this.grids.length; i++) {
                if (i == 0) {
                    this.grids[i].visible = true;
                } else {
                    this.grids[i].visible = this.open;
                };
            }
            if (this.open) {
                this.crruntTopProp > 0 ? this.toolUp.visible = true : this.toolUp.visible = false;
                this.crruntTopProp + this.grids.length < this.propData.length ? this.toolDown.visible = true : this.toolDown.visible = false;
            } else {
                this.toolUp.visible = false;
                this.toolDown.visible = false;
            };
        }
        //新增对比
    p.newComparison = function(data) {
            for (var i = 0; i < data.length; i++) {
                var flag = false;
                var p = data[i].id;
                for (var j = 0; j < this.propData.length; j++) {
                    if (p === this.propData[j].id) {
                        this.propData[j] = data[i];
                        flag = true;
                    }
                };
                if (!flag) {
                    this.propData.push(data[i]);
                    flag = false;
                };
            };
        }
        //删除对比
    p.delComparison = function(data) {
            for (var i = 0; i < this.propData.length; i++) {
                var flag = false;
                var p = this.propData[i].id;
                for (var j = 0; j < data.length; j++) {
                    if (p === data[j].id) {
                        flag = true;
                    }
                };
                if (!flag) {
                    this.propData.splice(i, 1);
                    flag = false;
                };
            };
        }
        //设置格子背景
    p.setPropBg = function(resid) {
            if (!resid) return;
            for (var i = 0; i < this.grids.length; i++) {
                var gridBg = this.grids[i].getChildByName("gridBg");
                gridBg.texture = RES.getRes(resid);
            }
        }
        //设置数据源
    p.setGridData = function(data, bgResid) {
            if (!data || data.length <= 0) return;
            if (bgResid) {
                this.setPropBg(bgResid);
                this.propData = data;
            } else {
                // this.toolBox_id = id;
                this.newComparison(data);
                this.delComparison(data);
            };
            if (!this.propData) return;
            //this.visible = true;
            this.crruntTopProp = 0;
            this.toolUp.visible = false;
            this.toolDown.visible = this.open ? !(this.propData.length <= this.grids.length) : false;
            this.bindProp(this.propData.slice(0, this.grids.length));
        }
        //添加道具
    p.addProp = function(data) {
            if (!data) return;
            for (var i = 0; i < this.propData.length; i++) {
                if (data.id == this.propData[i].id) {
                    this.propData[i].num = data.num;
                    this.bindProp(this.propData.slice(this.crruntTopProp, this.grids.length));
                    return;
                }
            }
            this.propData.push(data);
            this.bindProp(this.propData.slice(this.crruntTopProp, this.grids.length));
        }
        //删除道具
    p.delProp = function(data) {
            if (!data) return;
            for (var i = 0; i < this.propData.length; i++) {
                if (data.id == this.propData[i].id) this.propData.splice(i, 1);
            }
            this.bindProp(this.propData.slice(this.crruntTopProp, this.grids.length));
        }
        //查询当前选中道具
    p.getCurrentProp = function() {
        if (!this.propData) return null;
        return this.propData[0];
    }

    p.getPropNum = function()
    {
       if (!this.propData) return 0;
       return this.propData.length;
    }

    return ToolBox;
}(egret.Sprite));
egret.registerClass(ToolBox, 'ToolBox');