var Vortex;
(function(Vortex) {
    egret.Tween.prototype.$tick = function(delta) {
        if (this.paused) {
            return;
        }
        this.setPosition(this._prevPosition + delta * (this.speed ? this.speed : 1.0));
    };
    var processProp = function(data, content) {
        content = content ? content : this;
        var v, arg;
        for (var id in data) {
            var dobj = content[id];
            if (dobj) {
                var d = data[id];
                for (var x in d) {
                    d[x] = this.exp.expression(d[x]);
                }
                arg = {}, arg.sw = this.width, arg.sh = this.height;
                v = this.exp.expression(d.ps[0], arg);
                if (v && (!isNaN(v))) {
                    dobj.x = v;
                } else {
                    dobj.x = 0;
                }
                v = this.exp.expression(d.ps[1], arg);
                if (v && (!isNaN(v))) {
                    dobj.y = v;
                } else {
                    dobj.y = 0;
                }
                v = this.exp.expression(d.ps[2], arg), ((v && (!isNaN(v))) ? dobj.width = v : 0);
                v = this.exp.expression(d.ps[3], arg), ((v && (!isNaN(v))) ? dobj.height = v : 0);
                __extends(dobj, d);
                arg.w = dobj.width, arg.h = dobj.height;
                v = this.exp.expression(d.ps[4], arg), ((v && (!isNaN(v))) ? dobj.anchorOffsetX = v : 0);
                v = this.exp.expression(d.ps[5], arg), ((v && (!isNaN(v))) ? dobj.anchorOffsetY = v : 0);
                v = this.exp.expression(d.ps[6], arg), ((v && (!isNaN(v))) ? dobj.x = dobj.x + v : 0);
                v = this.exp.expression(d.ps[7], arg), ((v && (!isNaN(v))) ? dobj.y = dobj.y + v : 0);
                //水平翻转
                v = this.exp.expression(d.ps[9], arg), ((v && (!isNaN(v))) ? dobj.skewY = v : 0);
                //垂直翻转
                v = this.exp.expression(d.ps[10], arg), ((v && (!isNaN(v))) ? dobj.skewX = v : 0);
                //角度
                v = this.exp.expression(d.ps[8], arg);
                if (v && (!isNaN(v))) {
                    dobj.rotation = v;
                } else {
                    dobj.rotation = 0;
                }
                //透明度
                v = this.exp.expression(d.ps[11], arg);
                if (v && (!isNaN(v))) {
                    dobj.alpha = v;
                } else if (typeof v == 'undefined') {
                    dobj.alpha = 1;
                } else {
                    dobj.alpha = 0;
                }
            }
        }
    }
    Vortex.processProp = processProp;
    var fontSize = {
        "4": isVertical ? 26 : 21, //22,
        "5": isVertical ? 33 : 28, //25,
        "6": isVertical ? 42 : 37, //28,
        "7": isVertical ? 58 : 56, //31,
    }
    var fixFontSize = function(txtFields) {
        for (var i in txtFields) {
            var x = txtFields[i].style;
            if (!x) continue;
            if (fontSize[x.size]) {
                x.size = fontSize[x.size];
            } else {
                x.size = isVertical ? 26 : 21; //22;
            }
        }
    }
    Vortex.fixFontSize = fixFontSize;
    var AnimMng = (function() {
        function AnimMng(content) {
            this.objs = [];
            this.twns = [];
            this.tweenNum = 0;
            this.speed = 1.0;
            this.content = content;
        }
        var d = __define,
            c = AnimMng,
            p = c.prototype;
        p.clear = function() {
            this.twns = [];
            for (var i in this.objs) {
                egret.Tween.removeTweens(this.objs[i]);
            }
            this.objs = [];
            this.tweenNum = 0;
            this.speed = 1.0;
        }
        p.speedUp = function(spd) {
            this.speed = spd ? spd : this.speed * 2 > 8 ? 8 : this.speed * 2;
            for (var i in this.twns) {
                this.twns[i].speed = this.speed;
            }
        }
        p.isEnd = function() {
            return this.tweenNum <= 0;
        }
        p.AnimEnd = function(o) {
            for (var i in this.twns) {
                if (this.twns[i]._target.name == o.name) {
                    this.twns[i].speed = 10000;
                    this.twns.splice(i, 1);
                    if (this.tweenNum) {
                        this.tweenNum--;
                    }
                }
            }
            var params = {
                ps: o.ps
            }
            egret.Tween.removeTweens(o);
            this.content.processProp({
                data: params
            }, {
                data: o
            });
        }
        p.anim = function(dobj, anim, loop, callback, thisObj, content) {
            if (!anim) return;
            content ? 0 : content = this.content;
            loop ? loop = true : loop = false;
            var self = this;
            var tw = egret.Tween.get(dobj, {
                loop: loop
            });
            tw.speed = this.speed;
            this.twns.push(tw);
            this.objs.indexOf(dobj) < 0 ? this.objs.push(dobj) : 0;
            var argvs = {
                sw: content.width,
                sh: content.height
            }
            var props = ["width", "height", "x", "y", "alpha", "rotation"];
            for (var i in props) {
                argvs[props[i]] = dobj[props[i]];
            }
            var processProps = function(props) {
                for (var i in props) {
                    var p = props[i];
                    props[i] = content.exp.expression(p, argvs);
                    isNaN(props[i] * 1) ? 0 : props[i] = props[i] * 1;
                }
                return props;
            }
            var parseEase = function(ease) {
                return egret.Ease[ease];
            }
            var loopEase = function(ease) {
                VortexEase[ease.type](dobj, ease.looptw, ease.duration);
            }
            var objChange = function(props) {
                for (var i in props) {
                    dobj[i] = props[i];
                    if (i == "alpha") {
                        dobj.ps[11] = props[i];
                    }
                    if (i == "width") {
                        dobj.ps[2] = props[i];
                    }
                    if (i == "height") {
                        dobj.ps[3] = props[i];
                    }
                    if (i == "x") {
                        dobj.ps[0] = OffsetX + props[i];
                    }
                    if (i == "y") {
                        dobj.ps[1] = OffsetY + props[i];
                    }
                };
            }
            for (var i in anim) {
                var a = anim[i];
                var act = a[0];
                if (act === "visible") {
                    var duration = a[1];
                    var alpha = a[2] === "fadeIn" ? 0 : dobj.alpha;
                    VortexEase[act](dobj, tw, duration, alpha);
                }
                if (act === "wait") {
                    var duration = a[1] * 1;
                    var passive = a[2];
                    VortexEase[act](dobj, tw, duration, passive);
                }
                if (act === "to") {
                    var props = processProps(a[1]);
                    var duration = a[2] * 1;
                    var ease = parseEase(a[3]);
                    VortexEase[act](dobj, tw, props, duration, ease);
                    objChange(props);
                    // tw.to(props, duration, ease);
                }
                if (act === "set") {
                    var props = processProps(a[1]);
                    tw.set(props);
                }
                if (act === "call") {
                    var params = a[1];
                    tw.call(callback[0], thisObj, [params]);
                }
                if (act === "ease") {
                    var type = a[1];
                    var duration = a[2];
                    var isloop = a[3];
                    if (isloop && content.animSwitch) {
                        if (VortexEase[type]) {
                            var looptw = egret.Tween.get(dobj, {
                                loop: true
                            });
                            looptw.speed = this.speed;
                            this.twns.push(looptw);
                            VortexEase[type](dobj, tw, duration);
                            tw.call(loopEase, dobj, [{
                                type: type,
                                duration: duration,
                                looptw: looptw
                            }]);
                            break;
                        }
                    } else {
                        if (VortexEase[type]) {
                            VortexEase[type](dobj, tw, duration);
                        }
                    };
                }
            }
            var animEnd = function() {
                callback[1].call(thisObj)
                self.tweenNum--;
                if (self.tweenNum <= 0) {
                    callback[2].call(thisObj);
                }
            }
            if (!loop) {
                self.tweenNum++;
                tw.call(animEnd);
            }
        }
        return AnimMng;
    })();
    Vortex.AnimMng = AnimMng;
})(Vortex || (Vortex = {}));
var Vortex;
(function(Vortex) {
    var Avatar = (function(_super) {
        __extends(Avatar, _super);

        function Avatar(content) {
            _super.call(this);
            this.content = content;
            this.isAvatar = true;
        }
        var d = __define,
            c = Avatar,
            p = c.prototype;
        p.build = function(data) {
            var w_h = 640 / 720;
            var height = 720;
            var width = height * w_h;
            this.width = width;
            this.height = height;
            //捏脸各部件的缩放比例
            this.avatarScale = this.width / 640;
            //小游戏的缩放比例
            this.gameBodyScale = 0.7;
           
            for (var i in data) {
                if (i == "id") {
                    continue;
                }
                var resid = data[i];
                var b = new egret.Bitmap();
                b.name = i;
                b.resid = resid;
                // b.visible = false;
                var ps = this.getXY(resid);
                b.name = ps[0].length > 1 ? ps[0] : i;
                b.x = ps[1], b.y = ps[2];
                this.addChild(b);
                var texture = RES.getRes(resid); 
                if (!texture) {continue;}
                b.texture = texture;
                b.width = texture.textureWidth * this.avatarScale;
                b.height = texture.textureHeight * this.avatarScale;
                b.x *= this.avatarScale;
                b.y *= this.avatarScale;

            }
        }
        p.destroy = function() {
            this.removeChildren();
        };
        p.handleTap = function(event) {
            event.stopPropagation();
        };
        p.getXY = function(id) {
            var man = (RES.getRes("mod_2") && RES.getRes("mod_2")["res"] == "true") ? RES.getRes("mod_2")["msg"] : null;
            var woman = (RES.getRes("mod_3") && RES.getRes("mod_3")["res"] == "true") ? RES.getRes("mod_3")["msg"] : null;
            var pArr = this.getPsotion(id, man);
            if (!pArr) {
                pArr = this.getPsotion(id, woman);
            }
            return pArr ? pArr : ["", "0", "0"];
        }
        p.getPsotion = function(id, data) {
            for (var key in data) {
                var d = data[key];
                if (key == "mod") {
                    if (d[0] == id) {
                        return [key, d[2], d[3]];
                    }
                }
                for (var i = 0; i < d.length; i++) {
                    var arr = d[i];
                    if (arr[0] == id) {
                        return [key, arr[2], arr[3]];
                    }
                }
            }
            return null;
        }
        return Avatar;
    }(egret.Sprite));
    Vortex.Avatar = Avatar;
    egret.registerClass(Avatar, 'Vortex.Avatar');
})(Vortex || (Vortex = {}));
////
var Vortex;
(function(Vortex) {
    var VortexView = (function(_super) {
        __extends(VortexView, _super);
        //界面,虚拟机的界面控制..
        function VortexView(params) {
            _super.call(this);
            this.exp = new vortex.exp();
            this.exp.regFun("getRes", this.getRes, this);
            this.animMng = new Vortex.AnimMng(this);
            this.resGroups = [];
            this.autoSkip = null;
            this.clipFac = {};
            this.clips = [];
            this.snds = [];
            this.vces = [];
            this.vt = null;
            this.animSwitch = true; //动画开关，默认执行
            this.audioSwitch = true; //音频开关，默认执行
            this.musicSwitch = true; //音乐开关，默认执行
            this.soundSwitch = true; //音效开关，默认执行
            this.voiceSwitch = true; //语音开关，默认执行
            this.isEnding = false; //结局
            this.params = params;
            this.gameurl = this.params.gameurl;
            this.resurl = this.params.resurl ? this.params.resurl : Config.material;
            this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
            this.reviewText = ""; //剧情回放文本
            this.reviewIds = []; //剧情回放的sceneId
            this.saveDocumentPage = 1; //永久存档的当前第几页
            this.totalSaveNum = 0; //永久存档总个数
            this.autoPause = false;
            musicCtr = this;
            this.avatarGlobal = []; //全局的avatar
        }
        var d = __define,
            c = VortexView,
            p = c.prototype;
        p.processProp = Vortex.processProp;
        p.onAddToStage = function(event) {
            // if (screenMod == "fixedWidth") {
            OffsetY = isVertical ? this.height - 1280 : this.height - 720;
            // } else {
            OffsetX = isVertical ? (this.width - 720) / 2 : (this.width - 1280) / 2;
            // }
            this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
            this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            this.mask = new egret.Rectangle(0, 0, this.width, this.height);
            this.touchEnabled = true;
            var view = this.view = new egret.Sprite();
            view.width = this.width, view.height = this.height;
            this.addChild(view);
            this.bg2 = new egret.Bitmap();
            this.bg2.anchorOffsetX = this.width * 0.5, this.bg2.anchorOffsetY = this.height * 0.5;
            this.bg2.x = this.bg2.anchorOffsetX, this.bg2.y = this.bg2.anchorOffsetY;
            view.addChild(this.bg2);
            this.bg = new egret.Bitmap();
            this.bg.name = "bg";
            this.bg.anchorOffsetX = this.width * 0.5, this.bg.anchorOffsetY = this.height * 0.5;
            this.bg.x = this.bg.anchorOffsetX, this.bg.y = this.bg.anchorOffsetY;
            this.bg.touchEnabled = true;
            view.addChild(this.bg);
            this.act = new egret.Sprite();
            this.act.width = this.width, this.act.height = this.height;
            view.addChild(this.act);
            this.effect = new Effect();
            this.effect.width = this.width, this.effect.height = this.height;
            view.addChild(this.effect);
            this.talk = new TalkDialog(this);
            this.talk.width = this.width, this.talk.height = this.height;
            view.addChild(this.talk);

            this.game = new VortexGame.GameManager();
            this.game.width = this.width, this.game.height = this.height;
            this.game.addEventListener("game_over", this.handleGameOver, this);
            this.addChild(this.game);

            this.ui = new UIMain(this);
            this.ui.width = this.width, this.ui.height = this.height;
            this.addChild(this.ui);
            this.loadingView = new LoadingUI(this);
            this.addChild(this.loadingView);
            VortexEase['wh'](this);
            this.net = new Net(this);
            //这里监听ui抛出来的事件来处理总控的事情..
            this.net.getScript(function(o) {
                buildEnd(o.gameId);
                // if(o.payNeed){
                //     showLogin();
                //     return;
                // }
                //捏脸
                var resa = [{ //男
                    name: "mod_2",
                    type: "json",
                    url: Config.editor + "Api/Play/getPinface?id=2"
                }, { //女
                    name: "mod_3",
                    type: "json",
                    url: Config.editor + "Api/Play/getPinface?id=3"
                }];
                this.vortexResource("avatarMod", resa, null, null);
                this.vt = new vortex.vm({
                    script: o,
                    content: this
                });
                var self = this;
                var skinName = isVertical ? "DefaultUI-v" : "DefaultUI";
                if (o.global && o.global.skin) {
                    var tempa;
                    if (o.global.skin['0'] == "/") {
                        o.global.skin = o.global.skin.substr(1);
                    }
                    tempa = o.global.skin.split('/');
                    skinName = tempa[1].replace(/[0-9]/g, '');
                };
                this.global = o.global;
                if (_typeBox != 'preview'&&_typeBox != 'box') {
                    //如果不是预览，记录点击日志
                    self.net.log({
                        type: 1,
                        way: _way
                    });
                }
                this.vortexInit({
                    skin: skinName
                }, function() {
                    self.vortexSkin(skinName);
                    var isSkipContinue = self.params.isSkipContinue;
                    var markFrmid = self.vt.cache.getFrmId(o.gameId, self.userid)[0];
                    var isSkipContinue = self.params.isSkipContinue;
                    if (isSkipContinue == 1) {
                        //跳过是否继续游戏界面并且选择继续游戏
                        self.continueGame(o.gameId, true);
                    } else if (isSkipContinue == 2) {
                        //跳过是否继续游戏界面并且选择不继续游戏
                        self.continueGame(o.gameId, false);
                    } else {
                        if (markFrmid) {
                            self.ui.selectStart.showSelectStart(o.gameId);
                            self.loadingView.hide();
                        } else {
                            self.vt.play();
                        }
                    }
                })
            });
        };
        p.continueGame = function(gameId, flag) {
            if (flag) {
                this.reviewIds = this.vt.cache.getFrmId(gameId, this.userid)[1];
                this.reviewText = ""; //清空剧情回放
                this.reviewIds2Text(this.reviewIds);
                this.vt.play(this.vt.cache.getFrmId(gameId, this.userid)[0]);
            } else {
                this.vt.play();
            }
        }
        p.destroy = function() {
            this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
            this.game.removeEventListener("game_over", this.handleGameOver, this);
            this.vortexImageClear();
            while (this.act.numChildren) {
                var dobj = this.act.removeChildAt(0);
                if (dobj.destroy) {
                    dobj.destroy();
                }
            }
        };
        p.getRes = function(resid) {
            return RES.getRes(resid);
        };
        p.handleTap = function(event) {
            if (this.vt.onTapEvt(event.target.name)) {
                return;
            }
            if (this.isEnding && this.isNext(true) && event.target.name === "bg") {
                this.vt.cache.removeGame(null);
                if (is_showEnd) {
                    showEnd();
                } else {
                    this.ui.end.visible = true;
                    this.ui.HideUIExceptMenu(true);
                    var result = {
                        evt: "end",
                        argvs: {
                            result: true
                        }
                    }; //输出的参数
                    this.dispatchEventWith("game_over", true, result, false);
                }
                return;
            }
            this.animMng.speedUp();
        };
        p.onResourceProgress = function(event) {
            if (!this.loadingView.visible) {
                this.showLoading();
            };
            this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
        };
        p.hideLoading = function() {
            this.loadingView.hide();
        };
        p.showLoading = function(l) {
            this.loadingView.show(l);
        };
        p.initUser = function(callback) {
            //如果是登陆的话，openid在这里赋值
            var userid = _userid;
            if (userid == '') {
                //从本地获取openid
                userid = this.vt.cache.getLocalOpenid(this.vt.script.gameId);
            };
            if (typeof userid == 'undefined' || userid == null) {
                //如果本地也没有openid
                userid = new Date().getTime();
                this.vt.cache.setLocalOpenid(this.vt.script.gameId, userid);
            };
            this.userid = userid;
            callback.call();
        };
        p.vortexInit = function(params, callback) {
            var groupName = 'vortexInit';
            var resources = [{
                name: "skin_fnt",
                type: "sheet",
                url: "assets/UI/" + params.skin + "/texture.fnt"
            }, {
                name: "skin_json",
                type: "json",
                url: "assets/UI/" + params.skin + "/texture.json"
            }];
            var keys = "skin_fnt,skin_json";
            var cfg = {
                name: groupName,
                resources: resources,
                groups: [{
                    name: groupName,
                    keys: keys
                }]
            };
            var self = this;
            RES.parseConfig(cfg, 'resource/');
            if (callback) {
                var onComp = function(e) {
                    if (e.groupName === groupName) {
                        self.vortexSkin();
                        RES.loadGroup("init");
                    }
                    if (e.groupName === 'init') {
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                        self.initUser(function() {
                            callback.call();
                            // self.loadingView.hide();
                        });
                    };
                }
                var onError = function(e) {
                    if (e.groupName === groupName) {
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                    }
                }
                RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
                RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
            }
            RES.loadGroup(groupName);
        };
        p.vortexSkin = function() {
            //皮肤逻辑需要严重统一.目前不知道在干嘛.
            var str = "skin_json";
            this.skinname = "skin_fnt";
            this.res = RES.getRes(str);
            this.talk.setSkin(this.skinname, this.res);
            this.ui.setSkin(this.skinname, this.res);
        };
        p.clearReviewText = function() {
            this.reviewText = "";
            this.ui.menu.storyReview.setSkin("", this.res);
        }
        p.addReviewText = function(text) { //添加回放文本
            if (!text) {
                return this.reviewText;
            };
            if (text == " " && this.reviewText.substring(this.reviewText.length - 3).toString() == "\n \n") return this.reviewText;
            this.reviewText += text + "\n";
            return this.reviewText;
        };
        p.addReviewIds = function(id) { //添加回放剧情id或者选了选项的哪一项
            if (typeof id == 'undefined') return;
            if (typeof this.reviewIds == 'undefined') {
                this.reviewIds = [];
            };
            if (id.length == 1) {
                this.reviewIds[this.reviewIds.length - 1] += '-' + id;
            } else {
                this.reviewIds.push(id);
            }
        };
        p.reviewIds2Text = function(ids) {
            for (var i in ids) {
                var frmid = ids[i];
                var frmData, selectIndex = 0;
                if (typeof frmid != 'undefined' && frmid.indexOf('-') > -1) {
                    selectIndex = frmid.split('-')[1];
                    frmid = frmid.split('-')[0];
                }
                frmData = this.vt.list[frmid];
                var dialog_name = "";
                var dialog_content = "";
                var selectText = "";
                for (var i in frmData.cmds) {
                    var temp = frmData['cmds'][i];
                    if (temp[0] == 'talk') {
                        if (temp[1] && temp[1] != null) {
                            dialog_name = temp[1];
                        };
                        if (temp[2] && temp[2] != null) {
                            dialog_content = temp[2];
                        }
                    };
                    if (temp[0] == 'game' && temp[1] == 'txtopt') {
                        if (selectIndex != 0) {
                            selectText = temp[2].data['Text' + selectIndex].text;
                        }
                    }
                }
                var ntext = new egret.TextField();
                ntext.textFlow = new egret.HtmlTextParser().parser(dialog_name);
                this.addReviewText(ntext.text);
                var text = new egret.TextField();
                text.textFlow = new egret.HtmlTextParser().parser(dialog_content);
                this.addReviewText(text.text);
                this.addReviewText(" ");
                if (selectText) {
                    this.addReviewText(selectText);
                }
            }
        };
        p.isNext = function(tag) {
            if (!tag) {
                if (!this.vt.stopNext) {
                    this.addEventListener("nextIconHide", this.nextIconHide, this);
                    this.ui.nextIcon.visible = true;
                } else {
                    this.ui.nextIcon.visible = false;
                }
                return true;
            } else {
                return this.ui.nextIcon.visible;
            }
        };
        p.nextIconHide = function() {
            this.removeEventListener("nextIconHide", this.nextIconHide, this);
            this.ui.nextIcon.visible = false;
        }
        p.vortexTalk = function(name, content, params) {
            this.talk.setContent(name, content, params);
        };
        p.freshTalk = function(content) {
            this.talk.fillTalkContent(content, false);
        };
        p.vortexEffect = function(type, resid, params) {
            if (type && this.animSwitch) {
                this.effect.play(type, resid, params);
            } else {
                this.effect.stop();
            }
        };
        p.vortexPlayGame = function(gameid, params) {
            if(gameid!="txtopt"){
                this.ui.gameShowMBG(false);
            }
            params.skinname = this.skinname;
            params.skinres = this.res;
            params.content = this;
            this.game.playGame(gameid, params);
        };
        p.handleGameOver = function(event) {
            this.ui.gameShowMBG(true);
            this.game.clearGame();
            this.vt.onGameEvt(event.data);
        };
        p.vortexBackground = function(imgid, anim, anim2) {
            (!imgid) ? this.bg.texture = null: 0;
            var o = RES.getRes(imgid);
            if (o) {
                this.bg2.texture = this.bg.texture;
                this.bg2.width = this.width, this.bg2.height = this.height;
                anim2 ? this.vortexAnim(this.bg2, anim2) : 0;
                this.bg.texture = o;
            } else {
                RES.getResByUrl(this.resurl + "resource.jpeg?resid=" + imgid, function(o) {
                    this.bg.texture = o;
                }, this, RES.ResourceItem.TYPE_IMAGE);
                console.log("bg not found");
            }
            this.bg.width = this.width, this.bg.height = this.height;
            anim ? this.vortexAnim(this.bg, anim) : 0;
        };
        p.vortexEnd = function(result) {
            this.isEnding = result;

            if (_typeBox == 'box') 
            {

                return;
            }

            /*特殊处理，针对情人节游戏的结束页长按保存*/
            if (this.vt.gameid == '910e7d9a18d8dacf3900d2b779ae5f00') {
                var imgObj = new Image();
                imgObj.id = "shareImg";
                imgObj.src = this.bg.texture.toDataURL("image/jpeg");
                imgObj.style.position = "absolute";
                var canvas = document.getElementById('str').getElementsByTagName('canvas')[0];
                imgObj.style.left = canvas.style.left;
                // imgObj.style.top = canvas.style.height.replace('px','') * (-1) + 'px';
                imgObj.style.top = canvas.style.top;
                imgObj.style.width = canvas.style.width;
                imgObj.style.height = canvas.style.height;
                document.getElementById('str').appendChild(imgObj);
                /*function fadeInTop(elem){
                    var top = elem.style.top.replace('px','') * 1;
                    top += 30;
                    if (top >= 0) {
                        top = 0;
                        elem.style.top = top + 'px';
                        return;
                    };
                    elem.style.top = top + 'px';
                    setTimeout(function(){
                        fadeInTop(elem);
                    },10);
                }
                fadeInTop(imgObj);*/
                return;
            }
        };
        p.vortexImageClear = function() {
            while (this.act.numChildren) {
                var dobj = this.act.removeChildAt(0);
                if (dobj.destroy) {
                    dobj.destroy();
                }
            }
            this.act.removeChildren();
            // this.ui.toolBox.cleanProp();
            if (this.txt) {
                this.txt.removeChildren();
            }
            this.animMng.clear();
            for (var i in this.clips) {
                var dobj = this.clips[i];
                dobj.stop();
                dobj.removeEventListener(egret.Event.COMPLETE, this.onClipComp, this);
                dobj.removeEventListener(egret.Event.LOOP_COMPLETE, this.onClipLoopComp, this);
                dobj.removeEventListener(egret.MovieClipEvent.FRAME_LABEL, this.onClipLabel, this);
            }
            this.clipFac = {};
        };
        p.vortexAnim = function(dobj, anim, tag, loop) {
            if (!dobj) return; //如果点击事件的对象被删除则不执行
            if (tag) {
                this.objAnimEnd(dobj);
            }
            if (anim && anim[0] && (anim[0][0] == 'fadeIn' || anim[0][0] == 'visible')) {
                dobj.alpha = 0;
            }
            this.animMng.anim(dobj, anim, loop, [function(params) {
                this.vt.onAnimEvt(params);
            }, function() {
                this.vt.onAnimEvt("end." + dobj.name);
            }, function() {
                if (this.autoSkip) {
                    this.vortexAnim(this.vortexGetByName(this.autoSkip[1]), this.autoSkip[2]);
                    this.autoSkip = null;
                } else {
                    if (this.isNext()) this.vt.onAnimEvt("end");
                    this.game.dispatchEventWith("gameShow", true, null, false);
                }
            }], this, this);
            if (!this.animSwitch) {
                this.animStop();
            };
        };
        p.vortexWaitAnimEnd = function() {
            if (this.animMng.isEnd()) {
                this.isNext();
                this.game.dispatchEventWith("gameShow", true, null, false);
                this.vt.onAnimEvt("end");
            }
        };
        p.objAnimEnd = function(o) {
            this.animMng.AnimEnd(o);
            this.vt.onAnimEvt("end." + o);
        };
        p.animStop = function() {
            this.animMng.speedUp(10000);
        };
        p.vortexGetByName = function(id) {
            if (id == "bg") return this.bg;
            if (id == "view") return this.view;
            if (id == "all") return this;
            return this.act.getChildByName(id);
        };
        p.vortexTextFieldAdd = function(id, txt, params) {
            if (params.style && params.style.direction != "Vertical") {
                var dobj = new egret.TextField();
            } else {
                var dobj = new egret.Sprite();
            }
            dobj.name = id;
            this.act.addChild(dobj);
            this.vortexSpriteSet(dobj, params, false);
            dobj.fontFamily = this.res["mainui"].fontFamily;
            dobj.lineSpacing = isVertical ? 10 : 5;
            var speed = 1000;
            if (params.style) {
                dobj.textAlign = params.style.textAlign;
                if (params.style.speed == "0") {
                    speed = 0;
                } else if (params.style.speed == "20") {
                    speed = 1000;
                } else {
                    speed = 2000;
                }
                dobj.direction = params.style.direction;
            }
            if (dobj.direction != "Vertical") {
                dobj.height = 'auto';
            }
            txt = this.vt.showVariate(txt);
            dobj.textFlow = new egret.HtmlTextParser().parser(txt ? txt : "");
            Vortex.fixFontSize(dobj.textFlow);
            if (!params.anim) { //如果动画序列为空则直接执行打字机效果
                this.vortexAnim(dobj, [
                    ["ease", "typewriter", speed]
                ]);
                return;
            };
            var isHasEnterAnim = false;
            var isHasExitAnim = false;
            var exitAnimIndex;
            var enterAnimIndex;
            for (var i = 0; i < params.anim.length; i++) {
                var a = params.anim[i][1];
                if (a == "closer" || a == "pull") //将放大缩小改为淡入
                    params.anim[i][1] = "fadeIn";
                if (this.isExitAnim(a)) { //有退出动画
                    isHasExitAnim = true;
                    exitAnimIndex = i;
                    break;
                } else if (this.isEnterAnim(a) || this.isEmphasizeAnim(a) && !isHasEnterAnim) {
                    //只记录第一个进入动画位置
                    isHasEnterAnim = true;
                    enterAnimIndex = i;
                }
            };
            if (isHasExitAnim && !isHasEnterAnim) {
                //有退出且无进入　退出前+
                params.anim.splice(exitAnimIndex, 0, ["ease", "typewriter", speed]);
            } else if (!isHasEnterAnim && !isHasExitAnim) {
                //无进入且无退出　末尾+
                params.anim.push(["ease", "typewriter", speed]);
            } else if (isHasEnterAnim && isHasExitAnim && exitAnimIndex < enterAnimIndex) {
                //有退出且有进入且退出在进入之前　退出前+
                params.anim.splice(exitAnimIndex, 0, ["ease", "typewriter", speed]);
            }
            if (params.style && params.style.direction == "Vertical") {
                params.anim.splice(exitAnimIndex, 0, ["ease", "typewriter", 0]);
            }
            // params.anim.push(["ease", "typewriter", speed]);
            this.vortexAnim(dobj, params.anim);
        };
        p.isExitAnim = function(type) { //是否是退出动画
            var tag = ['fadeOutLeftBig', 'fadeOutRightBig', 'fadeOutUpBig', 'fadeOutDownBig', 'fadeOut', 'bounceOut'];
            for (var i in tag) {
                if (type == tag[i]) {
                    return true;
                }
            }
            return false;
        }
        p.isEnterAnim = function(type) { //是否是进入动画
            var tag = ['fadeInLeftBig', 'fadeInRightBig', 'fadeInDownBig', 'fadeInUpBig', 'fadeIn', 'closer', 'pull', 'bounceInDown', 'bounceInUp', 'bounceInLeft', 'bounceInRight', 'bounceIn'];
            for (var i in tag) {
                if (type == tag[i]) {
                    return true;
                }
            }
            return false;
        }
        p.isEmphasizeAnim = function(type) { //是否是强调动画
            var tag = ['bounce', 'flash', 'shake', 'tada'];
            for (var i in tag) {
                if (type == tag[i]) {
                    return true;
                }
            }
            return false;
        }
        p.freshTextField = function(id, txt) {
            var dobj = this.vortexGetByName(id);
            txt = this.vt.showVariate(txt);
            dobj.textFlow = new egret.HtmlTextParser().parser(txt ? txt : "");
            Vortex.fixFontSize(dobj.textFlow);
        };
        p.vortexSpriteSet = function(dobj, params, flag) {
            this.processProp({
                data: params
            }, {
                data: dobj
            });
            if (this.vt.events['tap.' + dobj.name]) {
                dobj.touchEnabled = this.vt.events['tap.' + dobj.name].cmds || this.vt.events['tap.' + dobj.name].filter ? true : false;
            } else {
                dobj.touchEnabled = false;
            }
            if (flag === undefined) {
                params.anim ? this.vortexAnim(dobj, params.anim) : 0;
            }
        };
        p.vortexImageAdd = function(id, imgid, params) {
            var dobj = new egret.Bitmap();
            dobj.name = id;
            var o = RES.getRes(imgid);
            if (o) {
                dobj.texture = o;
            } else {
                RES.getResByUrl(this.resurl + "resource.jpeg?resid=" + imgid, function(o) {
                    dobj.texture = o;
                }, this, RES.ResourceItem.TYPE_IMAGE);
                console.log("img not found");
            }
            if (id.indexOf('actor') > -1) {
                params.ps[2] = dobj.width;
                params.ps[3] = dobj.height;
            }
            this.vortexSpriteSet(dobj, params);
            this.act.addChild(dobj);
        };
        p.vortexfunShapeColor = function(id, imgid) {
            var dobj = this.vortexGetByName(id);
            dobj.texture = RES.getRes(imgid);
        };
        p.onClipComp = function(evt) {
            if (this.vt) {
                this.vt.onClipEvt("comp." + evt.target.name);
            };
        };
        p.onClipLoopComp = function(evt) {
            if (this.vt) {
                this.vt.onClipEvt("loopcomp." + evt.target.name);
            }
        };
        p.onClipLabel = function(evt) {
            if (this.vt) {
                this.vt.onClipEvt(evt.frameLabel + "." + evt.target.name);
            };
        };
        p.vortexClipAdd = function(id, resid, actid, params) {
            var fac = this.clipFac[resid];
            if (!fac) {
                fac = new egret.MovieClipDataFactory(RES.getRes(resid + ".json"), RES.getRes(resid + ".img"));
                this.clipFac[resid] = fac;
            }
            var dobj = new egret.MovieClip(fac.generateMovieClipData(actid));
            dobj.name = id;
            this.vortexSpriteSet(dobj, params);
            dobj.addEventListener(egret.Event.COMPLETE, this.onClipComp, this);
            dobj.addEventListener(egret.Event.LOOP_COMPLETE, this.onClipLoopComp, this);
            dobj.addEventListener(egret.MovieClipEvent.FRAME_LABEL, this.onClipLabel, this);
            dobj.visible = false;
            this.act.addChild(dobj);
            if (params.playTimes) {
                dobj.visible = true;
                dobj.play(params.playTimes);
            }
        };
        p.vortexClipPlay = function(id, resid, actid, playTimes) {
            var dobj = this.act.getChildByName(id);
            if (!dobj) return;
            var fac = this.clipFac[resid];
            if (!fac) return;
            dobj.movieClipData = fac.generateMovieClipData(actid);
            dobj.visible = true;
            dobj.play(playTimes);
        };
        p.vortexMsg = function(msg, params) {
            //TODO 标准的提示机制.
            this.ui.msgShow(msg, params);
        };
        p.boxOffMusic = function() {
            if (this.musicSwitch) {
                if (typeof this.bgm != 'undefined' && this.bgm != null) {
                    this.bgm.stop();
                }
            };
            var arr = [];
            if (this.soundSwitch) {
                arr = this.snds;
                for (var i in arr) {
                    if (!arr[i].isStopped) {
                        arr[i].stop();
                    }
                }
            };
            if (this.voiceSwitch) {
                arr = this.vces;
                for (var i in arr) {
                    if (!arr[i].isStopped) {
                        arr[i].stop();
                    }
                }
            };
        };
        p.boxonMusic = function() {
            if (this.musicSwitch) {
                this.onMusic();
            };
            if (this.soundSwitch) {
                this.onSound(1);
            };
            if (this.voiceSwitch) {
                this.onSound(2);
            };
        };
        //关闭音乐
        p.offMusic = function() {
            if (typeof this.bgm == 'undefined' || this.bgm == null) return;
            this.bgm.volume = 0;
        };
        //打开音乐
        p.onMusic = function() {
            if (typeof this.bgm == 'undefined' || this.bgm == null) return;
            this.bgm.volume = 1;
        };
        //关闭音效或语音
        p.offSound = function(type) {
            var arr = [];
            if (type == 1) {
                arr = this.snds;
            } else {
                arr = this.vces;
            }
            for (var i in arr) {
                if (!arr[i].isStopped) {
                    arr[i].volume = 0;
                }
            }
        };
        //打开音效或语音
        p.onSound = function(type) {
            var arr = [];
            if (type == 1) {
                arr = this.snds;
            } else {
                arr = this.vces;
            }
            for (var i in arr) {
                if (!arr[i].isStopped) {
                    arr[i].volume = 1;
                };
            }
        };
        /*音频淡入播放*/
        p.playAudio = function(resid, type) {
            var sd = RES.getRes(resid);
            if (sd) {
                var loopNum = 1;
                if (type == 'bgm') {
                    sd.type = egret.Sound.MUSIC;
                    loopNum = -1;
                }
                var sdc = sd.play(0, loopNum);
                sdc.volume = 1;
                if (type == 'bgm') {
                    this.bgm = sdc;
                } else if (type == 'snd') {
                    this.snds.push(sdc);
                } else if (type == 'vce') {
                    this.vces.push(sdc);
                }
                var tw = egret.Tween.get(sdc, {
                    loop: true
                });
                if ((type == 'bgm' && !this.musicSwitch) || (type == 'snd' && !this.soundSwitch) || (type == 'vce' && !this.voiceSwitch)) {
                    sdc.volume = 0;
                } else {
                    VortexEase['audioFadeIn'](sdc, tw, 2000);
                };
            }
        };
        p.vortexBgm = function(resid, params) {
            var self = this;
            if (this.bgm) {
                egret.Tween.removeTweens(self.bgm); //如果前一个音乐的淡入还没执行完，就停掉tween不继续执行淡入
                var tw = egret.Tween.get(this.bgm, {
                    loop: true
                });
                var callback = function() {
                    self.bgm.stop();
                    self.bgm = null;
                    self.playAudio(resid, 'bgm');
                };
                VortexEase['audioFadeOut'](this.bgm, tw, 1000, callback);
            } else {
                this.playAudio(resid, 'bgm');
            }
        };
        p.vortexClearSound = function() {
            for (var i in this.snds) {
                this.snds[i].stop();
                egret.Tween.removeTweens(this.snds[i]);
            }
            this.snds = [];
        };
        p.vortexSnd = function(resid, params) {
            this.vortexClearSound();
            this.playAudio(resid, 'snd');
        };
        p.vortexClearVoice = function() {
            for (var i in this.vces) {
                this.vces[i].stop();
                egret.Tween.removeTweens(this.vces[i]);
            }
            this.vces = [];
        };
        p.vortexVce = function(resid, params) {
            this.vortexClearVoice();
            this.playAudio(resid, 'vce');
        };
        p.vortexResource = function(frmid, resa, callback, thisobj) {
            if (RES.isGroupLoaded(frmid)) {
                if (callback) callback.call(thisobj, frmid);
                return;
            }
            var self = this;
            var findGroup = function(name) {
                for (var i in self.resGroups) {
                    var g = self.resGroups[i];
                    if (frmid === g.name) return g;
                }
            }
            var g = findGroup(frmid);
            if (!g) {
                var cfg = {
                    name: frmid,
                    resources: resa,
                    groups: [{
                        name: frmid,
                        keys: ""
                    }]
                };
                var ks = [];
                for (var i in resa) {
                    var r = resa[i];
                    ks.push(r.name);
                    if (!r.type || !r.url || r.url.indexOf("http", 0, 4) === 0) {
                        continue;
                    }
                    switch (r.type) {
                        case "image":
                            r.url = "resource.jpeg?resid=" + r.url;
                            break;
                        case "sound":
                            r.url = "resource.mp3?resid=" + r.url;
                            break;
                        default:
                            continue;
                            break;
                    }
                }
                cfg.groups[0].keys = ks.join(",");
                RES.parseConfig(cfg, this.resurl);
                if (frmid != "iconRes") this.resGroups.push(cfg);
                if (this.resGroups.length > 30) {
                    if (this.resGroups[0].name != frmid) {
                        var g = this.resGroups.shift();
                        if (g && g.name) {
                             if(g.name != "avatarMod")
                            {
                                RES.destroyRes(g.name, false);
                            }
                            // RES.destroyRes(g.name, false)
                        }
                    }
                }
            }
            if (callback) {
                this.showLoading(resa ? resa.length : 1);
                var onComp = function(e) {
                    if (e.groupName === frmid) {
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                        if (callback) callback.call(thisobj, frmid);
                        if (frmid != "iconRes") this.hideLoading();
                    }
                }
                var onError = function(e) {
                    if (e.groupName === frmid) {
                        RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, self.onResourceProgress, self);
                        RES.removeEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
                        if (callback) callback.call(thisobj, frmid);
                        this.hideLoading();
                    }
                }
                RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, onComp, self);
                RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
                RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, onError, self);
            }
            RES.loadGroup(frmid);
        };
        p.vortexOpenSystem = function(tag) {
            this.ui.HideUIExceptMenu(true);
            if (tag != "exit") {
                this.ui.menu.visible = true;
                this.ui.menu.AllMeunItemShowOrHide(false);
                this.ui.menu.getChildByName(tag).visible = true;
            }
            if (tag == "review") {
                this.ui.menu.getChildByName(tag).setReviewText();
            } else if (tag == "forever") {
                this.ui.menu.foreverSave();
            } else if (tag == "temporary") {
                this.ui.menu.temporarySave();
            } else if (tag == "exit") {
                egret.ExternalInterface.call("ocExit", "");
            }else if (tag == "share") {
                egret.ExternalInterface.call("ocShare", "");
            };
        };
        p.HideUIExceptUI = function(flag) {
            //true 表示隐藏
            this.act.visible = !flag;
            this.effect.visible = !flag;
            this.talk.visible = !flag;
            if (this.txt) {
                this.txt.visible = !flag;
            }
        };
        p.vortexToolBox = function(act, tool_box_bg, tools) {
            switch (act) {
                case "def":
                    this.ui.toolBox.setGridData(tools, tool_box_bg);
                    break;
                case "show":
                    this.ui.toolBox.showToolBox(tools);
                    break;
                case "fresh":
                    this.ui.toolBox.freshToolBox(tools);
                    break;
                case "hide":
                    this.setToolShow(false);
                    this.ui.toolBox.hideToolBox();
                    break;
                case "clear":
                    this.ui.toolBox.cleanProp();
                    break;
            }
        };
        /*将工具的点击事件的通知到vm*/
        p.tiggerToolEvt = function(cmds) {
            this.vt.defToolEvt(cmds);
        };
        /*保存存档*/
        p.save = function(params, callback) {
            this.net.saveDocument(params, callback);
        };
        /*读取存档*/
        p.read = function(params, callback) {
            var type = params.type;
            if (typeof params != 'obj') {
                params.userid = this.userid;
                params.gameid = this.vt.script.gameId;
            }
            if (params.type == 2) {
                params.page = this.saveDocumentPage;
                params.limit = 6;
            };
            this.net.readDocument(params, callback);
        };
        /*加载存档*/
        p.load = function(saveDocumentData) {
            var sceneId = saveDocumentData.sceneId;
            //加载当前页不往下执行
            if (sceneId == this.vt.curid) return;
            this.reviewIds = saveDocumentData.review;
            this.reviewText = ""; //清空剧情回放
            this.reviewIds2Text(this.reviewIds);
            this.vt.resetGvars(saveDocumentData.NUMBER.snapshot_before);
            this.isEnding = false;
            this.vt.doCmd(['goto', sceneId]);
        };
        //背包
        p.vortexBag = function(list) {
            this.ui.setBag(list);
        }
        p.setTotalSaveNum = function(num) {
            this.totalSaveNum = num;
        }
        p.closeMenu = function() {
            this.autoPause = false;
        }
        p.setMenuShow = function(type) {
            this.ui.setMenuShow(type);
        }

        p.setToolShow = function(type)
        {
            this.ui.setToolShow(type);
        }

        p.clearAvatarFrossmGlobal = function() {
            this.avatarGlobal = [];
        }
        //捏脸
        p.addAvatarToGlobal = function(id, data) {
            var d = new Array();
            if (this.avatarGlobal[this.vt.curid]) {
                d = this.avatarGlobal[this.vt.curid];
            }
            d[id] = data;
            this.avatarGlobal[this.vt.curid] = d;
            var gD = this.avatarGlobal["global"];
            if (!gD) {
                gD = [];
            }
            gD[id] = data;
            this.avatarGlobal["global"] = gD;
        };
        p.readAvatarFromGlobal = function(id) {
            var data = this.avatarGlobal[this.vt.curid];
            if (!data||(data&&(!data[id]))) {
                data = this.avatarGlobal["global"] ? this.avatarGlobal["global"] : null;
            }
            return data ? data[id] : null;
        };
        p.vortexAvatarChange = function(obj, editContainer) {
            var tContainer = obj;
            var gameBodyScale = tContainer.gameBodyScale;
            var arr = new Array();
            for (var i = 0; i < editContainer.numChildren; i++) {
                var c = editContainer.getChildAt(i);
                var name = c.name;
                var tc = tContainer.getChildByName(name);
                tc.texture = c.texture;
                tc.x = c.x / gameBodyScale;
                tc.y = c.y / gameBodyScale;
                tc.width = c.width / gameBodyScale;
                tc.height = c.height / gameBodyScale;
                tc.resid = c.resid;
                arr[name] = c.resid;
            }
            this.addAvatarToGlobal(obj.id, arr);
            //捏脸是依据捏脸对象的名字来对应修改，但是现需求：一个页面可能有多个同一id的捏脸对象(名字不同)
            //同一个页面,修改完一个捏脸对象后,id号相同的对象都要被修改
            //因此此处需要遍历act里面是否有相同id的捏脸对象
            for (var i = 0; i < this.act.numChildren; i++) {
                var item = this.act.getChildAt(i);
                if (item.isAvatar) {
                    if (item.id == obj.id && item.name != obj.name) {
                        for (var i = 0; i < item.numChildren; i++) {
                            var tc = item.getChildAt(i);
                            var name = tc.name;
                            var c = editContainer.getChildByName(name)
                            tc.texture = c.texture;
                            tc.x = c.x / gameBodyScale;
                            tc.y = c.y / gameBodyScale;
                            tc.width = c.width / gameBodyScale;
                            tc.height = c.height / gameBodyScale;
                            tc.resid = c.resid;
                        }
                    }
                }
            }
        };
        p.vortexAvatarAdd = function(id, name, params) {
            dobj = new Vortex.Avatar(this);
            dobj.id = id;
            dobj.name = name;
            dobj.ps = params.ps;
            dobj.touchEnabled = true;
            var atData = this.readAvatarFromGlobal(dobj.id);
            if (!atData) {
                atData = this.vt.script.avatars[dobj.id];
                this.addAvatarToGlobal(dobj.id, atData);
            }
            dobj.build(atData);
            var ps = params.ps;
            this.vortexSpriteSet(dobj, params);
            dobj.touchEnabled = true;
            this.act.addChild(dobj);
   
        };
        return VortexView;
    }(egret.Sprite));
    Vortex.VortexView = VortexView;
    egret.registerClass(VortexView, 'Vortex.VortexView');
})(Vortex || (Vortex = {}));
////