var vortex;
(function(vortex) {
    var build = (function() {
        function build() {}
        build.BUILD = {};
        build.reg = function(type, builder) {
            build.BUILD[type] = builder;
        }
        build.find = function(type) {
            return build.BUILD[type];
        }
        return build;
    })();
    vortex.build = build;
})(vortex || (vortex = {}));
var vortex;
(function(vortex) {
    var calPos = function(data) {
        if (data.fullScreen != "yes") {
            if (data.Position) {
                var p = data.Position.split(";");
                if (data.MovePos) {
                    p = data.MovePos.split(";");
                    p[0] = isVertical ? p[0] * 720 : p[0] * 1280;
                    p[1] = isVertical ? p[1] * 1280 : p[1] * 720;
                } else {
                    if (data.Position == "left") {
                        return [0, "## $sh"];
                    }
                    if (data.Position == "center") {
                        return ["## $sw * 0.5", "## $sh"];
                    }
                    if (data.Position == "right") {
                        return ["## $sw", "## $sh"];
                    }
                }
                if (isVertical) {
                    return ["## $sw * 0.5 - 360 + " + p[0] * 1, "## " + p[1] * 1 + " + $sh - 1280"];
                } else {
                    return ["## $sw * 0.5 - 640 + " + p[0] * 1, "## " + p[1] * 1 + " + $sh - 720"];
                }
            } else if (data.MovePos) {
                var p = data.MovePos.split(";");
                p[0] = isVertical ? p[0] * 720 : p[0] * 1280;
                p[1] = isVertical ? p[1] * 1280 : p[1] * 720;
                if (!p[0]) {
                    p[0] = 0;
                }
                if (!p[1]) {
                    p[1] = 0;
                }
                if (isVertical) {
                    return ["## $sw * 0.5 - 360 + " + p[0] * 1, "## " + p[1] * 1 + " + $sh - 1280"];
                } else {
                    return ["## $sw * 0.5 - 640 + " + p[0] * 1, "## " + p[1] * 1 + " + $sh - 720"];
                }
            }
            return ["## $sw", "## $sh"];
        }
        return [0, 0];
    }
    var calSize = function(data) {
        if (data.fullScreen && data.fullScreen == "yes") {
            return ["## $sw", "## $sh"];
        }
        if (data.Size) {
            var p = data.Size.split(";");
            return [p[0] * 1, p[1] * 1];
        }
        return [null, null];
    }
    var calAlign = function(data) {
        if (!data.Position) {
            return ["## $w * 0.5", "## $h * 0.5", "## $w * 0.5", "## $h * 0.5"];
        }
        if (!data.MovePos) {
            if (data.Position == "left") {
                return ["## $w * 0.5", "## $h * 0.5", "## $w * 0.5", "## $h * 0.5 - $h"];
            }
            if (data.Position == "center") {
                return ["## $w * 0.5", "## $h * 0.5", null, "## $h * 0.5 - $h"];
            }
            if (data.Position == "right") {
                return ["## $w * 0.5", "## $h * 0.5", "## $w * 0.5 - $w", "## $h * 0.5 - $h"];
            }
        }
        return ["## $w * 0.5", "## $h * 0.5", "## $w * 0.5", "## $h * 0.5"];
    }
    var calSkew = function(data) {
        var skew = [0, 0];
        if (data.AngleX == -1) {
            skew[0] = 180;
        }
        if (data.AngleY == -1) {
            skew[1] = 180;
        }
        if (data.scale == "-x" || data.scale == "-X") {
            skew[0] = 180;
        }
        return skew;
    }
    var getOperation = function(operationValue) {
        switch (operationValue) {
            case 1:
                return "+";
            case 2:
                return "-";
            case 3:
                return "=";
            case 4:
                return "*";
            case 5:
                return "/";
        }
    }
    var getValueStr = function(valueType, value) {
        var str = "";
        switch (valueType * 1) {
            case 1:
                str = str + value;
                break;
            case 2:
                var min = value.split("~")[0] * 1,
                    max = value.split("~")[1] * 1,
                    temp = min;
                if (min > max) {
                    min = max;
                    max = temp;
                }
                str = str + "( floor ( random * " + (max - min + 1) + " ) + " + min + " )";
                break;
            case 3:
                str = str + "$" + value;
                break;
        }
        return str;
    }
    var getCompareSign = function(compare_type) {
        switch (compare_type * 1) {
            case 1:
                return "&&";
            case 2:
                return "||";
            case 3:
                break;
        }
    }
    var getCompareOperation = function(operation) {
        switch (operation * 1) {
            case 1:
                return "==";
            case 2:
                return "<";
            case 3:
                return ">";
            case 4:
                return ">=";
            case 5:
                return "<=";
        }
    }
    var goinAnim = function(type) {
        var tag = ['fadeInLeftBig', 'fadeInRightBig', 'fadeInDownBig', 'fadeInUpBig', 'fadeIn', 'closer', 'pull', 'bounceInDown', 'bounceInUp', 'bounceInLeft', 'bounceInRight', 'bounceIn'];
        for (var i in tag) {
            if (type == tag[i]) {
                return true;
            }
        }
        return false;
    }
    var defChangeNmber = function(cmds, frameData, n_id) {
        var exp = "expression ";
        if (!frameData[n_id]) {
            exp = exp + "$" + n_id;
            cmds.push(["def", "c_" + n_id, exp, "frame"]);
        }
        frameData[n_id] = n_id;
        return cmds;
    }
    var setChangeNumber = function(cmds, frameData, flag) {
        if (flag) {
            var exp = "";
            var n_id;
            for (var i in (frameData ? frameData : null)) {
                exp = "expression ";
                exp = exp + "$" + i + " - $c_" + i;
                cmds.push(["set", "c_" + i, exp, "frame"]);
            }
        }
        return cmds;
    }
    var buildImgStroy = function(frmdata, tool_box) {
        var resa = [];
        var cmds = [];
        var stopNext = false;
        var parseAnim = function(animate) {
            if (!animate) return null;
            var out = [];
            var anim;
            if (animate.indexOf('[') > -1) {
                anim = JSON.parse(animate);
            } else {
                anim = [animate];
            }
            for (var i in anim) {
                if (anim[i] == null) {
                    continue;
                };
                var a = anim[i].split(";");
                var type = a[0];
                var duration = a[1].split("s")[0] * 1000; //持续时间
                var loop = a[2] * 1 === -1 ? true : false; //是否循环
                var times = a[2] * 1 > 1 ? a[2] * 1 : 1; //循环次数
                var wait = a[3].split("s")[0] * 1000; //延迟时间
                if (wait > 0) {
                    if (goinAnim(type)) {
                        out.push(["visible", wait, type]);
                    } else {
                        out.push(["wait", wait]);
                    }
                }
                if (loop) {
                    out.push(["ease", type, duration, loop]);
                } else {
                    for (var t = 0; t < times; t++) {
                        out.push(["ease", type, duration, loop]);
                    }
                };
            }
            if (out.length > 0) return out;
            return null;
        }
        cmds.push("clrobj");
        if (frmdata.savedocument === "true") {
            cmds.push("save;2");
        }
        if (frmdata.tempdocument === "true") {
            cmds.push("save;1");
        }
        var checkShowNumber = function(cmds) {
            var pattern = new RegExp("\\[(.| )+?\\]", "igm");
            if (frmdata.NewDialog) {
                var arr = null;
                var content = frmdata.NewDialog.Talkshow === "no" ? null : frmdata.NewDialog.Content.Html;
                if (content != null) {
                    arr = content.match(pattern);
                }
                if (arr != null) {
                    cmds.push(["freshTalk", content, ""]);
                }
            }
            for (var i in (frmdata.Wordbox ? frmdata.Wordbox : null)) {
                var content = frmdata.Wordbox[i].Content;
                var arr = content.match(pattern);
                if (arr != null) {
                    cmds.push(["freshWordBox", i, content]);
                }
            }
            return cmds;
        }
        var clickEvents = function(act, resid) {
                var anim = [];
                var freshFlag = false;
                var events = act.events;
                var e = events.replace("[", '').replace("]", '').split("\"");
                var evt = [];
                for (var i in e) {
                    if (e[i] != '' && e[i] != ',') evt.push(e[i]);
                };
                var toolFlag = frmdata.toolBox && frmdata.toolBox[act.idid];
                if (toolFlag) {
                    var condition = frmdata.toolBox[act.idid].tool.condition;
                    var exp = "expression $" + condition.n_id + " - " + frmdata.toolBox[act.idid].tool.subCount;
                    anim.push(["set", condition.n_id, exp, "global"]);
                }
                var framedata = {};
                var result = [];
                var sa = new Array();
                for (var i in evt) {
                    var a = evt[i].split(" ");
                    var b = a[1].split(",");
                    var s;
                    if (a[0] == '-f') {
                        if (b[1]) {
                            console.log(s);
                            s = ['anim', b[0],
                                [
                                    ["to", {
                                        "x": b[1],
                                        "y": b[2],
                                        "anchorOffsetX": 0,
                                        "anchorOffsetY": 0
                                    }],
                                ]
                            ]
                            sa.push(s);
                            continue;
                        }
                        if (b[3]) {
                            s = ['anim', b[0],
                                [
                                    ["to", {
                                        "width": b[3],
                                        "height": b[4]
                                    }]
                                ]
                            ];
                            sa.push(s);
                            continue;
                        }
                        if (b[5]) {
                            var resid = resid + "&color=" + b[5].replace("#", "")
                            s = ['color', b[0], resid];
                            anim.push(s)
                            resa.push({
                                name: resid,
                                type: "image",
                                url: resid,
                            });
                            continue;
                        }
                        if (b[6]) {
                            s = ['anim', b[0],
                                [
                                    ["to", {
                                        "alpha": b[6]
                                    }]
                                ]
                            ];
                            sa.push(s);
                            continue;
                        }
                    }
                    if (a[0] == '-j') {
                        stopNext = true;
                        s = ['goto', b[0],false,'-j'];
                        anim.push(s);
                        cmds.push(["pause", true]);
                        continue;
                    }
                    if (a[0] == '-a') {
                        var am = parseAnim("[\"" + b[1] + ";" + b[2] + ";" + b[3] + ";" + b[4] + "\"]");
                        console.log(am);
                        for (var i = 0; i < am.length; i++) {
                            s = ['anim', b[0],
                                [am[i]]
                            ];
                            sa.push(s);
                        };
                        continue;
                    }
                    if (a[0] == '-s') {
                        var str;
                        switch (parseInt(b[0])) {
                            case 1:
                                str = "forever";
                                break;
                            case 2:
                                str = "temporary";
                                break;
                            case 3:
                                str = "review";
                                break;
                            case 4:
                                str = "share";
                                break;
                            case 5:
                                str = "setting";
                                break;
                            case 6:
                                str = "exit";
                                break;
                            default:
                                str = "forever";
                                break;
                        }
                        s = ['system', str];
                        anim.push(s);
                        continue;
                    }
                    if (a[0] == "-nc") {
                        freshFlag = true;
                        anim = defChangeNmber(anim, framedata, b[0]);
                        var exp = "expression ";
                        exp = exp + "$" + b[1] + " ";
                        exp = exp + getOperation(b[2] * 1) + " " + getValueStr(b[3] * 1, b[4]);
                        s = ["set", b[0], exp, "global"];
                        anim.push(s);
                        continue;
                    }
                    if (a[0] == "-nj") {
                        stopNext = true;
                        var exp = "expression $" + b[0] + " ";
                        exp = exp + getCompareOperation(b[1] * 1) + " ";
                        if (b[2] * 1 == 1) {
                            exp = exp + b[3];
                        } else if (b[2] * 1 == 2) {
                            exp = exp + "$" + b[3];
                        }
                        s = ["if", exp, [
                            ["goto", b[4]]
                        ]];
                        cmds.push(["pause", true]);
                        anim.push(s);
                        continue;
                    }
                    var tag = true;
                    if (a[0] == "-lk") {
                        for (var m in anim) {
                            if (anim[m][1] == 'lock') {
                                tag = false;
                                break;
                            }
                        };
                        if (tag) {
                            for (var i in frmdata.lock) {
                                var lock = frmdata.lock[i];
                                if (i == b[0]) {
                                    s = ["game", "lock", lock];
                                    for (var j in lock['pic_res']) {
                                        resa.push({
                                            name: lock['pic_res'][j],
                                            type: "image",
                                            url: lock['pic_res'][j],
                                        });
                                    };
                                    for (var k in lock['all_pwd_res']) {
                                        resa.push({
                                            name: lock['all_pwd_res'][k],
                                            type: "image",
                                            url: lock['all_pwd_res'][k],
                                        });
                                    };
                                    stopNext = true;
                                    // cmds.push(["pause", true]);
                                    anim.push(s);
                                }
                            };
                        }
                    }
                }
                var sh = new Array();
                var fl = false;
                var num;
                for (var i = 0; i < sa.length; i++) {
                    var n = sa[i][1];
                    for (var j = 0; j < sh.length; j++) {
                        if (sh[j][1] == n) {
                            fl = true;
                            num = j;
                            break;
                        }
                    };
                    if (fl) {
                        fl = false;
                        var s = sh[num][2];
                        s.push(sa[i][2][0]);
                        sh.splice(num, 1, ['anim', n, s, true]);
                    } else {
                        sh.push(['anim', n, sa[i][2], true]);
                    }
                };
                for (var i = 0; i < sh.length; i++) {
                    anim.push(sh[i]);
                };
                anim = setChangeNumber(anim, framedata, freshFlag);
                anim = checkShowNumber(anim);
                s = ["toolbox", "fresh", frmdata.toolbox_id, null];
                anim.push(s);
                return anim;
            }
            //bg
        if (frmdata.background) {
            var bg = frmdata.background;
            var as;
            if (bg.animate_old) {
                var b = bg.animate_old ? bg.animate_old.replace("[", '').replace("]", '').replace(/\"/g, '').split(";") : null;
                bg.animate_old = "[\"" + a[0] + ";" + a[1] + ";" + a[3] + ";" + a[2] + "\"]";
            }
            if (bg.animate) {
                var ba = bg.animate.split(",");
                for (var i = 0; i < ba.length; i++) {
                    var a = ba[i] ? ba[i].replace("[", '').replace("]", '').replace(/\"/g, '').split(";") : null;
                    var b = "[\"" + a[0] + ";" + a[1] + ";" + a[3] + ";" + a[2] + "\"]";
                    i === 0 ? as = parseAnim(b) : as.push(parseAnim(b)[0]);
                };
            }
            cmds.push(["bg", bg.resid, as, parseAnim(bg.animate_old)]);
            resa.push({
                name: frmdata.background.resid,
                type: "image",
                url: frmdata.background.resid,
            });
        } else {
            cmds.push("clrbg");
        }
        var calList = false;
        var frameData = {};
        var result = [];
        for (var i in (frmdata.calList ? frmdata.calList : null)) {
            calList = true;
            cmds = defChangeNmber(cmds, frameData, frmdata.calList[i].n_id);
            var string = "expression ceil ( $" + frmdata.calList[i].calculate_nid1 + " ";
            string = string + getOperation(frmdata.calList[i].operation) + " " + getValueStr(frmdata.calList[i].valueType, frmdata.calList[i].value) + " )";
            cmds.push(["set", frmdata.calList[i].n_id, string, "global"]);
        }
        cmds = setChangeNumber(cmds, frameData, calList);
        //img
        var imgList = [];
        for (var i in (frmdata.Actor ? frmdata.Actor : null)) {
            frmdata.Actor[i].idid = i;
            frmdata.Actor[i].cmds = frmdata.Actor[i].events ? clickEvents(frmdata.Actor[i]) : null;
            imgList.push(frmdata.Actor[i]);
        }
        for (var i in (frmdata.ShapePic ? frmdata.ShapePic : null)) {
            frmdata.ShapePic[i].idid = i;
            frmdata.ShapePic[i].cmds = frmdata.ShapePic[i].events ? clickEvents(frmdata.ShapePic[i]) : null;
            imgList.push(frmdata.ShapePic[i]);
        }
        for (var i in (frmdata.Wordbox ? frmdata.Wordbox : null)) {
            frmdata.Wordbox[i].Content = frmdata.Wordbox[i].Content ? frmdata.Wordbox[i].Content.replace(/&nbsp;/g, " ").replace(/\n/g, " ") : null;
            frmdata.Wordbox[i].idid = i;
            frmdata.Wordbox[i].objtype = "textfield";
            imgList.push(frmdata.Wordbox[i]);
        }
        for (var i in (frmdata.Shape ? frmdata.Shape : null)) {
            frmdata.Shape[i].idid = i;
            frmdata.Shape[i].cmds = frmdata.Shape[i].events ? clickEvents(frmdata.Shape[i], frmdata.Shape[i].resid) : null;
            imgList.push(frmdata.Shape[i]);
        }
        for (var i in (frmdata.Prop ? frmdata.Prop : null)) {
            frmdata.Prop[i].idid = i;
            frmdata.Prop[i].cmds = [
                ["goto", frmdata.Prop[i].skip]
            ];
            imgList.push(frmdata.Prop[i]);
        }
        if (frmdata.Prop && Object.keys(frmdata.Prop).length > 0) {
            stopNext = true;
            cmds.push(["pause", true]);
        }
        var zsort = function(a, b) {
            return a.zindex > b.zindex;
        }
        imgList.sort(zsort);
        for (var i in imgList) {
            var act = imgList[i];
            var params = {
                ps: []
            };
            params.ps = params.ps.concat(calPos(act));
            params.ps = params.ps.concat(calSize(act));
            params.ps = params.ps.concat(calAlign(act));
            act.opacity = act.pacity ? act.pacity : act.opacity;
            act.opacity ? params.alpha = act.opacity / 100 : 0;
            act.animate ? params.anim = parseAnim(act.animate) : 0;
            act.cmds ? params.cmds = act.cmds : 0;
            act.Angle ? params.rotation = act.Angle : 0;
            params.ps = params.ps.concat(act.Angle ? act.Angle : 0);
            params.ps = params.ps.concat(calSkew(act));
            params.ps = params.ps.concat(typeof params.alpha === "undefined" ? 1 : params.alpha);
            // var params = {
            //  pos: calPos(act),
            //  size: calSize(act),
            //  alpha: act.opacity ? act.opacity / 100 : null,
            //  anim: parseAnim(act.animate),
            //  rotation: act.Angle,
            //  cmds: act.cmds
            // }
            if (act.cmds && frmdata.toolBox && frmdata.toolBox[act.idid]) {
                var condition = frmdata.toolBox[act.idid].tool.condition;
                var judgeStr = "expression ";
                judgeStr = judgeStr + "( $tool" + frmdata.toolBox[act.idid].tool.id + " > 0 ) && ";
                judgeStr = judgeStr + "( $" + condition.n_id + " ";
                judgeStr = judgeStr + getCompareOperation(condition.operation) + " ";
                if (condition.valueType == 1) {
                    judgeStr = judgeStr + condition.value;
                } else {
                    judgeStr = judgeStr + "$" + condition.compare_n_id;
                }
                judgeStr = judgeStr + " ) && ( $" + condition.n_id + " >= " + frmdata.toolBox[act.idid].tool.subCount + " )";
                cmds.push(["evt", "tap." + act.idid, judgeStr, act.cmds]);
            } else if (act.cmds) {
                cmds.push(["evt", "tap." + act.idid, null, act.cmds]);
            }
            if (act.objtype == "textfield") {
                var txt = act.Content;
                var style = {
                    textAlign: act.Align ? act.Align : "left",
                    direction: act.TextDirection ? act.TextDirection : "Transverse",
                    speed: act.TextSpeed ? act.TextSpeed : "20"
                }
                params.style = style;
                cmds.push(["text", act.idid, txt, params]);
                continue;
            }
            var resid = act.resid.split(";")[0];
            if (act.color) {
                resid = resid + "&color=" + act.color.substr(1);
            }
            cmds.push(["img", act.idid, resid, params]);
            resa.push({
                name: resid,
                type: "image",
                url: resid,
            });
        }
        //effect
        if (frmdata.effects) {
            //TODO 实现具体的特效并替换这里的参数
            //TODO 实现资源加载,根据玩家提交的图片.
            var buildEffect = function(type, rid, params) {
                var resid = rid ? rid : "magic";
                cmds.push(["effect", type, resid, params]);
            }
            var e = frmdata.effects;
            if (e.name == "rain") {
                buildEffect("rain", "rain", {
                    speed: e.speed
                });
            }
            if (e.name == "snow") {
                buildEffect("snow", "snow", {
                    speed: e.speed
                });
            }
            if (e.name == "flower") {
                buildEffect("flower", "flower", {
                    speed: e.speed
                });
            }
        } else {
            cmds.push("clreffect");
        }
        //Dialog
        if (frmdata.NewDialog) {
            var content = frmdata.NewDialog.Talkshow === "no" ? null : frmdata.NewDialog.Content.Html;
            var name = null;
            var contentDelay = frmdata.NewDialog.Content.delay ? frmdata.NewDialog.Content.delay * 1000 : 0;
            var nameDelay = 0;
            if (frmdata.NewDialog.NameContent.NameHtml != "") {
                name = frmdata.NewDialog.Nameshow === "no" ? null : frmdata.NewDialog.NameContent.NameHtml;
                nameDelay = frmdata.NewDialog.NameContent.delay ? frmdata.NewDialog.NameContent.delay * 1000 : 0;
            }
            var position = frmdata.NewDialog.NamePosition ? frmdata.NewDialog.NamePosition : null;
            var posX = frmdata.NewDialog.NamePosX ? frmdata.NewDialog.NamePosX : null;
            name = name ? name.replace(/&nbsp;/g, " ").replace(/\n/g, " ") : null;
            content = content ? content.replace(/&nbsp;/g, " ").replace(/\n/g, " ") : null;
            var speed = frmdata.NewDialog.VoiceSpeed ? frmdata.NewDialog.VoiceSpeed : "20";
            var style = {
                position: position,
                posX: posX,
                speed: speed,
                nameDelay : nameDelay,
                contentDelay : contentDelay,
            }
            if(!name&&!content){
                cmds.push("clrtalk");
            }else{
                cmds.push(["talk", name, content, style]);
            }
        } else {
            cmds.push("clrtalk");
        }
        //Selecttext 文本选项
        if (frmdata.SelectText && Object.keys(frmdata.SelectText).length > 0) {
            delete(frmdata.SelectText.wordType);
            stopNext = true;
            cmds.push(["game", "txtopt", {
                data: frmdata.SelectText,
                visible: true
            }]);
        }
        if (frmdata.toolbox_id && frmdata.toolbox_id != "") {
            var toolBox = tool_box[frmdata.toolbox_id];
            cmds.push(["toolbox", "def", frmdata.toolbox_id, toolBox.boxBg]);
        } else {
            cmds.push(["toolbox", "clear"]);
        }
        //TODO codelock//密码锁 小游戏方式实现.
        if (frmdata.game) {
            cmds.push(["game", frmdata.game.gameid, frmdata.game.params]);
        }
        var soundCmd = function(cmd, rid) {
            if (rid) {
                var resid = rid.split(";")[0];
                cmds.push([cmd, resid, null]);
                resa.push({
                    name: resid,
                    type: "sound",
                    url: resid,
                });
            }
        }
        if (frmdata.Music) {
            soundCmd("bgm", frmdata.Music.resid);
        } else {
            cmds.push("clrbgm");
        }
        if (frmdata.Sound) {
            soundCmd("snd", frmdata.Sound.resid);
        } else {
            cmds.push("clrsnd");
        }
        if (frmdata.Voice) {
            soundCmd("vce", frmdata.Voice.resid);
        } else {
            cmds.push("clrvce");
        }
        var evt = "tap.end";
        var nid = frmdata.next;
        if (frmdata.PageSkip && typeof frmdata.PageSkip !== "string") {
            nid = frmdata.PageSkip.sceneid;
        }
        if (frmdata.Story && typeof frmdata.Story !== "string") {
            stopNext = true;
            nid = null;
        }
        if (frmdata.autoSkip) {
            frmdata.autoSkip = frmdata.autoSkip.replace(/\"/g, "");
            cmds.push(["anim", "bg", [
                ["wait", frmdata.autoSkip * 1000]
            ]]);
            evt = "anim.end";
        }
        if (!nid) {
            cmds.push(["end", true]);
        }
        //....conditionJump
        if (typeof frmdata.jumpList != "undefined") {
            var branchList = [];
            var cmdArray = [];
            var judgeStr = "";
            var compareSign = "";
            var lastResult = ["goto", frmdata.jumpList.last.jump_sceneId, stopNext];
            var branch, condition;
            for (var i in frmdata.jumpList.branch) {
                branch = frmdata.jumpList.branch[i];
                judgeStr = "expression ";
                compareSign = getCompareSign(branch.compare_type);
                for (var j in branch.conditions) {
                    condition = branch.conditions[j];
                    judgeStr = judgeStr + "( $" + condition.n_id + " ";
                    judgeStr = judgeStr + getCompareOperation(condition.operation) + " ";
                    if (condition.valueType == 1) {
                        judgeStr = judgeStr + condition.value;
                    } else {
                        judgeStr = judgeStr + "$" + condition.value;
                    }
                    judgeStr = judgeStr + " )";
                    if (j < branch.conditions.length - 1) {
                        judgeStr = judgeStr + " " + compareSign + " ";
                    }
                }
                if (i == frmdata.jumpList.branch.length - 1) {
                    cmdArray.push(["if", judgeStr, [
                            ["goto", branch.jump_sceneId, stopNext]
                        ],
                        [lastResult]
                    ]);
                } else {
                    cmdArray.push(["if", judgeStr, [
                        ["goto", branch.jump_sceneId, stopNext]
                    ]]);
                }
            }
            cmds.push(["evt", evt, null, cmdArray]);
        } else {
            cmds.push(["evt", evt, null, [
                ["goto", nid, stopNext]
            ]]);
        }
        return [cmds, resa];
    }
    var globalBuild = function(script) {
        script.resa = [];
        script.cmds = [];

        function parseToolBox(toolBox) {
            var toolBox, tool, clickEvent, layers = null,
                frmId, resa = [];
            for (var i in toolBox) {
                toolBox = script.tool_box[i];
                script.resa.push({
                    name: toolBox.handBg,
                    type: "image",
                    url: toolBox.handBg
                });
                script.resa.push({
                    name: toolBox.boxBg,
                    type: "image",
                    url: toolBox.boxBg
                });
                for (var j in toolBox.tools) {
                    tool = toolBox.tools[j];
                    script.resa.push({
                        name: tool.resid,
                        type: "image",
                        url: tool.resid
                    });
                    for (var x in tool.events) {
                        clickEvent = tool.events[x];
                        frmId = clickEvent.bind_sceneId;
                        if (script.list[frmId] && script.list[frmId].toolbox_id == i) {
                            script.list[frmId]["toolBox"] = script.list[frmId]["toolBox"] ? script.list[frmId]["toolBox"] : {};
                            script.list[frmId]["toolBox"][clickEvent.layerId] = script.list[frmId]["toolBox"][clickEvent.layerId] ? script.list[frmId]["toolBox"][clickEvent.layerId] : {};
                            script.list[frmId]["toolBox"][clickEvent.layerId]["tool"] = {
                                id: tool.id,
                                condition: tool.condition,
                                subCount: clickEvent.subCount
                            };
                        }
                    }
                }
            }
        }

        function parseNumList(numList) {
            var result = {};
            var temp = 0;
            for (var i in numList) {
                result[numList[i].n_id] = {
                    n_id: numList[i].n_id,
                    value: numList[i].inital_value,
                    name: numList[i].n_name
                };
                script.cmds.push(["def", numList[i].n_id, numList[i].inital_value, "global"]);
            }
            script.numList = result;
        }

        function parseNumCal(calList) {
            var result = {};
            var temp = 0;
            for (var i in calList) {
                if (typeof result[calList[i].scene_id] == 'undefined') {
                    result[calList[i].scene_id] = {};
                }
                //数值的类型（1、固定数字，2、随机数，3、数值。默认1）
                if (calList[i].valueType == 2) {
                    temp = calList[i].min_value;
                    calList[i].value = calList[i].min_value + "~" + calList[i].max_value;
                } else if (calList[i].valueType == 3) {
                    calList[i].value = calList[i].calculate_nid2;
                }
                result[calList[i].scene_id][calList[i].id] = {
                    n_id: calList[i].n_id,
                    operation: calList[i].operation,
                    calculate_nid1: calList[i].calculate_nid1,
                    valueType: calList[i].valueType,
                    value: calList[i].value
                };
            };
            for (var i in result) {
                if (typeof script.list[i] != "undefined") {
                    script.list[i].calList = result[i];
                }
            }
        }

        function parseNumJump(jumpList) {
            var result = {};
            var tempCondition = {};
            var tempJump = {};
            for (var i in jumpList) {
                result[i] = {};
                result[i]["branch"] = [];
                result[i]["last"] = {};
                for (var j in jumpList[i]) {
                    tempJump = {};
                    tempJump["conditions"] = [];
                    for (var x in jumpList[i][j]) {
                        if (typeof jumpList[i][j][x] == 'object') {
                            tempCondition = {
                                n_id: jumpList[i][j][x].n_id,
                                valueType: jumpList[i][j][x].valueType,
                                operation: jumpList[i][j][x].operation
                            };
                            if (jumpList[i][j][x].valueType == 1) {
                                tempCondition.value = jumpList[i][j][x].value;
                            } else if (jumpList[i][j][x].valueType == 2) {
                                tempCondition.value = jumpList[i][j][x].compare_n_id;
                            }
                            tempJump["conditions"].push(tempCondition);
                        } else {
                            tempJump[x] = jumpList[i][j][x];
                        }
                    }
                    if (tempJump.compare_type == 4) {
                        result[i]["last"] = tempJump;
                    } else {
                        result[i]["branch"].push(tempJump);
                    }
                }
            }
            for (var i in result) {
                if (typeof script.list[i] != "undefined") {
                    script.list[i].jumpList = result[i];
                }
            }
            // return result;
        }

        function parseList(list) {
            var totalSaveNum = 0;
            for (var i in list) {
                if (list[i].savedocument === "true") {
                    totalSaveNum++;
                }
            }
            script.cmds.push(['totalSaveNum', totalSaveNum]);
        }
        //解析背包数据
        function parseItems(items) {
            var list = items ? items.data : [];
            if (list) {
                script.items = [];
                for (var i in list) {
                    var resid = list[i].iconSource.split('resid=')[1];
                    resid = resid + "&w=126&h=126";
                    script.resa.push({
                        name: resid,
                        type: "image",
                        url: resid
                    });
                    script.items.push({
                        idid: list[i].itemId,
                        nid: list[i].numericalId,
                        name: list[i].n_name,
                        key: resid,
                        value: list[i].inital_value
                    })
                }
            }
            script.cmds.push(['bag', script.items]);
        }
        parseToolBox(script.tool_box ? script.tool_box : null);
        parseNumList(script.numericalList ? script.numericalList.list : null);
        parseNumCal(script.toScenelist ? script.toScenelist.list : null);
        parseNumJump(script.conditionJump ? script.conditionJump.list : null);
        parseList(script.list);
        parseItems(script.items);
    }
    vortex.build.reg("img", {
        globalBuild: globalBuild,
        frameBuild: buildImgStroy
    });
})(vortex || (vortex = {}));
////