var vortex;
(function(vortex) {
    var cache = (function() {
        function cache(vm) {
            this.vm = vm;
            this.gameId = vm.script.gameId;
        }
        var d = vortex.define,
            c = cache,
            p = c.prototype;
        var defCachData = function(key, openId) {
            var obj = {};
            if (typeof openId != "undefined" && openId != null) {
                obj[openId] = {};
                obj[openId][key] = {};
            } else {
                obj.local = {};
                obj.local[key] = {};
            }
            return obj;
        }
        var setFrmId = function(obj, gameId, frmId, reviewIds, openId) {
            if (typeof openId != "undefined" && openId != null) {
                if (!obj[openId]) obj[openId] = {};
                obj[openId]["frmId"] = frmId;
                obj[openId]["reviewIds"] = reviewIds;
            } else {
                if (!obj.local) obj.local = {};
                obj.local.frmId = frmId;
                obj.local.reviewIds = reviewIds;
            }
            try {
                egret.localStorage.setItem(gameId, JSON.stringify(obj));
            } catch (error) {}
        }
        var cloneValue = function(object, vars) {
            for (var i in vars) {
                object[i] = vars[i];
            }
            return object;
        }
        var simpClone = function(obj, filter) {
            var res = {};
            for (var i in obj) {
                if (i.indexOf(filter) == -1) {
                    res[i] = obj[i];
                }
            }
            return res;
        }
        var setVars = function(obj, gameId, vars, openId) {
            if (typeof openId != "undefined" && openId != null) {
                if (!obj[openId]) obj[openId] = {};
                obj[openId]["gvars"] = simpClone(vars, "tool");
            } else {
                if (!obj.local) obj.local = {};
                obj.local.gvars = simpClone(vars, "tool");
            }
            try {
                egret.localStorage.setItem(gameId, JSON.stringify(obj));
            } catch (error) {}
        }
        p.setFrmId = function(gameId, frmId, reviewIds, openId) {
            var localData = egret.localStorage.getItem(gameId);
            if (localData == "undefined" || localData == null) {
                localData = defCachData("frmId", openId);
                setFrmId(localData, gameId, frmId, reviewIds, openId);
            } else {
                localData = JSON.parse(localData);
                setFrmId(localData, gameId, frmId, reviewIds, openId);
            }
        }
        p.getFrmId = function(gameId, openId) {
            var localData = egret.localStorage.getItem(gameId);
            var result = [];
            if (localData == "undefined" || localData == null) {
                return false;
            }
            localData = JSON.parse(localData);
            if (typeof openId != "undefined" && openId != null) {
                result.push(localData[openId] && localData[openId].frmId ? localData[openId].frmId : false);
                result.push(localData[openId] && localData[openId].reviewIds ? localData[openId].reviewIds : false);
            } else {
                result.push(localData.local && localData.local.frmId ? localData.local.frmId : false);
                result.push(localData.local && localData.local.reviewIds ? localData.local.reviewIds : false);
            }
            return result;
        }
        p.getLocalUniqueFlag = function() {
            var uniqueFlag = egret.localStorage.getItem('uniqueFlag');
            if (typeof uniqueFlag != 'string') {
                uniqueFlag = new Date().getTime();
                try {
                    egret.localStorage.setItem('uniqueFlag', uniqueFlag);
                } catch (error) {
                    return null
                }
            };
            return uniqueFlag;
        };
        p.getLocalOpenid = function(gameId) {
            var localData = egret.localStorage.getItem(gameId);
            if (localData)
            {
                //如果localData 非法，调用下面方法盒子里会报错
                localData = JSON.parse(localData);
            }
            if (localData == null || typeof localData.local == 'undefined') return null;
            return localData.local.openId;
        }
        p.setLocalOpenid = function(gameId, openId) {
            var localData = egret.localStorage.getItem(gameId);
             if (localData)
             {
                 localData = JSON.parse(localData);
             }
            if (localData == null) {
                localData = {
                    local: {
                        openId: openId
                    }
                }
            };
            try {
                egret.localStorage.setItem(gameId, JSON.stringify(localData));
            } catch (error) {}
        }
        p.setVars = function(gameId, vars, openId) {
            var localData = egret.localStorage.getItem(gameId);
            if (localData == "undefined" || localData == null) {
                localData = defCachData("gvars", openId);
            } else {
                localData = JSON.parse(localData);
            }
            setVars(localData, gameId, vars, openId);
        }
        p.getVars = function(gameId, openId) {
            var localData = egret.localStorage.getItem(gameId);
            if (localData == "undefined" || localData == null) {
                return false;
            }
            localData = JSON.parse(localData);
            var vars;
            if (typeof openId != "undefined" && openId != null) {
                vars = localData[openId].gvars;
            } else {
                vars = localData.local.gvars;
            }
            return vars;
        }
        p.removeGame = function(openId) {
            var localData = egret.localStorage.getItem(this.gameId);
            if (!localData)
            {
              return;
            }

            localData = JSON.parse(localData);
            if (typeof openId != "undefined" && openId != null) {
                delete localData[gameId];
            } else {
                delete localData.local;
            }
            // egret.localStorage.setItem(this.gameId, JSON.stringify(localData));
        }
        p.clrCache = function() {}
        return cache;
    })();
    vortex.cache = cache;
})(vortex || (vortex = {}))