var vortex;
(function(vortex) {
    var cmdGoto = function(cmd, argvs) {
        if (cmd[3] == '-j') {
            this.content.animStop();
            this.animating = false;
        };
        if (this.animating) return;

        var frmid = cmd[1];
        var pause = cmd[2];
        this.pause(pause);
        var frmdata = this.getFrm(frmid);
        if (frmdata) {
            this.content.vortexResource(frmid, frmdata.resa, function() {
                this.showFrame(frmid);
            }, this);
            this.preLoad(frmdata);
        }
        return "break";
    }
    vortex.vm.regCmd("goto", cmdGoto);
    var cmdSystem = function(cmd, argvs) {
        var str = cmd[1];
        this.content.vortexOpenSystem(str);
    }
    vortex.vm.regCmd("system", cmdSystem);
    var cmdGame = function(cmd, argvs) {
        var gameid = cmd[1];
        var gameParams = cmd[2];
        for (var i in gameParams) {
            gameParams[i] = this.exp.expression(gameParams[i], argvs);
        }
        this.content.vortexPlayGame(gameid, gameParams);
        this.pause(true);
    }
    vortex.vm.regCmd("game", cmdGame);
    var cmdTalk = function(cmd, argvs) {
        var name = cmd[1];
        var content = cmd[2];
        var params = cmd[3]
        this.content.vortexTalk(name, content, params);
    }
    vortex.vm.regCmd("talk", cmdTalk);
    var cmdFreshTalk = function(cmd, argvs) {
        this.content.freshTalk(cmd[1]);
    }
    vortex.vm.regCmd("freshTalk", cmdFreshTalk);
    var cmdClrTalk = function(cmd, argvs) {
        this.content.vortexTalk(null, null);
    }
    vortex.vm.regCmd("clrtalk", cmdClrTalk);
    var cmdImg = function(cmd, argvs) {
        var id = cmd[1];
        var resid = cmd[2];
        var params = cmd[3];
        this.content.vortexImageAdd(id, resid, params);
    }
    vortex.vm.regCmd("img", cmdImg);
    var cmdColor = function(cmd, argvs) {
        var id = cmd[1];
        var resid = cmd[2];
        this.content.vortexfunShapeColor(id, resid);
    }
    vortex.vm.regCmd("color", cmdColor);
    var cmdText = function(cmd, argvs) {
        var id = cmd[1];
        var txt = cmd[2];
        var params = cmd[3];
        this.content.vortexTextFieldAdd(id, txt, params);
    }
    vortex.vm.regCmd("text", cmdText);
    var cmdFreshWordBox = function(cmd, argvs) {
        this.content.freshTextField(cmd[1], cmd[2]);
    }
    vortex.vm.regCmd("freshWordBox", cmdFreshWordBox);
    var cmdClip = function(cmd, argvs) {
        var id = cmd[1];
        var resid = cmd[2];
        var actid = cmd[3];
        var params = cmd[4];
        this.content.vortexClipAdd(id, resid, actid, params);
    }
    vortex.vm.regCmd("clip", cmdClip);
    var cmdClipPlay = function(cmd, argvs) {
        var id = cmd[1];
        var resid = cmd[2];
        var actid = cmd[3];
        var playTimes = cmd[4] ? cmd[4] : 1;
        var target = cmd[5] ? cmd[5] : "act"; //在哪一层上
        this.content.vortexClipPlay(id, resid, actid, playTimes, target);
    }
    vortex.vm.regCmd("clipplay", cmdClipPlay);
    var cmdClrObj = function(cmd, argvs) {
        this.content.vortexImageClear();
    }
    vortex.vm.regCmd("clrobj", cmdClrObj);
    var cmdBg = function(cmd, argvs) {
        var resid = cmd[1];
        var animate = cmd[2];
        var animate_old = cmd[3];
        this.content.vortexBackground(resid, animate, animate_old);
    }
    vortex.vm.regCmd("bg", cmdBg);
    var cmdClrBg = function(cmd, argvs) {
        this.content.vortexBackground(null, null);
    }
    vortex.vm.regCmd("clrbg", cmdClrBg);
    var cmdAnim = function(cmd, argvs) {
        var id = cmd[1];
        var anim = cmd[2];
        var tag = cmd[3]; //判断是否是点击事件
        var a = cmd[4];
        if(a){
            this.content.autoSkip = cmd;
        }else{
            this.content.vortexAnim(this.content.vortexGetByName(id), anim, tag);
        }
    }
    vortex.vm.regCmd("anim", cmdAnim);
    var cmdEffect = function(cmd, argvs) {
        var type = cmd[1];
        var resid = cmd[2];
        var params = cmd[3];
        this.content.vortexEffect(type, resid, params);
    }
    vortex.vm.regCmd("effect", cmdEffect);
    var cmdClrEffect = function(cmd, argvs) {
        this.content.vortexEffect(null);
    }
    vortex.vm.regCmd("clreffect", cmdClrEffect);
    var cmdPause = function(cmd, argvs) {
        var value = cmd[1];
        this.pause(value);
    }
    vortex.vm.regCmd("pause", cmdPause);
    var cmdEvt = function(cmd, argvs) {
        var id = cmd[1];
        var filter = cmd[2];
        var cmds = cmd[3];
        this.addEvent(id, filter, cmds);
        // var cmds = cmd[2];
        // this.addEvent(id, cmds);
    }
    vortex.vm.regCmd("evt", cmdEvt);
    var cmdClrEvt = function(cmd, argvs) {
        this.clrEvent();
    }
    vortex.vm.regCmd("clrevt", cmdClrEvt);
    var cmdCmd = function(cmd, argvs) {
        cmds = cmd[1];
        argvs = cmd[2];
        this.doCmds(cmds, argvs);
    }
    vortex.vm.regCmd("cmd", cmdCmd);
    var cmdCall = function(cmd, argvs) {
        var name = cmd[1];
        var arg = cmd[2] ? cmd[2] : {};
        for (var a in arg) {
            arg[a] = this.exp.expression(arg[a], argvs);
        }
        arg.__up__ = argvs ? argvs : this.vars;
        var cmds = this.exp.getVar(name, argvs ? argvs : this.vars);
        if (cmds) {
            this.doCmds(cmds, arg);
        }
    }
    vortex.vm.regCmd("call", cmdCall);
    var cmdLog = function(cmd, argvs) {
        var msg = cmd[1];
        msg = this.exp.expression(msg, argvs);
        console.log(msg);
    }
    vortex.vm.regCmd("log", cmdLog);
    var cmdMsg = function(cmd, argvs) {
        var msg = cmd[1];
        var params = cmd[2];
        msg = this.exp.expression(msg, argvs);
        this.content.vortexMsg(msg, params);
    }
    var cmdDef = function(cmd, argvs) {
        var name = cmd[1];
        var value = cmd[2];
        var pos = cmd[3];
        value = this.exp.expression(value, argvs);
        if (pos === "global") {
            this.gvars[name] = value;
            return;
        }
        if (pos === "frame") {
            this.vars[name] = value;
            return;
        }
        if (argvs) {
            argvs[name] = value;
        }
    }
    vortex.vm.regCmd("def", cmdDef);
    var cmdSet = function(cmd, argvs) {
        if(this.animating){
            return null;
        }
        var name = cmd[1];
        var value = cmd[2];
        var pos = cmd[3];
        value = this.exp.expression(value, argvs);
        if (pos === "global") {
            this.exp.setVar(name, this.gvars, value);
        }
        if (pos === "frame") {
            this.exp.setVar(name, this.vars, value);
        }
        this.exp.setVar(name, argvs, value);
    }
    vortex.vm.regCmd("set", cmdSet);
    var cmdDelToolVars = function() {
        this.delVarWithTool();
    }
    vortex.vm.regCmd("delToolVars", cmdDelToolVars);
    var cmdIf = function(cmd, argvs) {
        var cond = cmd[1];
        var cmdtrue = cmd[2];
        var cmdfalse = cmd[3];
        cond = this.exp.expression(cond, argvs);
        if (cond) {
            this.doCmds(cmdtrue, argvs);
            return "break";
        } else {
            return this.doCmds(cmdfalse, argvs);
        }
    }
    vortex.vm.regCmd("if", cmdIf);
    var cmdWarn = function(cmd, argvs){
        var tips = cmd[1];
        alert(tips);
    }
    vortex.vm.regCmd("warn", cmdWarn);
    var cmdLoop = function(cmd, argvs) {
        var times = cmd[1];
        var cmds = cmd[2];
        times = this.exp.expression(times, argvs);
        for (var i = 0; i < times; i++) {
            var ret = this.doCmds(cmds, argvs);
            if (ret === "break") break;
        }
    }
    vortex.vm.regCmd("loop", cmdLoop);
    var cmdSave = function(cmd, argvs) {
        var type = cmd[1]; //存档类型,forever永久,temp临时存档.
        //TODO 保存
        this.save(type);
    }
    vortex.vm.regCmd("save", cmdSave);
    var cmdMenu = function(cmd, argvs) {
        var type = cmd[1]; //菜单显示隐藏
        //TODO 保存
        this.content.setMenuShow(type);
        // this.save(type);
    }
    vortex.vm.regCmd("menu", cmdMenu);

    var cmdEnd = function(cmd, argvs) {
        var result = cmd[1];
        this.content.vortexEnd(result);
        //TODO 游戏结束,返回结果..等...
    }
    vortex.vm.regCmd("end", cmdEnd);
    var cmdBgm = function(cmd, argvs) {
        var resid = cmd[1];
        var params = cmd[2];
        if (resid == this.bgm) return; //如果是相同音乐不执行
        this.bgm = resid;
        this.content.vortexBgm(resid, params);
    }
    vortex.vm.regCmd("bgm", cmdBgm);
    var cmdClrBgm = function(cmd, argvs) {
        this.bgm = null;
        this.content.vortexBgm(null, null);
    }
    vortex.vm.regCmd("clrbgm", cmdClrBgm);
    var cmdSnd = function(cmd, argvs) {
        var resid = cmd[1];
        var params = cmd[2];
        if (resid == this.snd) return; //如果是相同音效不执行
        this.snd = resid;
        this.content.vortexSnd(resid, params);
    }
    vortex.vm.regCmd("snd", cmdSnd);
    var cmdClrSnd = function(cmd, argvs) {
        this.snd = null;
        this.content.vortexClearSound();
    }
    vortex.vm.regCmd("clrsnd", cmdClrSnd);
    var cmdVce = function(cmd, argvs) {
        var resid = cmd[1];
        var params = cmd[2];
        if (resid == this.vce) return; //如果是相同语音不执行
        this.vce = resid;
        this.content.vortexVce(resid, params);
    }
    vortex.vm.regCmd("vce", cmdVce);
    var cmdClrVce = function(cmd, argvs) {
        this.vce = null;
        this.content.vortexClearVoice();
    }
    vortex.vm.regCmd("clrvce", cmdClrVce);
    var cmdToolBox = function(cmd, argvs) {
        var act = cmd[1];
        // var toolbox_id = cmd[2];
        var toolBg_res = cmd[2];
        var tools = [];
        if (act !== "clear") {
            tools = this.getToolsInToolBox();
        }
        this.content.vortexToolBox(act, toolBg_res, tools);
    }
    vortex.vm.regCmd("toolbox", cmdToolBox);
    var cmdBag = function(cmd, argvs) {
        var list = cmd[1];
        this.content.vortexBag(list);
    }
    vortex.vm.regCmd("bag", cmdBag);
    var cmdTotalSaveNum = function(cmd, argvs) {
        var list = cmd[1];
        this.content.setTotalSaveNum(list);
    }
    vortex.vm.regCmd("totalSaveNum", cmdTotalSaveNum);
    
    var cmdAvatar = function(cmd, argvs) {
        var id = cmd[2];
        var name = cmd[1];
        var pos = cmd[3];
        this.content.vortexAvatarAdd(id,name,pos);
    }
    vortex.vm.regCmd("avatar", cmdAvatar);

    //avatar编辑完成之后的回调。
    var cmdAvatarEdit = function(cmd, argvs) 
     {
        var obj = cmd[1];
        var editData = cmd[2];
        this.content.vortexAvatarChange(obj,editData);
    }
    vortex.vm.regCmd("avatarEdit", cmdAvatarEdit);

})(vortex || (vortex = {}));
////