define(function(require, exports, module) {

    module.exports.setRecordScene = function(_sceneId) {
        if (_.isUndefined(_sceneId)) return;
        set('record_scene', {
            sceneId: _sceneId
        });
    };

    module.exports.getRecordScene = function() {
        return get('record_scene');
    };

    module.exports.clearRecordScene = function(){
        return store.remove('record_scene');
    };

    module.exports.setRecordSceneList = function(_id) {
        var list = get('record_scenelist');
        if (!list) list = [];
        list.push(_id);
        set('record_scenelist', list);
    };

    module.exports.getRecordSceneList = function() {
        return get('record_scenelist');
    };

    module.exports.clearRecordSceneList = function(){
        set('record_scenelist', []);
    };

    //解析并存储数值跳转
    module.exports.numberJump = function(data) {
        var numberJump = data.list;
        set('numberJump', numberJump);
    };

    //获取数值跳转
    module.exports.getNumericalJump = function(){
        return get('numberJump');
    };

    // 解析并存储数值列表
    module.exports.numberList = function(data) {
        var numberList = {};
        _.each(data.list, function(elem, key) {
            numberList[elem.n_id] = elem;
        })
        set('numericalList', numberList);
    };
    //获取数值列表
    module.exports.getNumericalList = function(){
        return get('numericalList');
    };

    //解析并存储背包中的物品
    module.exports.itemList = function(data) {
        var items = {},
            sceneBind = {},
            itemNumber = 0;
        _.each(data.data, function(elem) {
            items[elem.n_id] = {
                numericalId: elem.n_id,
                itemId: elem.itemId,
                iconSource: elem.iconSource,
                name: elem.n_name
            };
            itemNumber++;
        });
        set('showBagFlag', itemNumber >= 1);
        set('itemList', items);
    };
    //获取背包是否显示的标志
    module.exports.getBagFlag = function(){
        return get('showBagFlag');
    };
    //获取物品列表
    module.exports.getItemList = function(){
        return get('itemList');
    };


    // 解析并存储数值运算
    module.exports.calByScene = function(data) {
        var sceneNums = {},
            tmp;
        _.each(data.list, function(elem) {
            if (_.isUndefined(sceneNums[elem.scene_id])) sceneNums[elem.scene_id] = [];
            var calculate_nid1 = elem.calculate_nid1;
            if (typeof calculate_nid1 == 'undefined' || calculate_nid1 == null) {
                calculate_nid1 = elem.n_id;
            };

            sceneNums[elem.scene_id].push({
                numId: elem.n_id,
                value: elem.value,
                operation: elem.operation,
                valueType: elem.valueType, //数值的类型（1、固定数字，2、随机数，3、数值。默认1）
                calculate_nid1: calculate_nid1, //数值的id(表示被加数的数值）
                min_value: elem.min_value, //随机数的最小值（默认0）
                max_value: elem.max_value, //随机数的最大值（默认100）
                calculate_nid2: elem.calculate_nid2 //数值的id(表示加数的数值)
            });
        });
        set('calByScene', sceneNums);
    };

    //获取数值运算
    module.exports.getCalByScene = function(){
        return get('calByScene');
    };

    //获取要准备的剧情页
    module.exports.getCurrentScene = function(){
        return get('currentScene');
    };
    //标记要准备的剧情页
    module.exports.setCurrentScene = function(_scene){
        set('currentScene', _scene);
    };
    //删除要准备的剧情页
    module.exports.delCurrentScene = function(){
        del('currentScene');
    };

    //设置显示出来的剧情页
    module.exports.setRenderScene = function(_scene){
        set('renderScene', _scene);
    }
    //获取显示的剧情
    module.exports.getRenderScene = function(){
        return get('renderScene');
    }
    //删除要显示的剧情
    module.exports.delRenderScene = function(){
        del('renderScene');
    }

    //设置暂停标记
    module.exports.setNext_flag = function(_flag){
        return set('next_flag', _flag);
    }
    //设置展厅标记
    module.exports.getKey = function(_id) {
        var keyList = get('keys'),
            result;
        _.each(keyList, function(elem) {
            if (elem.id === _id) result = elem;
        });
        return result;
    };

    module.exports.setKey = function(_id, _save) {
        var keyList = get('keys'),
            index = null;
        if (!keyList) keyList = [];
        _.each(keyList, function(elem, key) {
            if (elem.id === _id) index = key;
        });
        _save = _.extend({}, _save, {
            record_var: get('record_var')
        });
        if (index !== null) {
            keyList[index] = _save;
        } else {
            keyList.push(_save);
        }
        set('keys', keyList);
    };

    //设置默认颜色
    module.exports.setDefaultColor = function(_color){
        var init = get('INIT');
        if (!init) init = {};
        if(!init.plainStyle) init.plainStyle = {};
        init.plainStyle.color = _color;
        set('INIT', init);
    };
    //获取默认颜色
    module.exports.getDefaultColor = function(){
        var init = get('INIT');
        if (!init || _.isUndefined(init.plainStyle) || _.isUndefined(init.plainStyle.color)) return false;
        return init.plainStyle.color;
    };
    //设置默认对齐方式
    module.exports.setDefaultDirection = function(_direction){
        var init = get('INIT');
        if (!init) init = {};
        if(!init.plainStyle) init.plainStyle = {};
        init.plainStyle.textAlign = _direction;
        set('INIT', init);
    };
    //获取默认对其方式
    module.exports.getDefaultDirection = function(){
        var init = get('INIT');
        if (!init || _.isUndefined(init.plainStyle) || _.isUndefined(init.plainStyle.textAlign)) return false;
        return init.plainStyle.textAlign;
    };

    // 获取
    function get(name) {
        return store.get(name);
    }
    module.exports.get = get;

    // 设置
    function set(name, data) {
        store.set(name, data);
    }
    module.exports.set = set;

    // 删除
    function del(name) {
        if (_.isArray(name)) {
            return _.each(name, function(elem) {
                store.remove(elem);
            });
        }
        store.remove(name);
    }

    module.exports.del = del;

    module.exports.getAll = function() {
        return store.getAll();
    };

    module.exports.delAll = function(_except, _callback) {
        if (_except) {
            _except = _.isString(_except) ? [_except] : _except;
            var _temp = {};
            _.each(_except, function(_elem) {
                _temp[_elem] = get(_elem);
            });
            store.clear();
            _.each(_temp, function(elem, key) {
                set(key, elem);
            });
        } else {
            store.clear();
        }
        if (typeof _callback === 'function') return _callback();
    };

});
