define(function(require, exports, module) {

    var Cube = function() {
        var CUBE = {
            _id: '',
            attrs: {},
            children: [],
            parent: {},
            selector: {}
        };

        // 绘制
        var drawList = {
            width: setWidth,
            height: setHeight,
            minHeight: setMinHeight,
            w: setWidth,
            h: setHeight,
            x: setX,
            y: setY,
            id: setId,
            background: setBackground,
            backgroundColor:setbackgroundColor,
            hide: setHide,
            overflow: setOverflow,
            fontSize: setFontsize,
            lineHeight: setLineHeight,
            color: setColor,
            name: setName,
            text: setText,
            textAlign:setTextAlign
        }


        var child = '.cube-c';

        // 设置宽度
        function setWidth(_w) {
            if (_.isNumber(_w * 1)) _w += 'px';
            CUBE.selector.width(_w);
            CUBE.selector.children(child).width(_w);
        }

        // 设置高度
        function setHeight(_h) {
            if (_.isNumber(_h * 1)) _h += 'px';
            CUBE.selector.css('height', _h);
            CUBE.selector.children(child).css('height', _h);
            // CUBE.selector.height(_h);
            // CUBE.selector.children(child).height(_h);
        }
        //设置最小高度
        function setMinHeight (_h){
             if (_.isNumber(_h * 1)) _h += 'px';
            CUBE.selector.css('min-height', _h);
            // CUBE.selector.children(child).height(_h);
        }
        // 设置居左位置
        function setX(_x) {
            //    console.log(CUBE.selector,_x)
            if (_.isNumber(_x * 1)) _x += 'px';
            CUBE.selector.css('left', _x);
        }

        // 设置居上位置
        function setY(_y) {
            if (_.isNumber(_y * 1)) _y += 'px';
            CUBE.selector.css('top', _y);
        }

        // 设置Id
        function setId(_id) {
            CUBE.selector.data('id', _id);
            CUBE.selector.attr('data-nodeId', _id)
            CUBE.selector.addClass(_id);
        }

        // 设置 hide
        function setHide(_hide) {
            if (_hide) CUBE.selector.hide();
        }

        // 设置背景
        function setBackground(_background) {
            var child = CUBE.selector.children(child);
            if (!child.children('.cube_bg').length) {
                child.append('<div class="cube_bg"></div>');
            }
            background = child.children('.cube_bg');
            //child.children('.cube_bg').remove()
            background.removeAttr('class');
            background.addClass(_background + ' sprite cube_bg');
        }

        function setbackgroundColor(_color){
            var child = CUBE.selector.children(child);
            if (!child.children('.cube_bgc').length) {
                child.append('<div class="cube_bgc"></div>');
            }
            background = child.children('.cube_bgc');
            background.css('background-color',_color);
            background.css({
                width:CUBE.selector.css('width'),
                height:CUBE.selector.css('height')
            })
        }

        // 构造舞台DOM
        function buildStageDOM() {
            return $('<div id="cube_container" class="cube-p"><div class="cube-c"></div></div>');
        }

        // 构造元素DOM
        function buildElemDOM() {
            return $('<div class="cube-p"><div class="cube-c"></div></div>');
        }
        // 构造加载时的loading
        function buildLoadingDOM() {
            return $('<div class="cube-p"><div class="cube-loading"></div></div>');
        }

        function setFontsize(_fontSize) {
            CUBE.selector.children(child).css('fontSize', _fontSize)
        }

        function setLineHeight(_lineHeight) {
            CUBE.selector.children(child).css('lineHeight', _.isNumber(_lineHeight) ? (_lineHeight + 'px') : _lineHeight);
        }

        function setColor(_color) {
            CUBE.selector.children(child).css('color', _color)
        }

        function setName(_name) {
            CUBE.selector.children(child).addClass(_name);
        }

        function setText(_text) {
            CUBE.selector.children(child).html(_text);
        }

        function setTextAlign(_align){
            CUBE.selector.children(child).css('textAlign',_align);
        }

        function draw() {
            _.each(CUBE.attrs, function(elem, key) {
                !_.isUndefined(drawList[key]) && _.isFunction(drawList[key]) && drawList[key].call(this, elem);
            });
        }

        function find(_cubeObj, _where, result) {
            _.each(_cubeObj.children, function(elem) {
                if (elem.getAttr('id') == _where) result.push(elem);
                _.size(elem.children) && find(elem, _where, result);
            })
        }

        function setOverflow(_overflow) {
            CUBE.selector.children(child).css('overflow', _overflow)
        }

        // 舞台
        CUBE.Stage = function(_attrs) {
            if (_.isUndefined(_attrs.container) || _attrs.container == '') return console.error('No container set.');
            var container = $('#' + _attrs.container),
                stage = buildStageDOM(),
                children = stage.children(child);

            children.width(stage.width());
            children.height(stage.height());
            container.append(stage);
            CUBE.selector = stage;
            _.extend(CUBE.attrs, _attrs);
            return CUBE;
        }

        // 元素
        CUBE.Elem = function(_attrs) {
            var elem = buildElemDOM();
            CUBE.selector = elem;
            _.extend(CUBE.attrs, _attrs);
            draw();
            return CUBE;
        }

        // 新增节点
        CUBE.add = function(_node) {
            var zIndex = 1;
            if (CUBE.selector.data('zIndexCounter'))
                zIndex = CUBE.selector.data('zIndexCounter');
            _node.selector.css('z-index', zIndex);
            _node.setAttr('zIndex', zIndex);
            CUBE.selector.children(child).append(_node.selector);
            CUBE.children.push(_node);
            CUBE.selector.data('zIndexCounter', zIndex++);
        }

        // 查找节点
        CUBE.find = function(_tag) {
            var result = [];
            find(CUBE, _tag, result);
            return result;
        }

        CUBE.findOne = function(_tag) {
            var result = [];
            find(CUBE, _tag, result);
            return _.size(result) ? result[0] : [];
        }

        CUBE.getAttr = function(_attrName) {
            return CUBE.attrs[_attrName];
        }

        CUBE.getId = function() {
            return CUBE.attrs.id;
        }

        // 设置单个属性
        CUBE.setAttr = function(_attrName, _value) {
            CUBE.attrs[_attrName] = _value;
        }

        // 设置批量属性
        CUBE.setAttrs = function(_attrsList) {
            _.each(_attrsList, function(_value, _attrName) {
                CUBE.attrs[_attrName] = _value;
            });
        }

        // 绘制节点
        CUBE.draw = function() {
            if (_.size(CUBE.children))
                _.each(CUBE.children, function(elem) {
                    elem.draw();
                });
            draw();
        };

        CUBE.width = function() {
            return CUBE.selector.width();
        }

        CUBE.height = function() {
            return CUBE.selector.height();
        }

        CUBE.on = function(_eventList, callback) {
            CUBE.selector.on(_eventList, callback);
            return CUBE;
        }

        CUBE.off = function(_eventList) {
            CUBE.selector.off(_eventList);
            return CUBE;
        }

        CUBE.show = function() {
            return CUBE.selector.show();
        }

        CUBE.hide = function() {
            return CUBE.selector.hide();
        }

        CUBE.size = function(_size) {
            setWidth(_size.width);
            setHeight(_size.height);
            setMinHeight(_size.minHeight);
        }

        CUBE.getElem = function() {
            return CUBE.selector;
        }

        CUBE.setBackground = function(_background) {
            CUBE.attrs.background = _background;
            draw();
        }

        CUBE.text = function(_text) {
            CUBE.selector.children(child).html(_text);
            return CUBE;
        }

        CUBE.append = function(_content) {
            console.log(_content)
            CUBE.selector.children(child).append(_content);
            return CUBE;
        }

        CUBE.clone = function() {
            var _cube = _.cloneDeep(CUBE);
            console.log(_cube == CUBE)
            _cube.selector = _cube.selector.clone();
            return _cube;
        }

        return CUBE;
    }


    module.exports.create = function() {
        return new Cube();
    }

});
