// 调度模块
define(function(require, exports, module) {

    var script = {},
        _eventProxy = {},
        gameid = '',
        netModule = require('Net'),
        Cache = require('Cache'),
        Variate = require('Variate');
        resourceModule = require('Resource');

    var SCENES = {},
        BLOCKS = {},
        global = {},
        VARIATE = {},
        initId = false,
        START = '',
        scenesList = [],
        SCENES_FLAT = {},
        keyList = [],
        audioList = {},
        audioGroup = [];
    var openFrom = request('type');
    var ua = navigator.userAgent.toLowerCase();

    //获取这个剧情页以后要加载的音乐
    function getpreLoadList(_sceneId) {
        var i = 0,
            flag = i,
            resourceList = [];
        _.each(SCENES, function(elem, key) {
            if (key == _sceneId) {
                flag = i;
            }
            if (i > flag) {
                // 背景音乐
                if (elem.music && typeof elem.music == 'object' && !resourceModule.checkSoundLoaded(elem.music.resid)) {
                    resourceList.push({
                        id: elem.music.resid,
                        src: netModule.audioUrl(elem.music.resid),
                        attr: 'music',
                        type: 'audio'
                    });
                }
                //音效
                if (elem.sound && typeof elem.sound == 'object' && !resourceModule.checkSoundLoaded(elem.sound.resid)) {
                    resourceList.push({
                        id: elem.sound.resid,
                        src: netModule.audioUrl(elem.sound.resid),
                        attr: 'sound',
                        type: 'audio'
                    });
                }
            }
            i++;
        });
        return resourceList;
    }

    // 解析脚本

    function parseScript(_script, _new) {
        var sceneVariates = _script.scenesvar,
            tmp;
        // 准备剧情
        SCENES = _script.list;
        START = _script.start;
        global = _script.global;
        //获取默认元素
        Cache.setDefaultColor(undefined);
        Cache.setDefaultDirection(undefined);
        if(global.plainStyle){
            if(global.plainStyle.color && global.plainStyle.color !==''){
                Cache.setDefaultColor(global.plainStyle.color);
            }
            if(global.plainStyle.textAlign && global.plainStyle.textAlign !==''){
                Cache.setDefaultDirection(global.plainStyle.textAlign);
            }
        }

        //处理数值相关的问题
        if(_script.numericalList){
            Cache.numberList(_script.numericalList);
            VARIATE.numericalList = _script.numericalList;
        }
        if(_script.conditionJump){
            Cache.numberJump(_script.conditionJump);
            VARIATE.conditionJump = _script.conditionJump;
        }
        // Cache.itemList(_script.);
        if(_script.toScenelist){
            Cache.calByScene(_script.toScenelist);
            VARIATE.toScenelist = _script.toScenelist;
        }

        Variate.init(Cache.getNumericalList(), Cache.getNumericalJump(), Cache.getCalByScene(), Cache.getItemList());

        //处理文本剧情页的音乐、音效
        _.each(SCENES, function(elem, key) {
            if (elem.savedocument && elem.savedocument == 'true')
                keyList.push(elem.sceneId);

            tmp = {};
            // 资源列表
            tmp.resources = {
                sounds: []
            };

            // 解析音频
            tmp.sound = {};
            tmp.sound.backMusic = false;
            tmp.sound.effect = false;
            tmp.sound.voice = false;
            // 背景音乐
            if (elem.music && typeof elem.music == 'object') {
                tmp.sound.backMusic = elem.music.resid;
                // 压入资源
                tmp.resources.sounds.push(elem.music.resid);
                audioList[elem.music.resid] = {
                    id: elem.music.resid,
                    path: netModule.audioUrl(elem.music.resid),
                    attr: 'music',
                    type: 'audio'
                };
                audioGroup.push(audioList[elem.music.resid]);
            }
            //音效
            if (elem.sound && typeof elem.sound == 'object') {
                tmp.sound.effect = elem.sound.resid;
                tmp.resources.sounds.push(elem.sound.resid);
                audioList[elem.sound.resid] = {
                    id: elem.sound.resid,
                    path: netModule.audioUrl(elem.sound.resid),
                    attr: 'sound',
                    type: 'audio'
                };
                audioGroup.push(audioList[elem.music.resid]);
            }
        });
        var i = 0;
        // var openFrom = request('type');
        // var ua = navigator.userAgent.toLowerCase();
        // if(openFrom == 'box'){
        //     if (/android/.test(ua)) {

        //     } else {
        //         ocPreDownLoadMusic(audioGroup[0]['id']);
        //     }
        // }
        // resourceModule.loadList(audioList, function(_sound) {
            // console.log(_sound);
            // _eventProxy.trigger('SOUND_PLAY', 'background');
        // });
        // 对背景音乐进行处理
        // if (!_.isUndefined(_script.init) && !_.isUndefined(_script.init.music)) {
        //     var list = [{
        //         id: 'background',
        //         path: netModule.audioUrl(_script.init.music),
        //         attr: 'music'
        //     }];

        //     return resourceModule.loadList(list, function(_sound) {
        //         _eventProxy.trigger('SOUND_PLAY', 'background');
        //     });
        // }
    }

    function resetVariate(){
        if(VARIATE.numericalList){
            Cache.numberList(VARIATE.numericalList);
        }
        if(VARIATE.conditionJump){
            Cache.numberJump(VARIATE.conditionJump);
        }
        if(VARIATE.toScenelist){
            Cache.calByScene(VARIATE.toScenelist);
        }
        Variate.init(Cache.getNumericalList(), Cache.getNumericalJump(), Cache.getCalByScene(), Cache.getItemList());
    }
    module.exports.resetVariate = resetVariate;

    function makeBranchList(selectText) {
        var list = [];
        _.each(selectText, function(elem) {
            list.push({
                id: elem.sceneId,
                text: elem.text
            });
        });
        return list;
    }

    // function makeBranchList(blockA, blockB) {
    //     var list = [];
    //     _.each(arguments, function(elem) {
    //         list.push({
    //             id: elem.sceneId,
    //             text: elem.text
    //         });
    //     });
    //     return list;
    // }

    function compareVariate(_value, min, max) {
        min *= 1;
        max *= 1;
        if (_.isUndefined(max))
            return _value >= min;
        if (_.isUndefined(min))
            return _value <= max;
        return min <= _value && _value <= max;
    }

    //判断资源的加载
    function checkSceneResource(scene, hasMusicCallback, noMusicCallback) {
        if (scene.music && scene.music.resid && !resourceModule.checkSoundLoaded(scene.music.resid) || scene.sound && scene.sound.resid && !resourceModule.checkSoundLoaded(scene.sound.resid)) {
            var list = [];
            if (scene.music && scene.music.resid && !resourceModule.checkSoundLoaded(scene.music.resid))
                list.push({
                    id: scene.music.resid,
                    path: netModule.audioUrl(scene.music.resid),
                    attr: 'music',
                    type: 'audio'
                });
            if (scene.sound && scene.sound.resid && !resourceModule.checkSoundLoaded(scene.sound.resid))
                list.push({
                    id: scene.sound.resid,
                    path: netModule.audioUrl(scene.sound.resid),
                    attr: 'music',
                    type: 'audio'
                });
            hasMusicCallback(list);
        
        } else {
            noMusicCallback();
            // _eventProxy.trigger('renderNextScene', _sceneId);
        }
    }

    //根据剧情类型决定去向
    function judgeSceneType(scene){
        //-1表示选项的剧情页
        Cache.setCurrentScene(scene);
        Variate.calcByScene(scene.sceneId, false);
        if (scene.type == -1 && scene.selectText) {
            var selectText = scene.selectText;
            // // 判断是否需要显示分支选项
            // if (!_.isUndefined(selectText['1']) && !_.isUndefined(selectText['1'].sceneId) || !_.isUndefined(selectText['2'])  && !_.isUndefined(selectText['2'].sceneId)) {
                if (_.includes(keyList, scene.sceneId)) _eventProxy.trigger('setKey', scene.sceneId);
                Cache.setRecordScene(scene.sceneId);
                return _eventProxy.trigger('setBranch', scene, makeBranchList(selectText));
                // return _eventProxy.trigger('setBranch', scene, makeBranchList(selectText['1'], selectText['2']));
            // }

            // return _eventProxy.trigger('end');
        } else if(scene.type == -1) {
            return _eventProxy.trigger('end');
        }
        _eventProxy.trigger('renderNextScene', scene.sceneId);
    }

    // 渲染指定的脚本ID内容
    module.exports.prepare = function(_sceneId, isFromRecord) {
        if(isFromRecord)
            store.set('overView', false);
        if (_sceneId == 'init') {
            var _record = Cache.getRecordScene();
            if (_record && SCENES[_record.sceneId]) {
                return _eventProxy.trigger('selectStart' ,function(choice){
                    if(choice == 'Y'){
                        return _eventProxy.trigger('prepare', _record.sceneId);
                    } else {
                        // _eventProxy.trigger('prepare', 'init');
                        if(Stone.get('solaid') !== 'all' && typeof Stone.get('solaid') == 'string' && Stone.get('solaid') !== '')
                            return _eventProxy.trigger('prepare', Stone.get('solaid'));
                        return _eventProxy.trigger('prepare', START);
                    }
                });
            } else {
                if(Stone.get('solaid') !== 'all' && typeof Stone.get('solaid') == 'string' && Stone.get('solaid') !== '')
                    return _eventProxy.trigger('prepare', Stone.get('solaid'));
                return _eventProxy.trigger('prepare', START);
            }

            // if(store.get('solaid') !== 'all')
            //     return _eventProxy.trigger('prepare', store.get('solaid'));
            // return _eventProxy.trigger('prepare', START);
        }
        var scene = SCENES[_sceneId];
        if (_.isUndefined(scene)) return _eventProxy.trigger('end');
        // Cache.setCurrentScene(scene);
        // console.log("正常走");
        //-1表示选项的剧情页
        // if (scene.type == -1 && scene.selectText) {
        //     var selectText = scene.selectText;
        //     // 判断是否需要显示分支选项
        //     if (!_.isUndefined(selectText['1']) && !_.isUndefined(selectText['1'].sceneId) || !_.isUndefined(selectText['2'])  && !_.isUndefined(selectText['2'].sceneId)) {
        //         return _eventProxy.trigger('setBranch', _sceneId, makeBranchList(selectText['1'], selectText['2']));
        //     }

        //     return _eventProxy.trigger('end');
        // } else if(scene.type == -1) {
        //     return _eventProxy.trigger('end');
        // }
        if (scene.music && scene.music.resid && !resourceModule.checkSoundLoaded(scene.music.resid) || scene.sound && scene.sound.resid && !resourceModule.checkSoundLoaded(scene.sound.resid)) {
            var list = [];
            var musicListStr = '';
            if (scene.music && scene.music.resid && !resourceModule.checkSoundLoaded(scene.music.resid)){
                list.push({
                    id: scene.music.resid,
                    path: netModule.audioUrl(scene.music.resid),
                    attr: 'music',
                    type: 'audio'
                });
                _eventProxy.trigger('markMusic', scene.music.resid, 'music');
            }
            if (scene.sound && scene.sound.resid && !resourceModule.checkSoundLoaded(scene.sound.resid)){
                list.push({
                    id: scene.sound.resid,
                    path: netModule.audioUrl(scene.sound.resid),
                    attr: 'sound',
                    type: 'audio'
                });
                _eventProxy.trigger('markMusic', scene.sound.resid, 'sound');
            }
            if(list.length > 0 ){
                _eventProxy.trigger('showLoading');
                _eventProxy.trigger('loadingMusic');
                for(var i in list){
                    if(i == list.length - 1){
                        musicListStr += list[i].id;
                    } else {
                        musicListStr = musicListStr + list[i].id + ',';
                    }
                }
            }

            if(/iphone|ipad|ipod|iOS/.test(ua) && openFrom == 'box'){
                _eventProxy.trigger('loadMusicInBox', musicListStr, scene);
            } else {
                return resourceModule.loadList(list, function() {
                    // _eventProxy.trigger('renderNextScene', _sceneId);
                    _eventProxy.trigger('hideLoading');
                    _eventProxy.trigger('loadingComplete');
                    judgeSceneType(scene);
                    // resourceModule.loadList(getpreLoadList(_sceneId), function() {
                    
                    // });
                });
            }



        } else {
            judgeSceneType(scene);
            // _eventProxy.trigger('renderNextScene', _sceneId);
        }
        // _eventProxy.trigger('renderNextScene', _sceneId);

    };

    module.exports.renderNextScene = function(_sceneId, isFromRecord) {
        if(isFromRecord)
            store.set('overView', false);
        
        if (!_.isUndefined(SCENES[_sceneId])) {
            _eventProxy.trigger('showLoading');
            var _scene = SCENES[_sceneId];
            if (!_scene || _.isUndefined(_scene.content)) return _eventProxy.trigger('end');
            // var _content = _scene.content;
            if (_.includes(keyList, _sceneId)) _eventProxy.trigger('setKey', _sceneId);
            Cache.setRecordScene(_sceneId);
            _eventProxy.trigger('setMessage', _scene, function() {
                var next = _scene.next;
                if (_scene.end && _scene.end == 'true')
                    return _eventProxy.trigger('end');
                if (_scene.skipScene && _scene.skipScene.sceneId)
                    next = _scene.skipScene.sceneId;
                if (_scene.savedocument && _scene.savedocument == 'true') {
                    Cache.setRecordSceneList(_scene.sceneId, _scene.content);
                }
                var numericalTo = Variate.calcByScene(_scene.sceneId, true);
                next = numericalTo ? numericalTo : next;
                Cache.setRenderScene(_scene);
                _eventProxy.trigger('prepare', next);
            });
            return;
        }
        return _eventProxy.trigger('end');
        // return _eventProxy.trigger('blockEnd');
    };

    function prepareSceneWithMusic(list, scene){
        return resourceModule.loadList(list, function() {
            // _eventProxy.trigger('renderNextScene', _sceneId);
            judgeSceneType(scene);
            // resourceModule.loadList(getpreLoadList(scene.sceneId), function() {

            // });
        });
    }


    module.exports.read = function(data) {
        return netModule.getJSON(data, function(json) {
            var _record = Cache.getRecordScene();
            var _scene;
            parseScript(json, _record ? false : true);
            if (_record) {
                _scene = SCENES[_record.sceneId];
                checkSceneResource(_scene, prepareSceneWithMusic(list, _scene), judgeSceneType(_scene));
                _eventProxy.trigger('prepare', _record.blockId, _record.sceneId);

            } else {
                _scene = SCENES[START];
                _eventProxy.trigger('prepare', 'init');
            }

        });
    };

    //加载脚本后的方法
    function afterLoadScripte(json){
        return Thenjs(function(cont) {
            // 加载UI
            var init = json.global,
                setting = {
                    ui: './plainText/assets/DefaultUI/UI_css.json',
                    sprite: './plainText/assets/DefaultUI/sprite_css.png',
                    css: './plainText/assets/DefaultUI/sprite_css.css'
                };
            Stone.set('gameInit', init);
            if (typeof callback == 'function') {
                callback();
            };

            if (init.skin) {
                var skin = _.replace(init.skin, 'skin/', '');
                skin = skin.replace('flower', 'Flower');
                if(skin[0] == '/'){
                    skin = skin.substring(1);
                }
                setting.ui = './plainText/assets/' + skin + '/UI_css.json';
                setting.sprite = './plainText/assets/' + skin + '/sprite_css.png';
                setting.css = './plainText/assets/' + skin + '/sprite_css.css';
            }
            //兼容老版本
            if (window.location.href.indexOf('/plain-text') > -1) {
                setting = {
                    ui: './assets/DefaultUI/UI_css.json',
                    sprite: './assets/DefaultUI/sprite_css.png',
                    css: './assets/DefaultUI/sprite_css.css'
                };
                if (init.skin) {
                    var skin = _.replace(init.skin, 'skin/', '');
                    var skin = _.replace(init.skin, 'skin/', '');
                    skin = skin.replace('flower', 'Flower');
                    if(skin[0] == '/'){
                        skin = skin.substring(1);
                    }
                    setting.ui = './assets/' + skin + '/UI_css.json';
                    setting.sprite = './assets/' + skin + '/sprite_css.png';
                    setting.css = './assets/' + skin + '/sprite_css.css';
                }
            }
            return _eventProxy.trigger('buildUI', setting, function() {
                cont();
            });

        }).then(function() {
            var _record = Cache.getRecordScene();
            parseScript(json, _record ? false : true);
            _eventProxy.trigger('setStart');
            var type = request('type');
            if (type != 'box' && type != 'preview') {
                $('.iplay_header').css('display', 'block');
            }
            $('#downClose').off('click').on('click', function() {
                $('.iplay_header').hide();
            });
            _eventProxy.trigger('prepare', 'init');

        });
    }
    // load script
    module.exports.load = function(_gameId, callback) {
        _gameId != Cache.get('gameid') && Cache.del(['record_scene', 'record_var', 'blockId']);
        if(openFrom == 'box'){
            var path ='';
            if(/iphone|ipad|ipod|iOS/.test(ua)) {
                path = ocGetGameJsPath();
            } else if(/android/.test(ua)) {
                path = window.android_h5.getFileCatalog();
            }
            return netModule.getJSON(path, function(json) {
                afterLoadScripte(json);
            });
        } else {
            return netModule.getGameScript(_gameId, function(json) {
                afterLoadScripte(json);
            });
        }


        // return netModule.getGameScript(_gameId, function(json) {
        //     return Thenjs(function(cont) {
        //         // 加载UI
        //         var init = json.global,
        //             setting = {
        //                 ui: './plainText/assets/DefaultUI/UI_css.json',
        //                 sprite: './plainText/assets/DefaultUI/sprite_css.png',
        //                 css: './plainText/assets/DefaultUI/sprite_css.css'
        //             };
        //         Stone.set('gameInit', init);
        //         if (typeof callback == 'function') {
        //             callback();
        //         };

        //         if (init.skin) {
        //             var skin = _.replace(init.skin, 'skin/', '');
        //             if(skin.indexOf('flower') > -1)
        //                 skin.replace('flower', 'Flower');
        //             setting.ui = './plainText/assets/' + skin + '/UI_css.json';
        //             setting.sprite = './plainText/assets/' + skin + '/sprite_css.png';
        //             setting.css = './plainText/assets/' + skin + '/sprite_css.css';
        //         }
        //         //兼容老版本
        //         if (window.location.href.indexOf('/plain-text') > -1) {
        //             setting = {
        //                 ui: './assets/DefaultUI/UI_css.json',
        //                 sprite: './assets/DefaultUI/sprite_css.png',
        //                 css: './assets/DefaultUI/sprite_css.css'
        //             };
        //             if (init.skin) {
        //                 var skin = _.replace(init.skin, 'skin/', '');
        //                 setting.ui = './assets/' + skin + '/UI_css.json';
        //                 setting.sprite = './assets/' + skin + '/sprite_css.png';
        //                 setting.css = './assets/' + skin + '/sprite_css.css';
        //             }
        //         }
        //         return _eventProxy.trigger('buildUI', setting, function() {
        //             cont();
        //         });

        //     }).then(function() {
        //         var _record = Cache.getRecordScene();
        //         parseScript(json, _record ? false : true);
        //         _eventProxy.trigger('setStart');
        //         var type = request('type');
        //         if (type != 'box' && type != 'preview') {
        //             $('.iplay_header').css('display', 'block');
        //         }
        //         $('#downClose').off('click').on('click', function() {
        //             $('.iplay_header').hide();
        //         });
        //         _eventProxy.trigger('prepare', 'init');

        //     });
        // });
    };

    // 事件处理对象
    module.exports.eventProxy = function(_ep) {
        _eventProxy = _ep;
        _eventProxy.unbind('setKey').on('setKey', function(_sceneId) {
            var save = {
                id: _sceneId,
                name: SCENES[_sceneId].scenePath,
                variate: Variate.snapshot(),
                date: date('yyyyMMdd')
            };
            Cache.setKey(_sceneId, save);
        });

        _eventProxy.on('afterLoadMusicInBox', function(_scene){
            _eventProxy.trigger('hideLoading');
            _eventProxy.trigger('loadingComplete');
            judgeSceneType(_scene);
        });

    };

});