// 事件模块
define(function(require, exports, module) {
    var Modules = {},
        storyReview = [],
        shareflag = true;
    var _eventProxy = new EventProxy();
    var VARIATE = {};
    var next_flag = true,
        loading_flag = true,
        branch_status = false;
    var Cache = require('Cache'),
        resourceModule = require('Resource'),
        config = require('../configure'),
        Variate = require('Variate');
    Cache.setNext_flag(next_flag);
    // 配置模块
    module.exports.setModule = function(_moduleName, _module) {
        Modules[_moduleName] = _module;
        _module.eventProxy(_eventProxy);
    };

    function showShareByDevice() {
        if ((navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i))) {
            Modules.UI.hide("SHARE-WEIBO");
            Modules.UI.hide("SHARE-WEIXIN");
            Modules.UI.hide("SHARE-QZONE");
            Modules.UI.hide("BUTTONS_BAK");
        } else {
            Modules.UI.hide("BUTTONSHARE");
            Modules.UI.hide("BUTTONS");
        }
    }
    module.exports.bindBase = function() {
        var start = false,
            overflag = false,
            indexStart = 0,
            splahOver = false;
        var openFrom = request('type');
        var scriptId = 0;
        var PREPARE = {};
        // //数值相关初始化
        // _eventProxy.on('initNumerical', function(numberList, numberJump, numberCal, itemList){
        //     Variate.init(numberList, numberJump, numberCal, itemList);
        // });
        _eventProxy.on('prepare', function(_sceneId, isFromRecord) {
            if (splahOver && next_flag) {
                Modules.Dispatch.prepare(_sceneId, isFromRecord);
                if (Cache.getDefaultDirection()) $('.ACTIVITY_CONTAINER').css('text-align', Cache.getDefaultDirection());
                if (Cache.getDefaultColor()) $('.ACTIVITY_CONTAINER .cube-c').css('color', Cache.getDefaultColor());
            }
            // PREPARE.scriptId = _sceneId;
            PREPARE.sceneId = _sceneId;
        });
        _eventProxy.on('splashOver', function() {
            splahOver = true;
            return start && _.size(PREPARE) && _eventProxy.trigger('prepare', 'init');
        });
        _eventProxy.on('setStart', function() {
            start = true;
        });
        _eventProxy.on('restart_game', function() {
            Cache.delAll(null, function() {
                // require('../player_css').init('container');
                _eventProxy.trigger('settingModuleClose');
                Modules.Dispatch.resetVariate();
                Modules.UI.clearList();
                overflag = false;
                _eventProxy.trigger('prepare', 'init');
                // window.location.href = window.location.href;
            });
        });
        _eventProxy.on('selectStart', function(_callback) {
            Modules.UI.selectStart(_callback);
        });
        // var timerFlag = true;
        _eventProxy.on('renderNextScene', function(_sceneId, isFromRecord) {
            Modules.Dispatch.renderNextScene(_sceneId, isFromRecord);
            // next_flag && Modules.Dispatch.renderNextScene(_sceneId, isFromRecord);
        });
        _eventProxy.on('setNextScript', function(_scriptId) {
            scriptId = _scriptId;
        });
        _eventProxy.on('setMessage', function(_id, _content, _delay, _callback) {
            Modules.UI.message(_id, _content, _delay, _callback);
        });
        _eventProxy.on('makeMessageList', function(list) {
            Modules.UI.messageList(list);
        });
        _eventProxy.on('end', function() {
            //结束前延迟一秒后跳出菜单
            _eventProxy.trigger('hideLoading');
            setTimeout(function() {
                overflag = true;
                onBackStage();
                _eventProxy.trigger('closeBGM', 'music');
                Modules.UI.setSttingTitle('结束');
                // Modules.UI.hide("SHARE_MODULE");
                Modules.UI.show('UI_CONTAINER');
                Modules.UI.show("SETTING_MODULE");
                Modules.UI.show("BUTTON_RESTART");
                Modules.UI.hide("BUTTONM");
                if (openFrom == 'box') {
                    Modules.UI.hide("BUTTONS_ABOUT");
                } else {
                    Modules.UI.hide("BUTTONS_BAK");
                }
                Cache.del(['record_scene', 'record_scenelist', 'r_variate', 'record_var', 'blockId']);
            }, 1000);
        });
        _eventProxy.on('buildUI', function(setting, callback) {
            // 加载精灵图
            // return Modules.Resource.load('image', 'sprite', setting.sprite, 'sprite', function(e) {
            $('head').append($(sprintf('<link href="%s" rel="stylesheet">', setting.css)));
            $('head').append($(sprintf('<style>.sprite{background-image:url(%s)}</style>', setting.sprite)));
            return Modules.UI.build(setting.ui, function() {
                if (typeof callback === 'function') callback();
            });
            // });
        });
        //设置选项事件
        _eventProxy.on('setBranch', function(scene, _branchList, callback) {
            Modules.UI.branch(scene, _branchList, callback);
            branch_status = true;
        });
        _eventProxy.on('clickBranch', function() {
            branch_status = false;
        });
        // _eventProxy.on('scriptNext', function() {
        //     !overflag && Modules.Dispatch.prepare(start);
        // });
        // _eventProxy.on('setOver', function() {
        //     overflag = true;
        // });
        //打开菜单事件
        _eventProxy.on('setting', function() {
            next_flag = false;
            Cache.setNext_flag(next_flag);
            Modules.UI.setSttingTitle('设置');
            Modules.UI.show('UI_CONTAINER');
            Modules.UI.show("SETTING_MODULE");
            Modules.UI.hide("BUTTON_RESTART");
            Modules.UI.show("BUTTONM");
            if (openFrom == 'box') {
                Modules.UI.hide("BUTTONS_ABOUT");
            } else {
                Modules.UI.hide("BUTTONS_BAK");
            }
            // showShareByDevice();
            //    _eventProxy.emitLater('stopTime');
        });
        //关闭菜单时，隐藏其他界面
        _eventProxy.on('hideSetting', function() {
            Modules.UI.hide('UI_CONTAINER');
            Modules.UI.hide("SETTING_MODULE");
            Modules.UI.hide("TRACE_MODULE");
            Modules.UI.hide("OVERVIEW_MODULE");
            if (!(navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i))) {
                $('.SHARE-QZONE').show();
                $('.SHARE-WEIBO').show();
                $('.SHARE-WEIXIN').find('.wechat').show();
            }
            next_flag = true;
            Cache.setNext_flag(next_flag);
            $('.QRCODE').hide();
        });
        //关闭菜单界面
        _eventProxy.on('settingModuleClose', function() {
            next_flag = true;
            Cache.setNext_flag(next_flag);
            if (!branch_status && !overflag && loading_flag) {
                var _scene = Cache.getCurrentScene();
                if (_scene) {
                    if (store.get('closePass')) {
                        var next = _scene.next;
                        if (_scene.skipScene && _scene.skipScene.sceneId) next = _scene.skipScene.sceneId;
                        //只判断跳转不运算
                        var numericalTo = Variate.calcByScene(_scene.sceneId, true);
                        next = numericalTo ? numericalTo : next;
                        _eventProxy.trigger('prepare', next);
                    }
                } else {
                    _eventProxy.trigger('prepare', 'init');
                }
            }
            _eventProxy.trigger('hideSetting');
        });
        _eventProxy.on('controlmusic', function() {
            Modules.UI.setMusic();
        });
        _eventProxy.on('aboutVortexfun', function() {
            if ((navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i))) {
                window.location.href = "http://www.vortexfun.com";
            } else {
                window.open("http://www.vortexfun.com");
            }
        });
        _eventProxy.on('controlstart', function() {
            parseMusic();
            var ua = navigator.userAgent.toLowerCase();
            var openFrom = request('type');
            Cache.delCurrentScene();
            if ('preview' == openFrom) return;
            // parseMusic();
            if (openFrom != 'box') {
                // alert("请点击返回按钮！");
                // window.close();
                if (typeof WeixinJSBridge != 'undefined') {
                    WeixinJSBridge.call('closeWindow');
                } else {
                    window.history.go(-1);
                }
            } else {
                if (/android/.test(ua)) {
                    window.android_h5.finished();
                } else {
                    loadURL("exit:");
                }
            }
        });
        //点击分享按钮
        _eventProxy.on('controlshare', function() {
            var openFrom = request('type');
            if (openFrom == 'preview') return false;
            var ua = navigator.userAgent.toLowerCase();
            var gameName = Stone.get('gameInit').gameName;
            document.title = gameName;
            var array_title = ["偷偷告诉你一个秘密，最近我在玩漩涡互娱的【" + gameName + "】根本停不下来！", "小伙伴们，想知道我最近在玩什么吗？推荐一款【" + gameName + "】的漩涡作品来和我一起寻宝吧！", "嗨艾瑞巴蒂，分享给你一款超级好玩的漩涡作品【" + gameName + "】一般人我才不告诉他！", "爱妃们，本王最近玩了一款【" + gameName + "】的漩涡作品，满满的剧情特效让本王欲罢不能啊！", "本宝宝最近在玩一款【" + gameName + "】的漩涡作品，同样爱玩游戏的你怎么能错过呢！", "糟糕被发现了，分享我的私藏作品【" + gameName + "】给你玩吧~", "嘿！分享给你的漩涡红包——【" + gameName + "】", "玩过这个【" + gameName + "】我已经不知道节操是什么了！"];
            if (openFrom != 'box') {
                if ((navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i))) {
                    $('.click_here').css('display', 'block');
                    $('.click_herebg').css('display', 'block');
                    $('.click_herebg,.click_here').on('click', function() {
                        $('.click_here').css('display', 'none');
                        $('.click_herebg').css('display', 'none');
                    });
                } else {
                    _eventProxy.trigger('hideSetting');
                    Modules.UI.hide("SETTING_MODULE");
                    Modules.UI.show('UI_CONTAINER');
                    Modules.UI.show("SHARE_MODULE");
                }
            } else {
                var test = array_title[Math.floor(Math.random() * array_title.length + 1) - 1];
                var url = window.location.href.split('&')[0];
                url = url + '&type=share';
                var path = "";
                if (typeof Stone.get('gameInit').convent != 'undefined' && typeof Stone.get('gameInit').convent.path != 'undefined') {
                    path = config.resourceHost + '/Api/Res/oneback?fs=' + Stone.get('gameInit').convent.path;
                }
                if (/android/.test(ua)) {
                    window.android_h5.sharePop(test, gameName, url, path);
                } else {
                    loadURL("share:[1]shareInfo=" + test);
                }
            }
        });
        // 剧情追溯 事件
        _eventProxy.on('PlotTrace', function() {
            _eventProxy.trigger('hideSetting');
            Modules.UI.show('UI_CONTAINER');
            Modules.UI.show("TRACE_MODULE");
        });
        // 剧情总览 事件
        var OVERVIEW_INDEX = 0;
        _eventProxy.on('PlotOverview', function() {
            _eventProxy.trigger('hideSetting');
            Modules.UI.show('UI_CONTAINER');
            Modules.UI.show("OVERVIEW_MODULE");
            // 渲染
            var keys = Cache.get('keys'),
                list = [],
                index = 0;
            _.each(keys, function(elem) {
                if (OVERVIEW_INDEX * 5 <= index && (index < OVERVIEW_INDEX * 5 + 5)) list.push(elem);
                index++;
            });
            store.set('overView', true);
            $('.OVERVIEW_TOLEFT,.OVERVIEW_TORIGHT').hide();
            if (!keys) return;
            Modules.UI.setPlotOverview(list, OVERVIEW_INDEX);
            if (OVERVIEW_INDEX === 0) {
                $('.OVERVIEW_TOLEFT').hide();
                if (keys.length < 5) {
                    $('.OVERVIEW_TORIGHT').hide();
                } else {
                    $('.OVERVIEW_TORIGHT').show();
                }
            } else if (OVERVIEW_INDEX + 1 < Math.ceil(keys.length / 5)) {
                $('.OVERVIEW_TORIGHT').show();
                $('.OVERVIEW_TOLEFT').show();
            } else {
                $('.OVERVIEW_TORIGHT').hide();
                $('.OVERVIEW_TOLEFT').show();
            }
        });
        _eventProxy.on('gotoOverview', function(_sceneId) {
            // 清屏
            Modules.UI.clearList();
            next_flag = true;
            Cache.setNext_flag(next_flag);
            var key = Cache.getKey(_sceneId);
            Variate.reset(key.variate);
            overflag = false;
            // _eventProxy.trigger('renderNextScene', key.id, true);
            _eventProxy.trigger('prepare', key.id, true);
            // Cache.setRecordVar(key.record_var);
            Modules.UI.hide('UI_CONTAINER');
            Modules.UI.hide("OVERVIEW_MODULE");
        });
        //设置Trace 追溯点
        var TRACE = [];
        _eventProxy.on('setPlotTrace', function(_list) {
            if (_.size(TRACE) > 5) TRACE.shift();
            TRACE.push(_list);
            Modules.UI.setPlotTrace(TRACE);
        });
        // // 设置Overview 总览点
        // var OVERVIEW = [],
        //     OVERVIEW_INDEX = 0;
        // _eventProxy.on('setPlotOverview', function(_list) {
        //     var addFlag = true;
        //     _.each(OVERVIEW, function(elem) {
        //         if (elem.id == _list.id) addFlag = false;
        //     });
        //     if (addFlag) OVERVIEW.push(_list);
        //     Modules.UI.setPlotOverview(OVERVIEW, OVERVIEW_INDEX);
        // });
        _eventProxy.on('overview_toLeft', function() {
            OVERVIEW_INDEX--;
            if (OVERVIEW_INDEX < 0) OVERVIEW_INDEX = 0;
            _eventProxy.trigger('PlotOverview');
        });
        _eventProxy.on('overview_toRight', function() {
            OVERVIEW_INDEX++;
            var keys = Cache.get('keys');
            if (OVERVIEW_INDEX > Math.ceil(keys.length / 5)) OVERVIEW_INDEX = Math.ceil(keys.length / 5);
            _eventProxy.trigger('PlotOverview');
        });
        // 追溯点 返回
        _eventProxy.on('traceReturn', function() {
            //    Modules.UI.hide('UI_CONTAINER')
            Modules.UI.show('SETTING_MODULE');
            Modules.UI.hide("TRACE_MODULE");
            // store.set('overView', false);
        });
        // 总览点 返回
        _eventProxy.on('overviewReturn', function() {
            //    Modules.UI.hide('UI_CONTAINER')
            Modules.UI.show('SETTING_MODULE');
            Modules.UI.hide("OVERVIEW_MODULE");
            store.set('overView', false);
        });
        //分享返回
        _eventProxy.on('shareReturn', function() {
            Modules.UI.show('SETTING_MODULE');
            Modules.UI.hide("SHARE_MODULE");
        });
        _eventProxy.on('SHARE_CLICK', function(elem) {
            var share = elem.getAttr('name');
            var gameName = Stone.get('gameInit').gameName;
            document.title = gameName;
            var array_title = ["偷偷告诉你一个秘密，最近我在玩漩涡互娱的【" + gameName + "】根本停不下来！", "小伙伴们，想知道我最近在玩什么吗？推荐一款【" + gameName + "】的漩涡作品来和我一起寻宝吧！", "嗨艾瑞巴蒂，分享给你一款超级好玩的漩涡作品【" + gameName + "】一般人我才不告诉他！", "爱妃们，本王最近玩了一款【" + gameName + "】的漩涡作品，满满的剧情特效让本王欲罢不能啊！", "本宝宝最近在玩一款【" + gameName + "】的漩涡作品，同样爱玩游戏的你怎么能错过呢！"];
            var test = array_title[Math.floor(Math.random() * array_title.length + 1) - 1];
            var type = request('type');
            // var test = "快来和我一起玩";
            var url = window.location.href;
            switch (share) {
                case 'qzone':
                    window.open("http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?" + "url=" + encodeURIComponent(url) + "&title=" + gameName + "&summary=" + test);
                    break;
                case 'sina':
                    var ua = navigator.userAgent.toLowerCase();
                    if (/iphone|ipad|ipod|iOS/.test(ua) && type == 'box') {
                        loadURL("share:[1]shareInfo=" + test);
                    } else if (/android/.test(ua) && type == 'box') {
                        // javascript: android.clickOnAndroid(gameName, test, url);
                        window.android_h5.sharePop(test, gameName, url, path);
                    } else {
                        window.open("http://service.weibo.com/share/share.php?" + "url=" + encodeURIComponent(url) + "&title=" + test);
                    }
                    break;
                case 'wechat':
                    // $('.SHARE-WEIXIN').find('.wechat').hide();
                    // $('.SHARE-QZONE').find('.qzone').hide();
                    // $('.SHARE-WEIBO').find('.sina').hide();
                    $('.SHARE-WEIXIN').find('.wechat').hide();
                    $('.SHARE-QZONE').hide();
                    $('.SHARE-WEIBO').hide();
                    $('.QRCODE').show();
                    $('.SHARE-WEIXIN').append("<div class=QRCODE></div>");
                    if (shareflag === false) return;
                    shareflag = false;
                    $('.QRCODE').qrcode({
                        render: "canvas", //table方式
                        width: 80, //宽度
                        height: 80, //高度
                        text: url //任意内容ssss
                    });
                    break;
            }
        });
        //加载音乐时不允许走下一页
        _eventProxy.on('loadingMusic', function() {
            loading_flag = false;
        });
        //音乐家在结束更改标记
        _eventProxy.on('loadingComplete', function() {
            loading_flag = true;
        });
        //显示加载音乐
        _eventProxy.on('showLoading', function() {
            Modules.UI.showLoading();
        });
        //隐藏加载音乐
        _eventProxy.on('hideLoading', function() {
            Modules.UI.hideLoading();
        });
        _eventProxy.on('loadImg', function(url, callback) {
            var img = new Image();
            img.onload = function() {
                img.onload = null;
                callback();
            };
            img.src = url;
            // console.log(url);
        });
    };
    module.exports.getProxy = function() {
        return _eventProxy;
    };
    module.exports.next_flag = next_flag;

    function exitPlayer() {
        var ua = navigator.userAgent.toLowerCase();
        parseMusic();
        if (/android/.test(ua)) {
            window.android_h5.finished();
        } else {
            loadURL("exit:");
        }
    }
    window.exitPlayer = exitPlayer;
});