 // 对话框模块
 define(function(require, exports, module) {

 	module.exports.Button = function(text, options) {
 		options = _.isUndefined(options) ? {} : options;
 		var setting = _.extend({
 			origin: {
 				background: '#369dde',
 				color: "#ffffff",
 				fontSize: 18,
 				border: "0",
 				padding: [10, 25],
 				borderColor: "",
 				borderRadius: 5
 			},
 			hover: {
 				background: '#0F80C8',
 				color: '#ffffff'
 			},
 			active: {
 				background: "#3283bc",
 				color: '#ffffff'
 			}
 		}, options);

 		var buttonText = new Konva.Text({
 			text: text,
 			fontSize: setting.origin.fontSize,
 			fill: setting.origin.color,
 			align: 'center'
 		});

 		var rect = new Konva.Rect({
 			x: 0,
 			y: 0,
 			stroke: setting.origin.borderColor,
 			strokeWidth: setting.origin.border,
 			fill: setting.origin.background,
 			width: buttonText.getWidth() + setting.origin.padding[1] * 2,
 			height: buttonText.getHeight() + setting.origin.padding[0] * 2,
 			cornerRadius: setting.origin.borderRadius
 		});

 		buttonText.setAttrs({
 			x: setting.origin.padding[1],
 			y: setting.origin.padding[0]
 		})
 		var buttonGroup = new Konva.Group({
 			x: 0,
 			y: 0
 		});

 		buttonGroup.add(rect);
 		buttonGroup.add(buttonText);

 		buttonGroup.setAttrs({
 			width: rect.width(),
 			height: rect.height()
 		})

 		// 悬浮
 		buttonGroup.off('mouseover').on('mouseover', function() {
 			rect.setAttrs({
 				fill: setting.hover.background,
 				color: setting.hover.color
 			});
 			buttonGroup.draw();
 		});
 		// 离开
 		buttonGroup.off('mouseleave touchend').on('mouseleave touchend', function() {
 			rect.setAttrs({
 				fill: setting.origin.background,
 				color: setting.origin.color
 			});
 			buttonGroup.draw();
 		});
 		// 按击
 		buttonGroup.off('mousedown touchstart').on('mousedown touchstart', function() {
 			rect.setAttrs({
 				fill: setting.active.background,
 				color: setting.active.color
 			});
 			buttonGroup.draw();
 		});

 		return buttonGroup;

 	}

 });