// 图片模块
define(function(require, exports, module) {

    var _KONVA_IMAGES = {};

    var resourceModule = require('../Resource');


    // 获取/创建一个Konva图片对象
    module.exports.Image = function(_imageId, _imageObj, options) {
        if (arguments.length == 2) {
            options = _.extend({}, _imageObj);
            _imageObj = resourceModule.get(_imageId);
        }
        
        _KONVA_IMAGES[_imageId] = new Konva.Image(_.extend({}, {
            id: _imageId,
            image: _imageObj
        }, options));
        var _imageObj = _KONVA_IMAGES[_imageId];
        var _imageGet = _imageObj.getImage();

        if (!_.isUndefined(options.width)) {
            _imageObj.width(options.width);
            if (_.isUndefined(options.height)) {
                _imageObj.height(options.width * _imageGet.height / _imageGet.width);
            }
        }

        return _KONVA_IMAGES[_imageId];
    }

    // 获取Konva图像的源图片对象
    module.exports.getImage = function(_imageId) {
        if (_.isUndefined(_KONVA_IMAGES[_imageId]))
            return false;
        return _KONVA_IMAGES[_imageId].getImage();
    }

    // 根据现高计算出等比例下的现宽
    module.exports.calcWidth = function(_imageId, _height) {
        if (_.isUndefined(_KONVA_IMAGES[_imageId]))
            return false;
        _height = _height + 0;
        var _imageObj = _KONVA_IMAGES[_imageId],
            _imageGet = _imageObj.getImage();
        return _height * _imageObj.width / _imageGet.height;
    }

    // 根据现宽计算出等比例下的现高
    module.exports.calcHeight = function(_imageId, _width) {
        if (_.isUndefined(_KONVA_IMAGES[_imageId]))
            return false;
        _width = _width + 0;
        var _imageObj = _KONVA_IMAGES[_imageId],
            _imageGet = _imageObj.getImage();
        return _width * _imageGet.height / _imageGet.width;
    }

})