// 模态框模块
define(function(require, exports, module) {

	var buttonModule = require('Button');

	var uiLayer = {};

	module.exports.init = function(_uiLayer) {
		uiLayer = _uiLayer;
	}

	module.exports.newModal = function(_id, _title, options) {
		options = _.extend({
			width: 200,
			height: 50,
			x: 0,
			y: 0
		}, options);

		var group = new Konva.Group(),
			mainGroup = new Konva.Group({
				draggable: true,
				x: options.x,
				y: options.y
			}),
			titleGroup = new Konva.Group(),
			contentGroup = new Konva.Group(),
			titleBack = new Konva.Rect({
				fill: '#dadada',
				width: options.width,
				height: options.height * 1 / 5
			}),
			contentBack = new Konva.Rect({
				fill: '#ffffff',
				width: options.width,
				height: options.height * 4 / 5
			});

		titleGroup.add(titleBack);
		contentGroup.add(contentBack);
		titleGroup.height(titleBack.height());
		contentGroup.height(contentBack.height());
		contentGroup.y(titleGroup.height());

		var titleText = new Konva.Text({
			align: 'center',
			width: options.width,
			fontSize: 17,
			text: _title
		});

		titleGroup.add(titleText);

		titleText.y((titleGroup.height() - titleText.getTextHeight()) / 2)

		contentGroup.add(new Konva.Text({
			text: '这是一个测试模态框...',
			fontSize: 17,
			padding: 20
		}));

		var btnClose = buttonModule.Button('关闭');
		contentGroup.add(btnClose);
		btnClose.x((options.width - btnClose.width()) / 2);
		btnClose.y(contentGroup.height() - btnClose.height() - 20);
		btnClose.on('click tap', function() {
			group.destroy();
			uiLayer.draw();
		})

		mainGroup.add(titleGroup);
		mainGroup.add(contentGroup);

		// 增加一个遮罩
		group.add(new Konva.Rect({
			width: uiLayer.width(),
			height: uiLayer.height(),
			fill: 'black',
			opacity: .7
		}));
		group.add(mainGroup);

		return group;
	}

});