// 音频模块
define(function(require, exports, module) {

    var resources = require('Resource');
    var soundList = {},
        musicNow = {},
        tempMusic = {},
        _eventProxy = {};

    var openFrom = request('type');
    var ua = navigator.userAgent.toLowerCase();

    var setMusicNow = function(_musicId, _music) {
        musicNow.id = _musicId;
        musicNow.sound = _music;
    }

    var isMusicAllowPlay = true;

    var playHandle = function(_soundId) {
        // 获取资源信息
        var resource = soundList[_soundId];
        if (_.isUndefined(resource)) return false;
        if (_.isUndefined(resource.sound)) {
            resource.sound = createjs.Sound.play(_soundId, {
                volume: 1
            });
            resource.sound.stop();
        }
        // console.log(soundList);
        // 背景音乐处理
        if (resource.type == 'music' && musicNow.id != _soundId) {
            musicNow.sound && musicNow.sound.stop();
            setMusicNow(_soundId, resource.sound);
            musicNow.sound.loop = -1;
            // var _switch = store.get('music');
            // if(!_switch || _switch == 'off')
            if (isMusicAllowPlay) {
                // musicNow.sound.paused = false;
                musicNow.sound.play();
                musicNow.sound.volume = 1;
            }
        } else if(musicNow.id == _soundId){
            // musicNow.sound.paused = false;
            if(isMusicAllowPlay){
                musicNow.sound.play();
            }
        }
        // 其他音频处理
        
        if (isMusicAllowPlay && _.includes(['voice', 'sound'], resource.type)) {
            if(tempMusic[resource.type]){
                tempMusic[resource.type].sound.stop();
            }
            tempMusic[resource.type] = resource;
            tempMusic[resource.type].sound.play();
            tempMusic[resource.type].sound.volume = 1;
            // resource.sound.play();
            // resource.sound.volume = 1;
        }
    }

    var stopBGM = function(type, soundId){

    }

    var stopTempMusic = function(type){
        if(tempMusic[type]){
            tempMusic[type].sound.stop();
            delete tempMusic[type];
        }
        // tempMusic[resource].sound.stop();
        // delete tempMusic[resource];
    }

    // 事件处理对象
    module.exports.eventProxy = function(_ep) {
        _eventProxy = _ep;
        // 资源装载
        _eventProxy.on('SOUND_PUSH', function(_soundId, _soundType) {
            return soundList[_soundId] = {
                type: _soundType
            }
        });

        // 播放事件
        _eventProxy.on('SOUND_PLAY', function(_soundId) {
            var _switch = store.get('music');
            return playHandle(_soundId);
            // return (!_switch || _switch == 'off') && playHandle(_soundId);
        });
        _eventProxy.on('closeTempMusic', function(type){
            stopTempMusic(type);
        });

        //音乐开关事件
        _eventProxy.on('SETTING_MUSIC', function(elem) {
            if (_.isUndefined(elem)) elem = 'off';
            isMusicAllowPlay = elem == 'on';
            if (isMusicAllowPlay) {
                if(/iphone|ipad|ipod|iOS/.test(ua) && openFrom == 'box'){
                    _eventProxy.trigger('turnOnMusicInBox');
                } else {
                    if (_.size(musicNow) && musicNow.sound) {
                        musicNow.sound.play();
                        musicNow.sound.volume = 1;
                    } else {
                        return;
                    }
                }
            } else {
                if(/iphone|ipad|ipod|iOS/.test(ua) && openFrom == 'box'){
                    _eventProxy.trigger('turnOffMusicInBox');
                } else {
                    _.each(soundList, function(elem) {
                        if(elem.sound)
                            elem.sound.paused = true;
                    })
                }
            }
        });
        
        //只关闭背景音乐
        _eventProxy.on('SOUND_BACKGROUND', function(soundId){
            if(!musicNow || !musicNow.sound) return;
            if (!soundId) return;
            if (soundId == 'music'){
                // musicNow.sound.paused = true;
                musicNow.sound.stop();
                delete musicNow.sound;
                delete musicNow.id;
            }
            // if (soundId === musicNow.id) musicNow.sound.paused = true;
        });
    }

    var continueMusic = function() {
        _eventProxy.trigger('SETTING_MUSIC', 'on');
    }
    var pause = function() {
        store.remove('music');
        if(!(/iphone|ipad|ipod|iOS/.test(ua) && openFrom == 'box')){
            _eventProxy.trigger('SETTING_MUSIC', 'off');
            soundList = {};
            musicNow = {};
            createjs.Sound.removeAllSounds();
        }
        // _eventProxy.trigger('SETTING_MUSIC', 'off');
        // soundList = {};
        // musicNow = {};
        // createjs.Sound.removeAllSounds();
    }
    function notifyPlayer(){
        if (isMusicAllowPlay && store.get('music')) {
            if (_.size(musicNow) && musicNow.sound) {
                musicNow.sound.play();
                musicNow.sound.volume = 1;
            } else {
                return;
            }
        }
    }

    function onBackStage(){
        _.each(soundList, function(elem) {
            if(elem.sound)
                elem.sound.stop();
        });
    }


    window.notifyPlayer = notifyPlayer;
    window.onBackStage = onBackStage;
    window.pauseMusic = pause;
    window.continueMusic = continueMusic;

});