/* 数值 Variate */
define(function(require, exports, module) {
    var Cache = require('Cache');

    var VARIATE = {},
        VARIATE_BEFORE = {},
        ITEMS = {},
        items_show = [],
        itemGroup = [],
        SCENES = {};
    // var Items = require("items");

    //判断物品是否存在
    isItemInList = function(numericalId) {
        for (var i in items_show) {
            if (items_show[i].numericalId == numericalId) {
                return true;
            }
        }
        return false;
    }
    //更改物品数组中相应的值
    setItemValue = function(numericalId, value) {
        for (var i in items_show) {
            if (items_show[i].numericalId == numericalId) {
                items_show[i].value = value;
            }
        }
    }
    //删除某个物品
    deleteItem = function(numericalId) {
        for (var i in items_show) {
            if (items_show[i].numericalId == numericalId) {
                items_show.splice(i, 1);
            }
        }
    }

    var getNumberIdByNumberName = function(numberName) {
        var result = false;
        _.each(Cache.getNumericalList(), function(elem, key) {
            if (elem.n_name == numberName) {
                result = key;
            };
        })
        return result;
    }
    //获取所有的已有物品
    module.exports.getItemGroup = function() {
        return itemGroup;
    }

    //获取物品列表
    module.exports.getItemList = function() {
        return items_show;
    }

    module.exports.getVariate = function() {
        return VARIATE;
    }

    module.exports.getVariate_before = function() {
        return VARIATE_BEFORE;
    }

    //把所有物品分组
    module.exports.divideItems_show = function() {
        itemGroupIndex = 0;
        if (items_show.length >= 1) {
            for (var i = 0; i < items_show.length; i++) {
                if (i % 15 == 0) {
                    itemGroup[i / 15] = [];
                }
                itemGroup[Math.floor(i / 15)].push(items_show[i]);
            }
        } else {
            itemGroup[0] = [];
        }
        // if(itemGroup.length>1){
        //     event.showGroup(['ITEM_BEHIND']);
        // }else{
        //     event.hideGroup(['ITEM_BEHIND']);
        // }
    }



    module.exports.init = function(numberList, numberJump, numberCal, itemList) {
        // 数值初始化
        // _.each(numList, function(elem, key) {
        //     VARIATE[key] = 0; // 默认数值为 0
        // });

        _.each(numberList, function(elem, key) {
            VARIATE[key] = elem.inital_value * 1;
        })
        // Cache.setNumerList(VARIATE);
        // 初始化场景页绑定的数值触发
        // _.each(sceneBind, function(elem, key) {
        //     if (_.isUndefined(SCENES[key])) SCENES[key] = {};
        //     if (_.isUndefined(SCENES[key].bind)) SCENES[key].bind = {};
        //     _.each(elem, function(_elem, _key) {
        //         SCENES[key].bind[_key] = _elem;
        //     });
        // });

        _.each(numberJump, function(elem, key) {
            if (_.isUndefined(SCENES[key])) SCENES[key] = {};
            if (_.isUndefined(SCENES[key].bind)) SCENES[key].bind = {};
            _.each(elem, function(_elem, _key) {
                SCENES[key].bind[_key] = _elem;
            });
        })
        // 初始化场景页绑定的数值计算
        _.each(numberCal, function(elem, key) {
            if (_.isUndefined(SCENES[key])) SCENES[key] = {};
            if (_.isUndefined(SCENES[key].calc)) SCENES[key].calc = {};
            _.each(elem, function(_elem, _key) {
                SCENES[key].calc[_key] = _elem;
            });
        });
        ITEMS = itemList;
    };

    function judgeCondition(condition) {
        var result = false;
        //条件判断
        var n_id = condition.n_id;
        var value = VARIATE[n_id];
        var valueType = condition.valueType;
        var operation = condition.operation;
        var compareValue;
        switch (valueType * 1) {
            case 1:
                //固定数字
                compareValue = condition.value * 1;
                break;
            case 2:
                //数值
                compareValue = VARIATE[condition.compare_n_id];
                break;
        }
        switch (operation * 1) {
            //跳转条件
            case 1:
                //1-等于
                result = value == compareValue * 1;
                break;
            case 2:
                //2-小于 
                result = value < compareValue * 1;
                break;
            case 3:
                //3-大于 
                result = value > compareValue * 1;
                break;
            case 4:
                //4-大于等于 
                result = value >= compareValue * 1;
                break;
            case 5:
                //5-小于等于
                result = value <= compareValue * 1;
                break;

        }
        return result;
    }

    module.exports.calcByScene = function(sceneId, isSkipVariate) {
        if (!SCENES[sceneId]) return;
        // 存在数值运算，并且不是读档过来的，执行
        if (SCENES[sceneId].calc && !isSkipVariate) {
            var calNumIds = [];
            _.each(SCENES[sceneId].calc, function(elem, key) {
                var numId = elem.numId;
                key = numId;
                var valueType = elem.valueType;
                var calculate_nid1 = elem.calculate_nid1;
                var calValue = 0;
                switch (valueType * 1) {
                    case 1:
                        //固定数字计算
                        calValue = elem.value * 1;
                        break;
                    case 2:
                        //随机数计算
                        var min_value = elem.min_value * 1,  
                            max_value = elem.max_value * 1;
                        calValue = _.random(min_value, max_value);
                        calValue = Math.round(calValue);
                        break;
                    case 3:
                        //其他数值计算
                        var calculate_nid2 = elem.calculate_nid2;
                        if (typeof calculate_nid2 != 'undefined') {
                            calValue = _.cloneDeep(VARIATE[calculate_nid2]);
                        }
                        break;
                }
                //记录老的数值
                if (_.indexOf(calNumIds, key) == -1) {
                    //同一剧情页多次操作数值，只记录第一个前一个数值
                    VARIATE_BEFORE[key] = VARIATE[key];
                    calNumIds.push(key);
                };
                if (elem.operation * 1 === 1) {
                    VARIATE[key] = VARIATE[calculate_nid1] + calValue;
                } else if (elem.operation * 1 === 2) {
                    VARIATE[key] = VARIATE[calculate_nid1] - calValue;
                } else if (elem.operation * 1 === 3) {
                    VARIATE[key] = calValue; //兼容老数据
                } else if (elem.operation * 1 === 4) {
                    VARIATE[key] = VARIATE[calculate_nid1] * calValue;
                } else if (elem.operation * 1 === 5) {
                    if (calValue != 0) {
                        VARIATE[key] = Math.ceil(VARIATE[calculate_nid1] / calValue);
                    } else {
                        VARIATE[key] = VARIATE[calculate_nid1];
                    }
                }

                // if (ITEMS[key]) {
                //     if (!isItemInList(key) && VARIATE[key] > 0) {
                //         items_show.push({
                //             numericalId: key,
                //             name: ITEMS[key].name,
                //             value: VARIATE[key],
                //             iconSrc: ITEMS[key].iconSource
                //         });
                //     } else if (VARIATE[key] <= 0) {
                //         deleteItem(key);
                //     } else {
                //         setItemValue(key, VARIATE[key]);
                //     }
                // }
            });
        }

        var jumpTo = false,
            elseJumpTo = false;
        _.each(SCENES[sceneId].bind, function(elem, key) {
            var compare_type = elem.compare_type; //1-满足全部 2-满足任意一项 3-组内条件都不满足 4-绑定剧情页内条件都不满足
            var jump_sceneId = elem.jump_sceneId;
            switch (compare_type*1) {
                case 1:
                    //1-满足全部
                    var resultFlag = true;
                    _.each(elem, function(_elem, _key) {
                        if (typeof _elem == 'object') {
                            var condition = _elem,
                                conditionResult = false;
                            conditionResult = judgeCondition(condition);
                            resultFlag = resultFlag && conditionResult;
                        }
                    });
                    if (resultFlag) {
                        jumpTo = jump_sceneId;
                        return false; //跳出整个循环
                    };
                    break;
                case 2:
                    //2-满足任意一项
                    var resultFlag = false;
                    _.each(elem, function(_elem, _key) {
                        if (typeof _elem == 'object') {
                            var condition = _elem,
                                conditionResult = false;
                            conditionResult = judgeCondition(condition);
                            resultFlag = resultFlag || conditionResult;
                        }
                    });
                    if (resultFlag) {
                        jumpTo = jump_sceneId;
                        return false; //跳出整个循环
                    };
                    break;
                case 3:
                    //3-组内条件都不满足
                    var resultFlag = false;
                    _.each(elem, function(_elem, _key) {
                        if (typeof _elem == 'object') {
                            var condition = _elem,
                                conditionResult = false;
                            conditionResult = judgeCondition(condition);
                            resultFlag = resultFlag || conditionResult;
                        }
                    });
                    if (!resultFlag) {
                        jumpTo = jump_sceneId;
                        return false; //跳出整个循环
                    };
                    break;
                case 4:
                    jumpTo = jump_sceneId;
                    break;
            }

        });

        return jumpTo;
    };

    // 根据剧情ID获取剧情数值跳转的去向列表
    module.exports.jumpToWhere = function(sceneId) {
        if (!SCENES[sceneId]) return [];
        var jumpTo = [];
        if (SCENES[sceneId].bind) {
            _.each(SCENES[sceneId].bind, function(elem, key) {
                _.each(elem.jumpTo, function(_jump) {
                    jumpTo.push({
                        jumpTo: _jump
                    });
                });
            });
        }

        return jumpTo;
    };

    // 重置前一个数值
    module.exports.reset_before = function(_reset) {
        if (_reset) {
            VARIATE_BEFORE = _.cloneDeep(_reset);
        }
    };

    // 重置数值
    module.exports.reset = function(_reset) {
        if (_reset) {
            VARIATE = _.cloneDeep(_reset);
        } else {
            _.each(VARIATE, function(elem, key) {
                VARIATE[key] = Cache.getNumericalList()[key]['inital_value'] * 1;
            });
        }
    };

    //初始化背包里的物品
    module.exports.initItemList = function(_reset) {
        if (_.isUndefined(_reset)) _reset = [];
        items_show = _.cloneDeep(_reset);
    };
    // 前一个数值快照
    module.exports.snapshot_before = function() {
        return _.cloneDeep(VARIATE_BEFORE);
    };
    // 当前数值快照
    module.exports.snapshot = function() {
        return _.cloneDeep(VARIATE);
    };
    //显示数值
    module.exports.showVariate = function(text) {
        var result = _.cloneDeep(text);
        var pattern = new RegExp("\\[(.| )+?\\]", "igm");
        var arr = result.match(pattern);
        if (arr != null) {
            _.each(arr, function(elem, key) {
                var oldStr = elem;
                var temp = oldStr.substring(1, oldStr.length - 1);
                /*var order = temp.substring(0, 1).toLowerCase();
                var numberName = temp.substring(1, temp.length);*/
                var order = temp.split(':')[0].toLowerCase();
                var numberName = temp.split(':')[1];
                var numberId = getNumberIdByNumberName(numberName);
                if (!numberId) return;
                var numberValue = VARIATE[numberId];
                switch (order) {
                    case 'v':
                        //显示当前剧情页的该数值的总值
                        result = result.replace(oldStr, numberValue);
                        break;
                    case 'c':
                        if (typeof VARIATE_BEFORE[numberId] == 'undefined') {
                            VARIATE_BEFORE[numberId] = 0;
                        }
                        if (typeof VARIATE[numberId] == 'undefined') {
                            VARIATE[numberId] = 0;
                        }
                        var change = VARIATE[numberId] - VARIATE_BEFORE[numberId];
                        if (change > 0) {
                            change = "+" + change;
                        }
                        result = result.replace(oldStr, change);
                        break;
                }
            })
        } else {
            result = text;
        }
        return result;
    }

});