define(function(require, exports, module) {
    var resourceModule = require('player/Resource'),
        uiModule = require('player/UI_css'),
        dispatchModule = require('player/Dispatch'),
        soundModule = require('player/Sound'),
        netModule = require('player/Net'),
        musicInBox = require('player/MusicInBox');
        eventModule = require('player/Events');

    _.each({
        UI: uiModule,
        Dispatch: dispatchModule,
        Resource: resourceModule,
        BoxMusic: musicInBox,
        Sound: soundModule
    }, function(elem, key) {
        eventModule.setModule(key, elem);
    });

    var usualSet = {
        'splash': './plainText/assets/splash.jpg',
        'ui': './plainText/assets/UI_css.json',
        'script': './plainText/assets/script.json',
        'sprite': './plainText/assets/sprite_css.png',
        'audio': './plainText/assets/audio/RoomOfAngel.mp3'
    };
    eventModule.bindBase();
    var _eventProxy = eventModule.getProxy();
    module.exports.init = function(containerName) {
        var gameid = request('gameid'),
            scriptId = request('id'),
            sceneId = request('solaid');
        if (typeof sceneId !== 'undefined' && sceneId !== 'all' && sceneId !== null) {
            Stone.set('solaid', sceneId);
        } else {
            Stone.set('solaid', 'all');
        }
        if(typeof sceneId != 'undefined' && gameid != null){
            
        }
        return Thenjs(function(cont) {
            Stone.set('device', request('device'));
            Stone.set('device', $(window).width() > $(window).height() ? 'PC' : '');
            if (Stone.get('device') == 'PC') {
                $('.left_down').show();
                $('.right_down').show();
            }
            // 初始化舞台
            // 将舞台数据载入到UI模块
            uiModule.init(containerName);
            // 加载闪屏
            uiModule.splash(usualSet.splash, function() {
                uiModule.showStage();
            });
            cont();
        }).then(function(cont) {
            // 加载精灵图
            // resourceModule.load('image', 'sprite', usualSet.sprite, 'sprite', function(e) {
                var style = sprintf('<style>.sprite{background-image:url(%s)}</style>', usualSet.sprite);
                $('head').append($(style));
                cont();
            // });

            // }).then(function(cont) {
            // return uiModule.build(usualSet.ui, function() {
            //     cont();
            // });
        }).then(function(cont) {
            (store.get('gameid') != gameid && store.get('scriptId') != scriptId) && store.clear();
            store.set('gameid', gameid);
            store.set('scriptId', scriptId);
            dispatchModule.load(gameid, function() {

                cont();
            });
        }).then(function(cont) {
            if (request('id') == "" && request('type') != "preview") {
                return netModule.getGameInit(gameid, function(data) {
                    // var noSleep = new NoSleep();
                    // noSleep.enable();
                    Stone.set('gameInit', data);
                    cont();
                });
            } else {
                cont();
            }

        }).then(function(cont) {
            var gameName = Stone.get('gameInit').gameName;
            document.title = gameName + '_漩涡互娱';

            var ua = navigator.userAgent;
            var ipad = ua.match(/(iPad).*OS\s([\d_]+)/),
                isIphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/),
                isAndroid = ua.match(/(Android)\s+([\d.]+)/),
                isMobile = isIphone || isAndroid;

            if (isMobile && ua.match(/MicroMessenger/i) == 'MicroMessenger') {
                // hack在微信等webview中无法修改document.title的情况
                var $body = $('body');
                var $iframe = $('<iframe src="./static/css/favicon.ico"></iframe>');
                $iframe.on('load', function() {
                    setTimeout(function() {
                        $iframe.off('load').remove();
                    }, 0);
                }).appendTo($body);
            }

            var uniqueFlag = store.get('uniqueFlag');
            if (uniqueFlag == null) {
                uniqueFlag = new Date().getTime();
                store.set('uniqueFlag', uniqueFlag);
            };

            $.ajax({
                type: 'post',
                url: 'http://box.vortexfun.com/Mobile/Goods/shareGoods',
                data: {
                    goods_id: store.get('gameid'),
                    type: 1,
                    way: request('way'),
                    uniqueFlag: uniqueFlag
                },
                success: function() {

                }
            });
        });
    };
});