;
(function() { 
    // 去除字符串中script标签
    String.prototype.stripHTML = function() {
        var reTag = /<(?:.|\s)*?>/g;
        return this.replace(reTag, "");
    }
}).call(this);
(function() {
    // 获取DOM元素的宽高属性，包括隐藏的DOM
    function getType(o) {
        var _t;
        return ((_t = typeof(o)) == "object" ? o == null && "null" || Object.prototype.toString.call(o).slice(8, -1) : _t).toLowerCase();
    }
    //获取元素样式
    function getStyle(el, styleName) {
        return el.style[styleName] ? el.style[styleName] : el.currentStyle ? el.currentStyle[styleName] : window.getComputedStyle(el, null)[styleName];
    }

    function getStyleNum(el, styleName) {
        return parseInt(getStyle(el, styleName).replace(/px|pt|em/ig, ''));
    }

    function setStyle(el, obj) {
        if (getType(obj) == "object") {
            for (s in obj) {
                var cssArrt = s.split("-");
                for (var i = 1; i < cssArrt.length; i++) {
                    cssArrt[i] = cssArrt[i].replace(cssArrt[i].charAt(0), cssArrt[i].charAt(0).toUpperCase());
                }
                var cssArrtnew = cssArrt.join("");
                el.style[cssArrtnew] = obj[s];
            }
        } else
        if (getType(obj) == "string") {
            el.style.cssText = obj;
        }
    }

    function getSize(el) {
        if (getStyle(el, "display") != "none") {
            return {
                width: el.offsetWidth || getStyleNum(el, "width"),
                height: el.offsetHeight || getStyleNum(el, "height")
            };
        }
        var _addCss = {
            display: "",
            position: "absolute",
            visibility: 'hidden'
        };
        var _oldCss = {};
        for (i in _addCss) {
            _oldCss[i] = getStyle(el, i);
        }
        setStyle(el, _addCss);
        var _width = el.clientWidth || getStyleNum(el, "width");
        var _height = el.clientHeight || getStyleNum(el, "height");
        for (i in _oldCss) {
            setStyle(el, _oldCss);
        }
        return {
            width: _width,
            height: _height
        };
    }
    window.getSize = getSize
}).call(this);;
(function() {
    "use strict";
    // imgReady 异步获取图片的宽高属性
    var list = [],
        intervalId = null,
        tick = function() {
            var i = 0;
            for (; i < list.length; i++) {
                list[i].end ? list.splice(i--, 1) : list[i]();
            };
            !list.length && stop();
        },
        stop = function() {
            clearInterval(intervalId);
            intervalId = null;
        };
    var imgReady = function(url, ready, load, error) {
        var onready, width, height, newWidth, newHeight,
            img = new Image();

        img.src = url;
        if (img.complete) {
            ready.call(img);
            load && load.call(img);
            return;
        };
        width = img.width;
        height = img.height;
        img.onerror = function() {
            error && error.call(img);
            onready.end = true;
            img = img.onload = img.onerror = null;
        };
        onready = function() {
            newWidth = img.width;
            newHeight = img.height;
            if (newWidth !== width || newHeight !== height ||
                newWidth * newHeight > 1024
            ) {
                ready.call(img);
                onready.end = true;
            };
        };
        onready();
        img.onload = function() {
            !onready.end && onready();
            load && load.call(img);
            img = img.onload = img.onerror = null;
        };

        if (!onready.end) {
            list.push(onready);
            if (intervalId === null) intervalId = setInterval(tick, 40);
        };
    };

    if (typeof module !== 'undefined' && typeof module.exports !== 'undefined') {
        module.exports = imgReady;
    } else {
        if (typeof define === "function" && define.amd) {
            define([], function() {
                return imgReady;
            });
        } else {
            window.imgReady = imgReady;
        }
    }
}).call(this);